GUI "RMCHARTDEMO"

$INCLUDE "rmchartbcx.inc"
$INCLUDE "bcxmini.inc"

SUB FORMLOAD
   GLOBAL nH AS INTEGER
   GLOBAL nW AS INTEGER
   nW = 400 : nH = 300

   GLOBAL Form1 AS HWND
   Form1 = BCX_FORM( "BCX RMChart Demo",10,10,nW,nH)

   CENTER(Form1)
   SHOW(Form1)
END SUB


FUNCTION AddMenu(hwndOwner AS HWND) AS BOOL
   CONST ID_MENU1      = 9001
   CONST ID_SBARS      = 9002
   CONST ID_GBARS      = 9003
   CONST ID_STBARS     = 9004
   CONST ID_FBARS      = 9008
   CONST ID_CBARS      = 9005
   CONST ID_LINE       = 9006
   CONST ID_BLINE      = 9007
   CONST ID_PIE        = 9011
   CONST ID_DONUT      = 9012
   CONST ID_XYSIMPLE   = 9021
   CONST ID_XYCOMPLEX  = 9022
   CONST ID_FROMFILE   = 9031
   CONST ID_FROMSTRING = 9032
   CONST ID_SAVECHART  = 9033
   CONST ID_DATAFROMFILE=9034


   GLOBAL MainMenu AS HMENU
   GLOBAL GridbasedMenu AS HMENU
   GLOBAL NoneGridbasedMenu AS HMENU
   GLOBAL XYMenu AS HMENU
   GLOBAL MiscMenu AS HMENU

   MainMenu = CreateMenu()

   GridbasedMenu = CreateMenu()
   InsertMenu(MainMenu,  0, MF_POPUP, GridbasedMenu, "&Grid based")
   AppendMenu(GridbasedMenu, MF_STRING, ID_SBARS, "Single bars")
   AppendMenu(GridbasedMenu, MF_STRING, ID_GBARS, "Grouped bars")
   AppendMenu(GridbasedMenu, MF_STRING, ID_STBARS, "Stacked bars")
   AppendMenu(GridbasedMenu, MF_STRING, ID_FBARS, "Floating bars")
   AppendMenu(GridbasedMenu, MF_STRING, ID_CBARS, "Bars with diff. colors and BgImage")
   AppendMenu(GridbasedMenu, MF_SEPARATOR, 0, "")
   AppendMenu(GridbasedMenu, MF_STRING, ID_LINE, "Line with a trend line")
   AppendMenu(GridbasedMenu, MF_STRING, ID_BLINE, "Bars and line")
   AppendMenu(GridbasedMenu, MF_SEPARATOR, 0, "")
   AppendMenu(GridbasedMenu, MF_STRING, ID_DATAFROMFILE, "Read the data from file")

   NoneGridbasedMenu = CreateMenu()
   InsertMenu(MainMenu,  1, MF_POPUP, NoneGridbasedMenu, "&None grid-based")
   AppendMenu(NoneGridbasedMenu, MF_STRING, ID_PIE, "Pie")
   AppendMenu(NoneGridbasedMenu, MF_STRING, ID_DONUT, "Donut")

   XYMenu = CreateMenu()
   InsertMenu(MainMenu,  1, MF_POPUP, XYMenu, "&XY series")
   AppendMenu(XYMenu, MF_STRING, ID_XYSIMPLE, "Simple")
   AppendMenu(XYMenu, MF_STRING, ID_XYCOMPLEX, "XY with 2 series")

   MiscMenu = CreateMenu()
   InsertMenu(MainMenu, 1, MF_POPUP, MiscMenu      , "&Miscellaneous")
   AppendMenu(MiscMenu, MF_STRING   , ID_MSC1      ,"Scroll chart")
   AppendMenu(MiscMenu, MF_STRING   , ID_FROMFILE  ,"Read chart from file")
   AppendMenu(MiscMenu, MF_STRING   , ID_FROMSTRING,"Create chart from data string")
   AppendMenu(MiscMenu, MF_STRING   , ID_SAVECHART ,"Save chart without painting")
   AppendMenu(MiscMenu, MF_SEPARATOR, 0            ,"")
   AppendMenu(MiscMenu, MF_STRING   , ID_MSC6      ,"MiniDesigner")

   IF NOT SetMenu(hwndOwner, MainMenu) THEN
      FUNCTION = FALSE
   END IF
   FUNCTION = TRUE
END FUNCTION

SUB ExportTheChart(hDlg AS HWND, nCtrlID AS LONG)
   LOCAL sFilter AS STRING
   LOCAL sFileName AS STRING

   sFilter$ = "Graphic Files (*.jpg *.png)|*.png;*.jpg;*.jpeg|ALL Files (*.*)|*.*"
   sFileName$=GETFILENAME$("EXPORT Chart",sFilter$,1,hDlg)
   IF *sFileName$ THEN
      IF NOT INCHR(sFileName$,".") THEN CONCAT(sFileName$,".png")
      RMC_Draw2File (nCtrlID, sFileName$ ,0,0,0)
   END IF
END SUB

FUNCTION PrinterDialog (hWnd AS HWND,BYREF hDC AS HDC) AS LONG
   LOCAL pd AS PRINTDLG
   LOCAL save_hDevMode  AS HANDLE
   LOCAL save_hDevNames  AS HANDLE

   pd.lStructSize = SIZEOF(pd)
   pd.hDevMode    = save_hDevMode
   pd.hDevNames   = save_hDevNames
   pd.hwndOwner   = hWnd
   pd.Flags       = PD_SHOWHELP OR PD_RETURNDC
   pd.nCopies     = 1
   pd.nFromPage   = 1
   pd.nToPage     = 1
   pd.nMinPage    = 1
   pd.nMaxPage    = 1
   IF PrintDlg(&pd) THEN
      hDC        = pd.hDC
      FUNCTION   = TRUE
   END IF
   FUNCTION = 0
END FUNCTION


BEGIN EVENTS
   DIM TINFO AS tRMC_INFO PTR
   LOCAL sLines$
   DIM x AS LONG
   DIM nError AS LONG
   STATIC z AS LONG
   STATIC nC AS LONG
   STATIC nCtlW AS LONG
   STATIC nCtlH AS LONG
   SELECT CASE CBMSG
      CASE WM_CREATE
      BCX_BUTTON("&Save bitmap", hWnd, ID_EXPORT,(nW/2) - 85,nH-35,50,15)
      BCX_BUTTON("&Print",       hWnd, ID_PRINT, (nW/2) - 25,nH-35,50,15)
      BCX_BUTTON("&Close",       hWnd, ID_CLOSE, (nW/2) + 35,nH-35,50,15)
      lScrH = _
      BCX_CONTROL("SCROLLBAR", hWnd, "", ID_SCROLL,328,5,12,249,WS_CHILD|SBS_VERT|SBS_RIGHTALIGN|WS_TABSTOP)
      AddMenu(hWnd)

      CASE %WM_SIZE
      INCR nC
      IF nC < 3 THEN
         nCtlW = LOWORD(CBLPARAM) : nCtlH = HIWORD(CBLPARAM)
         EXIT FUNCTION
      END IF
      RMC_SetCtrlSize(ID_RMC1, LOWORD(CBLPARAM)-nCtlW,HIWORD(CBLPARAM)-nCtlH,1) ' set control's size relative to the former size
      nCtlW = LOWORD(CBLPARAM) : nCtlH = HIWORD(CBLPARAM)  ' save former Width and former Height for the next resize

      CASE WM_COMMAND
      SELECT CASE CBCTL
         CASE ID_RMC1
         SELECT CASE CBCTLMSG
            CASE RMC_CTRLLBUTTONDOWN
            TINFO = (tRMC_INFO PTR)CBLPARAM ' lParam holds a pointer to a tRMC_INFO structure
            ShowInfo(TINFO)
            CASE RMC_LBUTTONDOWN
            IF NOT IsWindowVisible(lScrH) THEN
               z = 1                   ' flag for left mousebutton pressed
            END IF                     ' Ignore if ScrollChart is active
            CASE RMC_LBUTTONUP
            z = 0                      ' reset the flag
            CASE RMC_RBUTTONDOWN
            IF nChangeData THEN        ' if in the first line chart
               TINFO = (tRMC_INFO PTR)CBLPARAM ' lParam holds a pointer to a tRMC_INFO structure
               IF TINFO->nGCol > 0 THEN
                  ' Set the new data
                  x=RMC_SetSeriesSingleData(ID_RMC1,1,1,TINFO->nVirtData1,TINFO->nGCol,0)
                  

                    ' Now recalculate the trend line:
                   DIM nFirst AS DOUBLE 
                   DIM nLast AS DOUBLE 
                   DIM nL AS LONG 
                   DIM nT AS LONG 
                   DIM nR AS LONG 
                   DIM nB AS LONG 
                   DIM nRetVal AS LONG
                   DIM nColor AS LONG
                
                    ' Calc the trend and get the needed X/Y positions (nL,nT,nR,nB) for the line
                   nRetVal = RMC_CalcTrend(ID_RMC1,1,1,&nFirst,&nLast,&nL,&nT,&nR,&nB,"")
                   IF nFirst > nLast THEN
                       nColor = ColorRed
                   ELSE
                       nColor = ColorGreen
                   END IF        
                   
                    ' Add a CustomLine to show the trend:
                   nRetVal = RMC_CODash(ID_RMC1,1,nL,nT,nR,nB,RMC_LINE_FLAT_DASH,nColor,0,2,0,RMC_ANCHOR_ARROW_CLOSED)
                    
                    ' Draw the "legend" for the trend line:
                   nRetVal = RMC_CODash(ID_RMC1,2,470,11,500,11,RMC_LINE_FLAT_DASH,nColor,0,2,0,0)
                   nRetVal = RMC_COText(ID_RMC1,3,"Trend",505,5,0,0,0,0,0,0,0,0,"")
                  
                  
                  
                  ' Draw the chart with the new data
                  IF x=0 THEN
                     nError=RMC_Draw(ID_RMC1)
                  END IF
               END IF
            END IF
            CASE RMC_MOUSEMOVE
            TINFO = (tRMC_INFO PTR)CBLPARAM    ' lParam holds a pointer to a tRMC_INFO structure
            IF z THEN                          ' if left mousebutton is pressed
               RMC_SetCtrlPos(ID_RMC1,TINFO->nXMove,TINFO->nYMove,1) ' move the control
            END IF
         END SELECT
         CASE ID_EXPORT
         ExportTheChart(CBHNDL, ID_RMC1)
         CASE ID_PRINT
         STATIC hDC AS HDC
         DIM RAW nResult AS LONG
         nResult = PrinterDialog(CBHNDL,&hDC)
         IF nResult THEN
            RMC_Draw2Printer(ID_RMC1, hDC,0,0,0,0,0)
         END IF
         CASE ID_CLOSE
         CLOSEDIALOG
         CASE ID_SBARS
         HIDE(lScrH)
         nChangeData = 0 ' disallow changing the data with a mouseclick
         SingleBars(hWnd)
         CASE ID_GBARS
         HIDE(lScrH)
         nChangeData = 0 ' disallow changing the data with a mouseclick
         GroupedBars(hWnd)
         CASE ID_STBARS
         HIDE(lScrH)
         nChangeData = 0 ' disallow changing the data with a mouseclick
         StackedBars(hWnd)
         CASE ID_FBARS
         HIDE(lScrH)
         nChangeData = 0 ' disallow changing the data with a mouseclick
         FloatingBars(hWnd)
         CASE ID_CBARS
         HIDE(lScrH)
         nChangeData = 0 ' disallow changing the data with a mouseclick
         ColorBars(hWnd)
         CASE ID_LINE
         HIDE(lScrH)
         nChangeData = 1 ' allow changing the data with a mouseclick
         SimpleLine(hWnd)
         CASE ID_BLINE
         HIDE(lScrH)
         nChangeData = 0 ' disallow changing the data with a mouseclick
         BarsLine(hWnd)
         CASE ID_DATAFROMFILE
         HIDE(lScrH)
         nChangeData = 0 ' disallow changing the data with a mouseclick
         DataFromFile(hWnd)
         CASE ID_PIE
         HIDE(lScrH)
         nChangeData = 0 ' disallow changing the data with a mouseclick
         ExplPie(hWnd)
         CASE ID_DONUT
         HIDE(lScrH)
         nChangeData = 0 ' disallow changing the data with a mouseclick
         Donut(hWnd)
         CASE ID_XYSIMPLE
         HIDE(lScrH)
         nChangeData = 0 ' disallow changing the data with a mouseclick
         XYSimple(hWnd)
         CASE ID_XYCOMPLEX
         HIDE(lScrH)
         nChangeData = 0 ' disallow changing the data with a mouseclick
         XYTwoSeries(hWnd)
         CASE ID_FROMFILE
         HIDE(lScrH)
         nChangeData = 0 ' disallow changing the data with a mouseclick
         FromFile(hWnd)
         CASE ID_FROMSTRING
         HIDE(lScrH)
         nChangeData = 0 ' disallow changing the data with a mouseclick
         FromString(hWnd)
         CASE ID_SAVECHART
         HIDE(lScrH)
         nChangeData = 0 ' disallow changing the data with a mouseclick
         SaveChart(hWnd)
         CASE ID_MSC6
         nChangeData = 0 ' disallow changing the data with a mouseclick
         CALL MiniDesign(hWnd)
         CASE ID_MSC1
         nChangeData = 0 ' disallow changing the data with a mouseclick
         SHOW(lScrH)
         sih.cbSize = SIZEOF(sih)
         sih.fMask = SIF_RANGE OR SIF_PAGE
         sih.nMin = 1
         sih.nMax = 1256           ' 1256 days total
         sih.nPage = 21            ' 21 days shall be painted
         SetScrollInfo (lScrH, SB_CTL, &sih, TRUE)
         ' Call the Sub which builds the chart, but does not add data and does not show it
         nError = Build_ScrollChart(CBHNDL)
         IF nError THEN MSGBOX "RMChart Demo","Error " + STR$(nError), MB_OK BOR MB_ICONERROR
         ' Set the initial data for the first series (Bars):
         RMC_SetSeriesDataFile (ID_RMC1,1,1, "dowdaily.csv","1256,1236","3",",",0)
         ' Set the initial data for the second series (Line):
         RMC_SetSeriesDataFile (ID_RMC1,1,2, "dowdaily.csv","1256,1236","2",",",0)
         RMC_Draw (ID_RMC1)   ' Draw the chart for the first time
      END SELECT
      CASE WM_VSCROLL            ' the vertical scrollbar from "Scroll chart" (see Function Build_ScrollChart)
      SELECT CASE LOWORD(CBWPARAM)
         sih.cbSize = SIZEOF(sih)
         sih.fMask = SIF_ALL
         GetScrollInfo (lScrH, SB_CTL, &sih)
         CASE SB_LINEDOWN
         sih.nPos = MIN(sih.nPos + 1,(sih.nMax-sih.nPage)+1)
         CASE SB_LINEUP
         sih.nPos = MAX(1,sih.nPos - 1)
         CASE SB_PAGEUP
         sih.nPos = MAX(1,sih.nPos - (sih.nPage-1))
         CASE SB_PAGEDOWN
         sih.nPos = MIN(sih.nPos + (sih.nPage-1),(sih.nMax-sih.nPage)+1)
         CASE SB_THUMBTRACK
         sih.nPos = HIWORD(CBWPARAM)
         CASE SB_TOP
         sih.nPos = 1
         CASE SB_BOTTOM
         sih.nPos = (sih.nMax-sih.nPage)+1
         CASE ELSE
         FUNCTION = TRUE
      END SELECT
      SetScrollInfo (lScrH, SB_CTL, &sih, TRUE)
      sLines$ = FORMAT$((1237-sih.nPos)+20) + "," +  FORMAT$((1237-sih.nPos))
      ' Set the new data for the first series (Bars):
      RMC_SetSeriesDataFile (ID_RMC1,1,1, "dowdaily.csv",sLines,"3",",",0)
      ' Set the new data for the second series (Line):
      RMC_SetSeriesDataFile (ID_RMC1,1,2, "dowdaily.csv",sLines,"2",",",0)
      nError = RMC_Draw(ID_RMC1) ' Show the chart with the new data
   END SELECT
END EVENTS


SUB SingleBars(hParentDlg AS HWND)
   DIM nRetVal AS LONG
   DIM sTemp AS STRING
   DIM DYNAMIC aData[0] AS DOUBLE
   
   ' This example uses the short notation style, where each 'property'
   ' is passed by a single parameter. See the next example for the
   ' alternative long notation style.


   '************** Create the chart **********************
   nRetVal = RMC_CreateChart(hParentDlg,ID_RMC1,10,10,600,450,ColorAliceBlue,RMC_CTRLSTYLEFLAT,FALSE,"","",0,0)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Region 1 *****************************
   nRetVal = RMC_AddRegion(ID_RMC1,5,5,-5,-5,"",FALSE)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add caption to region 1 *******************
   nRetVal = RMC_AddCaption(ID_RMC1,1,"This is the chart's caption",ColorBlue,ColorYellow,11,TRUE)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add grid to region 1 *****************************
   nRetVal = RMC_AddGrid(ID_RMC1,1,ColorWhite,FALSE,0,0,0,0,RMC_BICOLOR_LABELAXIS)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add data axis to region 1 *****************************
   nRetVal = RMC_AddDataAxis(ID_RMC1,1,RMC_DATAAXISLEFT,0,100,11,8,ColorBlack,ColorBlack,RMC_LINESTYLESOLID,0,"","","",0)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add label axis to region 1 *****************************
   sTemp = "Label 1*Label 2*Label 3*Label 4*Label 5"
   nRetVal = RMC_AddLabelAxis(ID_RMC1,1, sTemp,1,5,RMC_LABELAXISBOTTOM,8,ColorBlack,RMC_TEXTCENTER,ColorBlack,RMC_LINESTYLENONE,"")
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Series 1 to region 1 *******************************
   '****** Read data values ******
   REDIM aData[4] AS DOUBLE
   aData[0] = 60 : aData[1] = 70 : aData[2] = 40 : aData[3] = 60 : aData[4] = 30
   nRetVal = RMC_AddBarSeries(ID_RMC1,1,aData, 5,RMC_BARSINGLE,RMC_BAR_FLAT_GRADIENT2,FALSE,ColorDefault,FALSE,1,RMC_VLABEL_NONE,1,RMC_HATCHBRUSH_OFF)
   IF nRetVal < 0 THEN GOTO IsError



    ' Now add an average line:
   DIM nAverage AS DOUBLE
   DIM nL AS LONG
   DIM nT AS LONG
   DIM nR AS LONG
   DIM nB AS LONG
   DIM DYNAMIC aXPoints[2] AS LONG
   DIM DYNAMIC aYPoints[2] AS LONG
    
    ' Calc the average and get the needed X/Y positions (nL,nT,nR,nB) for the line
   nRetVal = RMC_CalcAverage(ID_RMC1,1,1,&nAverage,&nL,&nT,&nR,&nB,"")
    
    ' Add a CustomLine to show the average:
   nRetVal = RMC_CODash(ID_RMC1,1,nL,nT,nR,nB,RMC_LINE_FLAT,ColorGreen,0,2,0,0)
    
    ' Draw the "legend" for the average line:
   aXPoints[0] = 480 : aXPoints[1] = 565 : aXPoints[2] = 565
   aYPoints[0] = 175 : aYPoints[1] = 175 : aYPoints[2] = 215
   nRetVal = RMC_COLine(ID_RMC1,2,aXPoints,aYPoints,3,RMC_LINE_FLAT,ColorGreen,0,2,0,RMC_ANCHOR_ARROW_OPEN)
   nRetVal = RMC_COText(ID_RMC1,3," Average (" + FORMAT$(nAverage,"0.00") + ")",480,159,0,0,0,0,0,0,0,0,"")

   nRetVal = RMC_SetWatermark("",RMC_USERWMCOLOR,RMC_USERWMLUCENT,RMC_USERWMALIGN,RMC_USERFONTSIZE)
   nRetVal = RMC_Draw(ID_RMC1)
   IF nRetVal < 0 THEN GOTO IsError
   EXIT SUB

   IsError:
END SUB

SUB GroupedBars(hParentDlg AS HWND)
   DIM nRetVal AS LONG
   DIM sTemp AS STRING
   DIM DYNAMIC aData[0] AS DOUBLE
   DIM tChart AS tRMC_CHART
   DIM tRegion AS tRMC_REGION
   DIM tCaption AS tRMC_CAPTION
   DIM tLegend AS tRMC_LEGEND
   DIM tGrid AS tRMC_GRID
   DIM tDataAxis AS tRMC_DATAAXIS
   DIM tLabelAxis AS tRMC_LABELAXIS
   DIM tBarSeries AS tRMC_BARSERIES


   ' This example uses the alternative long notation style (with UDTs) and omits
   ' no property: the code is bigger, but it's easier to change
   ' the properties for testing purposes

   '************** Create the chart **********************
   tChart.nLeft        = 10
   tChart.nTop         = 10
   tChart.nWidth       = 600
   tChart.nHeight      = 450
   tChart.nBackColor   = ColorDefault
   tChart.nCtrlStyle   = RMC_CTRLSTYLEFLAT
   tChart.sFontName    = ""
   nRetVal = RMC_CreateChartI(hParentDlg, ID_RMC1, &tChart)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Region 1 *****************************
   tRegion.nLeft       = 5
   tRegion.nTop        = 5
   tRegion.nWidth      = -5
   tRegion.nHeight     = -5
   tRegion.sFooter     = ""
   tRegion.nShowBorder = FALSE
   nRetVal = RMC_AddRegionI(ID_RMC1, &tRegion)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add grid to region 1 *****************************
   tGrid.nGridBackColor = ColorDefault
   tGrid.nAsGradient    = FALSE
   tGrid.nLeft      = 0
   tGrid.nTop       = 0
   tGrid.nWidth     = 0
   tGrid.nHeight    = 0
   nRetVal = RMC_AddGridI(ID_RMC1, 1, &tGrid)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add data axis to region 1 *****************************
   tDataAxis.nAlignment      = RMC_DATAAXISLEFT
   tDataAxis.nMinValue       = 0
   tDataAxis.nMaxValue       = 100
   tDataAxis.nTickCount      = 11
   tDataAxis.nFontsize       = 8
   tDataAxis.nTextColor      = ColorDefault
   tDataAxis.nLineColor      = ColorDefault
   tDataAxis.nLineStyle      = RMC_LINESTYLESOLID
   tDataAxis.nDecimalDigits  = 0
   tDataAxis.sUnit           = ""
   tDataAxis.sText           = ""
   nRetVal = RMC_AddDataAxisI(ID_RMC1, 1, &tDataAxis)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add label axis to region 1 *****************************
   tLabelAxis.nCount         = 1
   tLabelAxis.nTickCount     = 5
   tLabelAxis.nAlignment     = RMC_LABELAXISBOTTOM
   tLabelAxis.nFontsize      = 8
   tLabelAxis.nTextColor     = ColorDefault
   tLabelAxis.nTextAlignment = RMC_TEXTCENTER
   tLabelAxis.nLineColor     = ColorDefault
   tLabelAxis.nLineStyle     = RMC_LINESTYLESOLID
   sTemp = "2000*2001*2002*2003*2004"
   nRetVal = RMC_AddLabelAxisI(ID_RMC1, 1, sTemp, &tLabelAxis)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add legend to region 1 *******************************
   tLegend.nLegendAlign    = RMC_LEGEND_TOP
   tLegend.nLegendBackColor= ColorDefault
   tLegend.nLegendStyle    = RMC_LEGENDRECT
   tLegend.nLegendTextColor= ColorDefault
   tLegend.nLegendFontSize = 8
   tLegend.nLegendIsBold   = FALSE
   sTemp = "First quarter*Second quarter*Third quarter*Fourth quarter"
   nRetVal = RMC_AddLegendI(ID_RMC1, 1, sTemp, &tLegend)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Series 1 to region 1 *******************************
   tBarSeries.nType             = RMC_BARGROUP
   tBarSeries.nStyle            = RMC_BAR_HOVER
   tBarSeries.nIsLucent         = FALSE
   tBarSeries.nColor            = ColorDefault
   tBarSeries.nIsHorizontal     = FALSE
   tBarSeries.nWhichDataAxis    = 1
   tBarSeries.nValueLabelOn     = FALSE
   tBarSeries.nPointsPerColumn  = 1
   tBarSeries.nHatchMode        = RMC_HATCHBRUSH_OFF
   '****** Read data values ******
   REDIM aData[4] AS DOUBLE
   aData[0] = 30 : aData[1] = 20 : aData[2] = 40 : aData[3] = 60 : aData[4] = 10
   nRetVal = RMC_AddBarSeriesI(ID_RMC1, 1, aData,5,&tBarSeries)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Series 2 to region 1 *******************************
   tBarSeries.nType             = RMC_BARGROUP
   tBarSeries.nStyle            = RMC_BAR_HOVER
   tBarSeries.nIsLucent         = FALSE
   tBarSeries.nColor            = ColorDefault
   tBarSeries.nIsHorizontal     = FALSE
   tBarSeries.nWhichDataAxis    = 1
   tBarSeries.nValueLabelOn     = FALSE
   tBarSeries.nPointsPerColumn  = 1
   tBarSeries.nHatchMode        = RMC_HATCHBRUSH_OFF
   '****** Read data values ******
   REDIM aData[4] AS DOUBLE
   aData[0] = 30 : aData[1] = 20 : aData[2] = 50 : aData[3] = 70 : aData[4] = 60
   nRetVal = RMC_AddBarSeriesI(ID_RMC1, 1, aData,5, &tBarSeries)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Series 3 to region 1 *******************************
   tBarSeries.nType             = RMC_BARGROUP
   tBarSeries.nStyle            = RMC_BAR_HOVER
   tBarSeries.nIsLucent         = FALSE
   tBarSeries.nColor            = ColorDefault
   tBarSeries.nIsHorizontal     = FALSE
   tBarSeries.nWhichDataAxis    = 1
   tBarSeries.nValueLabelOn     = FALSE
   tBarSeries.nPointsPerColumn  = 1
   tBarSeries.nHatchMode        = RMC_HATCHBRUSH_OFF
   '****** Read data values ******
   REDIM aData[4] AS DOUBLE
   aData[0] = 40 : aData[1] = 10 : aData[2] = 30 : aData[3] = 20 : aData[4] = 80
   nRetVal = RMC_AddBarSeriesI(ID_RMC1, 1, aData,5, &tBarSeries)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Series 4 to region 1 *******************************
   tBarSeries.nType             = RMC_BARGROUP
   tBarSeries.nStyle            = RMC_BAR_HOVER
   tBarSeries.nIsLucent         = FALSE
   tBarSeries.nColor            = ColorDefault
   tBarSeries.nIsHorizontal     = FALSE
   tBarSeries.nWhichDataAxis    = 1
   tBarSeries.nValueLabelOn     = FALSE
   tBarSeries.nPointsPerColumn  = 1
   tBarSeries.nHatchMode        = RMC_HATCHBRUSH_OFF
   '****** Read data values ******
   REDIM aData[4] AS DOUBLE
   aData[0] = 70 : aData[1] = 50 : aData[2] = 80 : aData[3] = 40 : aData[4] = 30
   nRetVal = RMC_AddBarSeriesI(ID_RMC1, 1, aData,5, &tBarSeries)
   IF nRetVal < 0 THEN GOTO IsError

   nRetVal = RMC_SetWatermark("BCX",ColorRed,20,RMC_TEXTLEFT,RMC_USERFONTSIZE) ' set optional watermark
   nRetVal = RMC_Draw(ID_RMC1)      ' Draw the chart

   IF nRetVal < 0 THEN GOTO IsError
   EXIT SUB

   IsError:
   MSGBOX("Error: " + STR$(nRetVal))
END SUB

SUB StackedBars(hParentDlg AS HWND)
   DIM nDataCount AS LONG
   DIM nRetVal AS LONG
   DIM sTemp AS STRING
   DIM DYNAMIC aData[0] AS DOUBLE
   DIM DYNAMIC aData2[0] AS DOUBLE
   DIM DYNAMIC aPPC[0]  AS LONG
   DIM DYNAMIC aColor[0] AS LONG

   DIM nToolTipWidth AS LONG
   nToolTipWidth = 100 ' We want to have ToolTips, so we must set the width. To avoid them, set it to zero
    
   '************** Create the chart **********************
   nRetVal = RMC_CreateChart(hParentDlg,ID_RMC1,10,10,600,450,ColorBisque,RMC_CTRLSTYLE3DLIGHT,FALSE,"","",nToolTipWidth,0)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Region 1 *****************************
   nRetVal = RMC_AddRegion(ID_RMC1,5,10,-5,-5,"this is the footer",FALSE)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add caption to region 1 *******************
   nRetVal = RMC_AddCaption(ID_RMC1,1,"Example of stacked bars",ColorBisque,ColorBlack,11,TRUE)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add grid to region 1 *****************************
   nRetVal = RMC_AddGrid(ID_RMC1,1,ColorCornsilk,FALSE,0,0,0,0,0)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add data axis to region 1 *****************************
   nRetVal = RMC_AddDataAxis(ID_RMC1,1,RMC_DATAAXISBOTTOM,0,50000,11,8,ColorBlack,ColorBlack,RMC_LINESTYLESOLID,0,"$","This is an optional axis text","",0)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add label axis to region 1 *****************************
   sTemp = "Label Nr. 1*Label Nr. 2*Label Nr. 3*Label Nr. 4*Label Nr. 5*Label Nr. 6"
   nRetVal = RMC_AddLabelAxis(ID_RMC1,1, sTemp,1,6,RMC_LABELAXISLEFT,8,ColorBlack,RMC_TEXTCENTER,ColorBlack,RMC_LINESTYLESOLID,"")
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add legend to region 1 *******************************
   sTemp = "Apples*Pears*Cherries*Strawberries"
   nRetVal = RMC_AddLegend(ID_RMC1,1,sTemp,RMC_LEGEND_CUSTOM_UR,ColorLightYellow,RMC_LEGENDRECT,ColorBlue,8,FALSE)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Series 1 to region 1 *******************************
   '****** Read data values ******
   REDIM aData[5] AS DOUBLE
   aData[0] = 10000 : aData[1] = 10000 : aData[2] = 16000 : aData[3] = 12000
   aData[4] = 20000 : aData[5] = 10000
   nRetVal = RMC_AddBarSeries(ID_RMC1,1,aData, 6,RMC_BARSTACKED,RMC_COLUMN_FLAT,FALSE,ColorDarkBlue,TRUE,1,RMC_VLABEL_NONE,1,RMC_HATCHBRUSH_OFF)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Series 2 to region 1 *******************************
   '****** Read data values ******
   REDIM aData[5] AS DOUBLE
   aData[0] = 5000 : aData[1] = 7000 : aData[2] = 4000 : aData[3] = 15000 : aData[4] = 10000
   aData[5] = 10000
   nRetVal = RMC_AddBarSeries(ID_RMC1,1,aData, 6,RMC_BARSTACKED,RMC_COLUMN_FLAT,FALSE,ColorDarkGreen,TRUE,1,RMC_VLABEL_NONE,1,RMC_HATCHBRUSH_OFF)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Series 3 to region 1 *******************************
   '****** Read data values ******
   REDIM aData[5] AS DOUBLE
   aData[0] = 10000 : aData[1] = 3000 : aData[2] = 12000 : aData[3] = 10000
   aData[4] = 5000 : aData[5] = 20000
   nRetVal = RMC_AddBarSeries(ID_RMC1,1,aData, 6,RMC_BARSTACKED,RMC_COLUMN_FLAT,FALSE,ColorMaroon,TRUE,1,RMC_VLABEL_NONE,1,RMC_HATCHBRUSH_OFF)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Series 4 to region 1 *******************************
   '****** Read data values ******
   REDIM aData[5] AS DOUBLE
   aData[0] = 5000 : aData[1] = 9000 : aData[2] = 12000 : aData[3] = 6000 : aData[4] = 10000
   aData[5] = 5000
   nRetVal = RMC_AddBarSeries(ID_RMC1,1,aData, 6,RMC_BARSTACKED,RMC_COLUMN_FLAT,FALSE,ColorDarkGoldenrod,TRUE,1,RMC_VLABEL_NONE,1,RMC_HATCHBRUSH_OFF)
   IF nRetVal < 0 THEN GOTO IsError

   nRetVal = RMC_SetWatermark(RMC_USERWM,RMC_USERWMCOLOR,RMC_USERWMLUCENT,RMC_USERWMALIGN,RMC_USERFONTSIZE)
   nRetVal = RMC_Draw(ID_RMC1)
   IF nRetVal < 0 THEN GOTO IsError

   EXIT SUB
   IsError:

END SUB

SUB FloatingBars(hParentDlg AS HWND)
    Dim i AS LONG
    Dim nC AS LONG
    Dim nDataCount AS LONG
    Dim nRetVal AS LONG
    Dim sTemp AS STRING
    DIM DYNAMIC aData[0] AS DOUBLE
 
 
    '************** Create the chart ********************** 
    nRetVal = RMC_CreateChart(hParentDlg,ID_RMC1,10,10,550,300,ColorLightGray,RMC_CTRLSTYLE3DLIGHT,FALSE,"","Tahoma",0,0)
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add Region 1 ***************************** 
    nRetVal = RMC_AddRegion(ID_RMC1,5,5,-5,-5,"",FALSE) 
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add caption to region 1 ******************* 
    nRetVal = RMC_AddCaption(ID_RMC1,1,"Birth of a Killer App",ColorDefault,ColorBlack,11,TRUE) 
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add grid to region 1 ***************************** 
    nRetVal = RMC_AddGrid(ID_RMC1,1,ColorPaleGoldenrod,TRUE,0,0,0,0,RMC_BICOLOR_NONE) 
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add data axis to region 1 ***************************** 
    sTemp = "04/01*04/02*04/03*04/04*04/05*04/06*04/07*04/08*04/09*04/10*04/11*04/12*05/01"
    nRetVal = RMC_AddDataAxis(ID_RMC1,1,RMC_DATAAXISBOTTOM,1,13,13,8,ColorBlack,ColorBlack,RMC_LINESTYLESOLID,0,"","",sTemp,RMC_TEXTCENTER) 
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add label axis to region 1 ***************************** 
    sTemp = "Design*Development*Testing*Bug Fixing*Documentation*Marketing"
    nRetVal = RMC_AddLabelAxis(ID_RMC1,1, sTemp,1,6,RMC_LABELAXISLEFT,8,ColorBlack,RMC_TEXTCENTER,ColorBlack,RMC_LINESTYLESOLID,"") 
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add legend to region 1 ******************************* 
    sTemp = "Schedule*Reality"
    nRetVal = RMC_AddLegend(ID_RMC1,1,sTemp,RMC_LEGEND_CUSTOM_UR,ColorLightBlue,RMC_LEGENDRECT,ColorMediumBlue,8,FALSE) 
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add Series 1 to region 1 ******************************* 
    '****** Read data values ******
    REDIM aData[12] AS DOUBLE
    aData[0] = 1 : aData[1] = 3 : aData[2] = 4 : aData[3] = 6 : aData[4] = 6
    aData[5] = 4 : aData[6] = 7 : aData[7] = 4 : aData[8] = 9 : aData[9] = 3
    aData[10] = 10 : aData[11] = 3
    nRetVal = RMC_AddBarSeries(ID_RMC1,1,aData, 12,RMC_FLOATINGBARGROUP,RMC_BAR_HOVER,FALSE,ColorPaleGreen,TRUE,1,RMC_VLABEL_NONE,1,RMC_HATCHBRUSH_OFF) 
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add Series 2 to region 1 ******************************* 
    '****** Read data values ******
    REDIM aData[12] AS DOUBLE
    aData[0] = 1 : aData[1] = .5 : aData[2] = 1.5 : aData[3] = 10.5 : aData[4] = 12
    aData[5] = 1 : aData[6] = 12 : aData[7] = 1 : aData[8] = 12.5 : aData[9] = .5
    aData[10] = 2 : aData[11] = 11
    nRetVal = RMC_AddBarSeries(ID_RMC1,1,aData, 12,RMC_FLOATINGBARGROUP,RMC_BAR_HOVER,FALSE,ColorOrangeRed,TRUE,1,RMC_VLABEL_NONE,2,RMC_HATCHBRUSH_OFF) 
    IF nRetVal < 0 THEN GOTO IsError
 
    nRetVal = RMC_SetWatermark(RMC_USERWM,RMC_USERWMCOLOR,RMC_USERWMLUCENT,RMC_USERWMALIGN,RMC_USERFONTSIZE)
    nRetVal = RMC_Draw(ID_RMC1)
    IF nRetVal < 0 THEN GOTO IsError
    Exit SUB 
 
    IsError: 
END SUB

SUB ColorBars(hParentDlg AS HWND)
   DIM nRetVal AS LONG
   DIM sTemp AS STRING
   DIM DYNAMIC aData[0] AS DOUBLE
   DIM tChart AS tRMC_CHART
   DIM tRegion AS tRMC_REGION
   DIM tCaption AS tRMC_CAPTION
   DIM tGrid AS tRMC_GRID
   DIM tDataAxis AS tRMC_DATAAXIS
   DIM tLabelAxis AS tRMC_LABELAXIS
   DIM tBarSeries AS tRMC_BARSERIES

   '************** Create the chart **********************
   tChart.nLeft        = 10
   tChart.nTop         = 10
   tChart.nWidth       = 600
   tChart.nHeight      = 450
   tChart.nBackColor   = ColorTransparent
   tChart.nCtrlStyle   = RMC_CTRLSTYLEIMAGE
   tChart.sBgImage     = "seasky.jpg"
   tChart.sFontName    = ""
   tChart.nToolTipWidth = 100  ' We want to have ToolTips, so we must set the width
   nRetVal = RMC_CreateChartI(hParentDlg, ID_RMC1, &tChart)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Region 1 *****************************
   tRegion.nLeft       = 5
   tRegion.nTop        = 5
   tRegion.nWidth      = -5
   tRegion.nHeight     = -5
   tRegion.sFooter     = ""
   tRegion.nShowBorder = FALSE
   nRetVal = RMC_AddRegionI(ID_RMC1, &tRegion)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add grid to region 1 *****************************
   tGrid.nGridBackColor = ColorTransparent
   tGrid.nAsGradient    = FALSE
   tGrid.nLeft      = 0
   tGrid.nTop       = 0
   tGrid.nWidth     = 0
   tGrid.nHeight    = 0
   nRetVal = RMC_AddGridI(ID_RMC1, 1, &tGrid)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add data axis to region 1 *****************************
   tDataAxis.nAlignment      = RMC_DATAAXISLEFT
   tDataAxis.nMinValue       = 0
   tDataAxis.nMaxValue       = 100
   tDataAxis.nTickCount      = 11
   tDataAxis.nFontsize       = 8
   tDataAxis.nTextColor      = ColorChalk
   tDataAxis.nLineColor      = ColorChalk
   tDataAxis.nLineStyle      = RMC_LINESTYLEDOT
   tDataAxis.nDecimalDigits  = 0
   tDataAxis.sUnit           = ""
   tDataAxis.sText           = ""
   nRetVal = RMC_AddDataAxisI(ID_RMC1, 1, &tDataAxis)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add label axis to region 1 *****************************
   tLabelAxis.nCount         = 1
   tLabelAxis.nTickCount     = 5
   tLabelAxis.nAlignment     = RMC_LABELAXISBOTTOM
   tLabelAxis.nFontsize      = 8
   tLabelAxis.nTextColor     = ColorYellow
   tLabelAxis.nTextAlignment = RMC_TEXTCENTER
   tLabelAxis.nLineColor     = ColorChalk
   tLabelAxis.nLineStyle     = RMC_LINESTYLENONE
   tLabelAxis.sText          = ""
   sTemp = "Label 1*Label 2*Label 3*Label 4*Label 5"
   nRetVal = RMC_AddLabelAxisI(ID_RMC1, 1, sTemp, &tLabelAxis)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Series 1 to region 1 *******************************
   tBarSeries.nType             = RMC_BARSINGLE
   tBarSeries.nStyle            = RMC_BAR_FLAT_GRADIENT2
   tBarSeries.nIsLucent         = TRUE
   tBarSeries.nColor            = ColorTransparent
   tBarSeries.nIsHorizontal     = FALSE
   tBarSeries.nWhichDataAxis    = 1
   tBarSeries.nValueLabelOn     = RMC_VLABEL_NONE
   tBarSeries.nPointsPerColumn  = 1
   tBarSeries.nHatchMode        = RMC_HATCHBRUSH_OFF
   '****** Read data values ******
   REDIM aData[4] AS DOUBLE
   aData[0] = 50 : aData[1] = 70 : aData[2] = 40 : aData[3] = 60 : aData[4] = 30
   nRetVal = RMC_AddBarSeriesI(ID_RMC1, 1, aData, 5, &tBarSeries)
   IF nRetVal < 0 THEN GOTO IsError


    ' Let's set some CustomToolTipTexts:
    nRetVal = RMC_SetCustomToolTipText(ID_RMC1,1,1,1,"First Bar"+CHR$(13)+CHR$(10)+"Value: 50"+CHR$(13)+CHR$(10)+"Color: Blue")
    nRetVal = RMC_SetCustomToolTipText(ID_RMC1,1,1,2,"Second Bar"+CHR$(13)+CHR$(10)+"Value: 70"+CHR$(13)+CHR$(10)+"Color: Green")
    nRetVal = RMC_SetCustomToolTipText(ID_RMC1,1,1,3,"Third Bar"+CHR$(13)+CHR$(10)+"Value: 40"+CHR$(13)+CHR$(10)+"Color: Red")
    nRetVal = RMC_SetCustomToolTipText(ID_RMC1,1,1,4,"Fourth Bar"+CHR$(13)+CHR$(10)+"Value: 60"+CHR$(13)+CHR$(10)+"Color: Yellow")
    ' Last bar gets no CustomText, so the default ToolTipText (=Value) is used


   nRetVal = RMC_SetWatermark(RMC_USERWM,RMC_USERWMCOLOR,RMC_USERWMLUCENT,RMC_USERWMALIGN,RMC_USERFONTSIZE)
   nRetVal = RMC_Draw(ID_RMC1)
   IF nRetVal < 0 THEN GOTO IsError
   EXIT SUB

   IsError:

END SUB

SUB SimpleLine(hParentDlg AS HWND)
   DIM nRetVal AS LONG
   DIM sTemp AS STRING
   DIM DYNAMIC aData[0] AS DOUBLE



   '************** Create the chart **********************
   nRetVal = RMC_CreateChart(hParentDlg,ID_RMC1,10,10,600,450,ColorChalk,RMC_CTRLSTYLEFLAT,FALSE,"","",0,0)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Region 1 *****************************
   nRetVal = RMC_AddRegion(ID_RMC1,5,5,-5,-5,"Click with the right mousebutton into the grid!\C11",FALSE)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add caption to region 1 *******************
   nRetVal = RMC_AddCaption(ID_RMC1,1,"Simple line",ColorNavy,ColorWhite,10,TRUE)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add grid to region 1 *****************************
   nRetVal = RMC_AddGrid(ID_RMC1,1,ColorBeige,TRUE,0,0,0,0,0)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add data axis to region 1 *****************************
   nRetVal = RMC_AddDataAxis(ID_RMC1,1,RMC_DATAAXISLEFT,0,100,11,8,ColorBlack,ColorBlack,RMC_LINESTYLESOLID,0,"","","",0)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add label axis to region 1 *****************************
   sTemp = ""
   nRetVal = RMC_AddLabelAxis(ID_RMC1,1, sTemp,1,20,RMC_LABELAXISBOTTOM,8,ColorBlack,RMC_TEXTCENTER,ColorBlack,RMC_LINESTYLESOLID,"")
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Series 1 to region 1 *******************************
   '****** Read data values ******
   REDIM aData[19] AS DOUBLE
   aData[0] = 15 : aData[1] = 25 : aData[2] = 30 : aData[3] = 22 : aData[4] = 75
   aData[5] = 45 : aData[6] = 65 : aData[7] = 75 : aData[8] = 40 : aData[9] = 35
   aData[10] = 20 : aData[11] = 45 : aData[12] = 80 : aData[13] = 90 : aData[14] = 70
   aData[15] = 65 : aData[16] = 25 : aData[17] = 10 : aData[18] = 30 : aData[19] = 25
   nRetVal = RMC_AddLineSeries(ID_RMC1,1, aData, 20,0,0,RMC_LINE,RMC_LINE_FLAT,RMC_LSTYLE_LINE,FALSE, _
   ColorBlue,RMC_SYMBOL_BULLET,1,RMC_VLABEL_DEFAULT,RMC_HATCHBRUSH_OFF)
   IF nRetVal < 0 THEN GOTO IsError

    ' Now add a trend line:
   DIM nFirst AS DOUBLE 
   DIM nLast AS DOUBLE 
   DIM nL AS LONG 
   DIM nT AS LONG 
   DIM nR AS LONG 
   DIM nB AS LONG 
   DIM nColor AS LONG

    ' Calc the trend and get the needed X/Y positions (nL,nT,nR,nB) for the line
   nRetVal = RMC_CalcTrend(ID_RMC1,1,1,&nFirst,&nLast,&nL,&nT,&nR,&nB,"")
   IF nFirst > nLast THEN
      nColor = ColorRed
   ELSE
       nColor = ColorGreen
   END IF        
    
    ' Add a CustomLine to show the trend:
   nRetVal = RMC_CODash(ID_RMC1,1,nL,nT,nR,nB,RMC_LINE_FLAT_DASH,nColor,0,2,0,RMC_ANCHOR_ARROW_CLOSED)
    
    ' Draw the "legend" for the trend line:
   nRetVal = RMC_CODash(ID_RMC1,2,470,11,500,11,RMC_LINE_FLAT_DASH,nColor,0,2,0,0)
   nRetVal = RMC_COText(ID_RMC1,3,"Trend",505,5,0,0,0,0,0,0,0,0,"")


   nRetVal = RMC_Draw(ID_RMC1)
   IF nRetVal < 0 THEN GOTO IsError
   EXIT SUB

   IsError:

END SUB

SUB BarsLine(hParentDlg AS HWND)
   DIM nRetVal AS LONG
   DIM sTemp AS STRING
   DIM DYNAMIC aData[0] AS DOUBLE
   DIM tChart AS tRMC_CHART
   DIM tRegion AS tRMC_REGION
   DIM tCaption AS tRMC_CAPTION
   DIM tLegend AS tRMC_LEGEND
   DIM tGrid AS tRMC_GRID
   DIM tDataAxis AS tRMC_DATAAXIS
   DIM tLabelAxis AS tRMC_LABELAXIS
   DIM tBarSeries AS tRMC_BARSERIES
   DIM tLineSeries AS tRMC_LINESERIES


   '************** Create the chart **********************
   tChart.nLeft        = 10
   tChart.nTop         = 10
   tChart.nWidth       = 670
   tChart.nHeight      = 450
   tChart.nBackColor   = ColorCornflowerBlue
   tChart.nCtrlStyle   = RMC_CTRLSTYLEFLATSHADOW
   tChart.sBgImage     = ""
   tChart.sFontName    = ""
   nRetVal = RMC_CreateChartI(hParentDlg, ID_RMC1, &tChart)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Region 1 *****************************
   tRegion.nLeft       = 5
   tRegion.nTop        = 10
   tRegion.nWidth      = -5
   tRegion.nHeight     = -5
   tRegion.sFooter     = "data source: F.A.Z"
   tRegion.nShowBorder = FALSE
   nRetVal = RMC_AddRegionI(ID_RMC1, &tRegion)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add caption to region 1 *******************
   tCaption.sText  =     "The world's 10 biggest industrial companies 2003"
   tCaption.nBackColor = ColorCoral
   tCaption.nTextColor = ColorFloralWhite
   tCaption.nFontSize  = 12
   tCaption.nIsBold    = TRUE
   nRetVal = RMC_AddCaptionI(ID_RMC1, 1, &tCaption)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add grid to region 1 *****************************
   tGrid.nGridBackColor = ColorAzure
   tGrid.nAsGradient    = TRUE
   tGrid.nLeft      = 0
   tGrid.nTop       = 0
   tGrid.nWidth     = 0
   tGrid.nHeight    = 0
   nRetVal = RMC_AddGridI(ID_RMC1, 1, &tGrid)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add data axis to region 1 *****************************
   tDataAxis.nAlignment      = RMC_DATAAXISLEFT
   tDataAxis.nMinValue       = 100000
   tDataAxis.nMaxValue       = 250000
   tDataAxis.nTickCount      = 11
   tDataAxis.nFontsize       = 9
   tDataAxis.nTextColor      = ColorCornsilk
   tDataAxis.nLineColor      = ColorBlack
   tDataAxis.nLineStyle      = RMC_LINESTYLESOLID
   tDataAxis.nDecimalDigits  = 0
   tDataAxis.sUnit           = "$"
   tDataAxis.sText           = "Total turnover in Mill. Dollar"
   nRetVal = RMC_AddDataAxisI(ID_RMC1, 1, &tDataAxis)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add second data axis to region 1 *****************************
   tDataAxis.nAlignment      = RMC_DATAAXISRIGHT
   tDataAxis.nMinValue       = 0
   tDataAxis.nMaxValue       = 0
   tDataAxis.nDecimalDigits  = 2
   tDataAxis.sUnit           = "%"
   tDataAxis.sText           = "Net operating margin"
   nRetVal = RMC_AddDataAxisI(ID_RMC1, 1, &tDataAxis)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add label axis to region 1 *****************************
   tLabelAxis.nCount         = 1
   tLabelAxis.nTickCount     = 10
   tLabelAxis.nAlignment     = RMC_LABELAXISBOTTOM
   tLabelAxis.nFontsize      = 8
   tLabelAxis.nTextColor     = ColorCornsilk
   tLabelAxis.nTextAlignment = RMC_TEXTCENTER
   tLabelAxis.nLineColor     = ColorBlack
   tLabelAxis.nLineStyle     = RMC_LINESTYLESOLID
   tLabelAxis.sText          = ""
   sTemp =         "Exxon Mobil*Royal Dutch / Shell*BP*General Motors*Daimler Chrysler*Ford Motor*Toyota Motor*General E"
   sTemp = sTemp + "lectric*TOTAL*Chevron Texaco"
   nRetVal = RMC_AddLabelAxisI(ID_RMC1, 1, sTemp, &tLabelAxis)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Series 1 to region 1 *******************************
   tBarSeries.nType             = RMC_BARSINGLE
   tBarSeries.nStyle            = RMC_BAR_FLAT_GRADIENT2
   tBarSeries.nIsLucent         = FALSE
   tBarSeries.nColor            = ColorGold
   tBarSeries.nIsHorizontal     = FALSE
   tBarSeries.nWhichDataAxis    = 1
   tBarSeries.nValueLabelOn     = RMC_VLABEL_NONE
   tBarSeries.nPointsPerColumn  = 1
   tBarSeries.nHatchMode        = RMC_HATCHBRUSH_OFF
   '****** Read data values ******
   REDIM aData[9] AS DOUBLE
   aData[0] = 242365 : aData[1] = 235598 : aData[2] = 232571 : aData[3] = 185524
   aData[4] = 170457 : aData[5] = 164196 : aData[6] = 149321 : aData[7] = 132797
   aData[8] = 130067 : aData[9] = 119703
   nRetVal = RMC_AddBarSeriesI(ID_RMC1, 1, aData, 10, &tBarSeries)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Series 2 to region 1 *******************************
   tLineSeries.nType             = RMC_LINE
   tLineSeries.nStyle            = RMC_LINE_CABLE
   tLineSeries.nLineStyle        = RMC_LSTYLE_LINE
   tLineSeries.nIsLucent         = FALSE
   tLineSeries.nColor            = ColorGreen
   tLineSeries.nSeriesSymbol     = RMC_SYMBOL_BULLET
   tLineSeries.nWhichDataAxis    = 2
   tLineSeries.nValueLabelOn     = RMC_VLABEL_DEFAULT
   tLineSeries.nHatchMode        = RMC_HATCHBRUSH_OFF
   '****** Read data values ******
   REDIM aData[9] AS DOUBLE
   aData[0] = 8.9 : aData[1] = 4.1 : aData[2] = 4.4 : aData[3] = 2.1 : aData[4] = .3
   aData[5] = .3 : aData[6] = 5.9 : aData[7] = 11.3 : aData[8] = 6.7 : aData[9] = 6
   nRetVal = RMC_AddLineSeriesI(ID_RMC1, 1, aData, 10,0,0, &tLineSeries)
   IF nRetVal < 0 THEN GOTO IsError

   nRetVal = RMC_SetWatermark(RMC_USERWM,RMC_USERWMCOLOR,RMC_USERWMLUCENT,RMC_USERWMALIGN,RMC_USERFONTSIZE)
   nRetVal = RMC_Draw(ID_RMC1)
   IF nRetVal < 0 THEN GOTO IsError
   EXIT SUB

   IsError:

END SUB

SUB DataFromFile(hParentDlg AS HWND)
    Dim i AS LONG
    DIM nC AS LONG
    DIM nDataCount AS LONG
    DIM nRetVal AS LONG
    DIM sTemp AS STRING
    DIM DYNAMIC aData[0] AS DOUBLE
    DIM DYNAMIC aData2[0] AS DOUBLE
    DIM DYNAMIC aPPC[0]  AS LONG
    DIM DYNAMIC aColor[0] AS LONG
 
 
    '************** Create the chart ********************** 
    nRetVal = RMC_CreateChart(hParentDlg,ID_RMC1,10,10,600,450,ColorPaleGreen,RMC_CTRLSTYLEFLATSHADOW,FALSE,"","Tahoma", 0,0)
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add Region 1 ***************************** 
    nRetVal = RMC_AddRegion(ID_RMC1,5,10,-5,-5,"data on a weekly basis. source: www.yahoo.com",FALSE) 
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add caption to region 1 ******************* 
    nRetVal = RMC_AddCaption(ID_RMC1,1,"Performance of DOW JONES, DAX and NASDAQ from January 2000 to end of June 2004",ColorPaleGreen,ColorDarkBlue,9,TRUE) 
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add grid to region 1 ***************************** 
    nRetVal = RMC_AddGrid(ID_RMC1,1,ColorLightBlue,TRUE,0,0,0,0,RMC_BICOLOR_NONE) 
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add data axis to region 1 ***************************** 
    nRetVal = RMC_AddDataAxis(ID_RMC1,1,RMC_DATAAXISLEFT,0,0,11,8,ColorDarkBlue,ColorDarkSlateGray,RMC_LINESTYLEDOT,0,"%","2nd January 2000 = 100%","",RMC_TEXTCENTER) 
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add label axis to region 1 ***************************** 
    sTemp = "2000*2001*2002*2003*2004"
    nRetVal = RMC_AddLabelAxis(ID_RMC1,1, sTemp,1,5,RMC_LABELAXISBOTTOM,8,ColorDarkBlue,RMC_TEXTCENTER,ColorDarkSlateGray,RMC_LINESTYLEDOT,"") 
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add legend to region 1 ******************************* 
    sTemp = "DOW JONES*DAX*NASDAQ"
    nRetVal = RMC_AddLegend(ID_RMC1,1,sTemp,RMC_LEGEND_CUSTOM_UR,ColorPaleTurquoise,RMC_LEGENDRECT,ColorDarkBlue,8,FALSE) 
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add Series 1 to region 1 ******************************* 
    '****** Read points per column ******
    REDIM aPPC[0] AS LONG
    aPPC[0] = 52
    nRetVal = RMC_AddLineSeries(ID_RMC1,1, aData, 0,aPPC,1,RMC_LINE_INDEXED,RMC_LINE_FLAT,RMC_LSTYLE_LINE,FALSE, _
                                    ColorBlue,RMC_SYMBOL_NONE,1,RMC_VLABEL_NONE,RMC_HATCHBRUSH_OFF) 
    IF nRetVal < 0 THEN GOTO IsError
    '****** Set name and parameters for the datafile for series 1 ******
    nRetVal = RMC_SetSeriesDataFile(ID_RMC1,1,1,"dow00-04.csv","-1,1","5",",",0)
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add Series 2 to region 1 ******************************* 
    '****** Read points per column ******
    REDIM aPPC[0] AS LONG
    aPPC[0] = 52
    nRetVal = RMC_AddLineSeries(ID_RMC1,1, aData, 0,aPPC,1,RMC_LINE_INDEXED,RMC_LINE_FLAT,RMC_LSTYLE_LINE,FALSE, _
                                    ColorCrimson,RMC_SYMBOL_NONE,1,RMC_VLABEL_NONE,RMC_HATCHBRUSH_OFF) 
    IF nRetVal < 0 THEN GOTO IsError
    '****** Set name and parameters for the datafile for series 2 ******
    nRetVal = RMC_SetSeriesDataFile(ID_RMC1,1,2,"dax00-04.csv","-1,1","5",",",0)
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add Series 3 to region 1 ******************************* 
    '****** Read points per column ******
    REDIM aPPC[0] AS LONG
    aPPC[0] = 52
    nRetVal = RMC_AddLineSeries(ID_RMC1,1, aData, 0,aPPC,1,RMC_LINE_INDEXED,RMC_LINE_FLAT,RMC_LSTYLE_LINE,FALSE, _
                                    ColorBlack,RMC_SYMBOL_NONE,1,RMC_VLABEL_NONE,RMC_HATCHBRUSH_OFF) 
    IF nRetVal < 0 THEN GOTO IsError
    '****** Set name and parameters for the datafile for series 3 ******
    nRetVal = RMC_SetSeriesDataFile(ID_RMC1,1,3,"nasdaq00-04.csv","-1,1","5",",",0)
    IF nRetVal < 0 THEN GOTO IsError

    ' Add some CustomObjects
    nRetVal = RMC_COText(ID_RMC1,1,"09/11/2001",287,117,80,22,0,ColorLightGreen,0,150,0,0,"CB")
    nRetVal = RMC_CODash(ID_RMC1,2,327,141,250,223,0,ColorLightGreen,0,2,0,RMC_ANCHOR_ARROW_OPEN)
    nRetVal = RMC_CODash(ID_RMC1,3,327,141,250,274,0,ColorLightGreen,0,2,0,RMC_ANCHOR_ARROW_OPEN)
    nRetVal = RMC_CODash(ID_RMC1,4,327,141,252,336,0,ColorLightGreen,0,2,0,RMC_ANCHOR_ARROW_OPEN)

 
    nRetVal = RMC_Draw(ID_RMC1)
    IF nRetVal < 0 THEN GOTO IsError
    EXIT SUB 
 
    IsError: 
END SUB

SUB ExplPie(hParentDlg AS HWND)
   DIM nRetVal AS LONG
   DIM sTemp AS STRING
   DIM DYNAMIC aData[0] AS DOUBLE
   DIM DYNAMIC aColor[0] AS LONG


   '************** Create the chart **********************
   nRetVal = RMC_CreateChart(hParentDlg,ID_RMC1,10,10,600,450,ColorAliceBlue,RMC_CTRLSTYLE3D,FALSE,"","",0,0)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Region 1 *****************************
   nRetVal = RMC_AddRegion(ID_RMC1,5,5,-5,-5,"",FALSE)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add legend to region 1 *******************************
   sTemp = "Cherries*Bananas*Apples*Strawberries"
   nRetVal = RMC_AddLegend(ID_RMC1,1,sTemp,RMC_LEGEND_CUSTOM_UL,ColorLightYellow,RMC_LEGENDRECT,ColorBlue,8,FALSE)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Series 1 to region 1 *******************************
   '****** Read color values ******
   REDIM aColor[3] AS LONG
   aColor[0] = ColorFirebrick
   aColor[1] = ColorLightSteelBlue
   aColor[2] = ColorDarkGreen
   aColor[3] = ColorLightCoral
   '****** Read data values ******
   REDIM aData[3] AS DOUBLE
   aData[0] = 10 : aData[1] = 20 : aData[2] = 30 : aData[3] = 40
   nRetVal = RMC_AddGridlessSeries(ID_RMC1,1, aData, 4,aColor,4,RMC_PIE_3D,RMC_FULL,2,TRUE,RMC_VLABEL_NONE,RMC_HATCHBRUSH_OFF,0)
   IF nRetVal < 0 THEN GOTO IsError

   nRetVal = RMC_SetWatermark(RMC_USERWM,RMC_USERWMCOLOR,RMC_USERWMLUCENT,RMC_USERWMALIGN,RMC_USERFONTSIZE)
   nRetVal = RMC_Draw(ID_RMC1)
   IF nRetVal < 0 THEN GOTO IsError
   EXIT SUB

   IsError:

END SUB

SUB Donut(hParentDlg AS HWND)
   DIM nDataCount AS LONG
   DIM nRetVal AS LONG
   DIM sTemp AS STRING
   DIM DYNAMIC aData[0] AS DOUBLE
   DIM DYNAMIC aData2[0] AS DOUBLE
   DIM DYNAMIC aPPC[0]  AS LONG
   DIM DYNAMIC aColor[0] AS LONG


   '************** Create the chart **********************
   nRetVal = RMC_CreateChart(hParentDlg,ID_RMC1,10,10,600,450,ColorTransparent,RMC_CTRLSTYLEIMAGETILED,FALSE,"paper.jpg","",0,0)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Region 1 *****************************
   nRetVal = RMC_AddRegion(ID_RMC1,5,5,-5,-5,"",FALSE)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add legend to region 1 *******************************
   sTemp = "Apples*Citrons*Bananas*Cherries"
   nRetVal = RMC_AddLegend(ID_RMC1,1,sTemp,RMC_LEGEND_ONVLABELS,ColorDefault,RMC_LEGENDNORECT,ColorBlue,8,FALSE)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Series 1 to region 1 *******************************
   '****** Read color values ******
   REDIM aColor[3] AS LONG
   aColor[0] = ColorLightGreen
   aColor[1] = ColorYellow
   aColor[2] = ColorGoldenrod
   aColor[3] = ColorCrimson
   '****** Read data values ******
   REDIM aData[3] AS DOUBLE
   aData[0] = 40 : aData[1] = 30 : aData[2] = 60 : aData[3] = 20
   nRetVal = RMC_AddGridlessSeries(ID_RMC1,1, aData, 4,aColor,4,RMC_DONUT_GRADIENT,RMC_FULL,0,FALSE,RMC_VLABEL_TWIN,RMC_HATCHBRUSH_OFF,0)
   IF nRetVal < 0 THEN GOTO IsError

    ' Add a CustomObject
   nRetVal = RMC_COText(ID_RMC1,1,"With CustomObjects you can place text wherever you want!",230,175,140,100,0,0,0,0,0,ColorRed,"12C")
   nRetVal = RMC_Draw(ID_RMC1)
   IF nRetVal < 0 THEN GOTO IsError
   EXIT SUB

   IsError:
END SUB


SUB XYSimple(hParentDlg AS HWND)
   DIM i AS LONG
   DIM nC AS LONG
   DIM nRetVal AS LONG
   DIM sTemp AS STRING
   DIM DYNAMIC aData[0] AS DOUBLE
   DIM DYNAMIC aData2[0] AS DOUBLE

   '************** Create the chart **********************
   nRetVal = RMC_CreateChart(hParentDlg,ID_RMC1,10,10,600,450,ColorSteelBlue,RMC_CTRLSTYLEFLAT,FALSE,"","",0,0)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Region 1 *****************************
   nRetVal = RMC_AddRegion(ID_RMC1,5,5,-5,-5,"",FALSE)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add caption to region 1 *******************
   nRetVal = RMC_AddCaption(ID_RMC1,1,"Simple XY chart",ColorAliceBlue,ColorBlack,10,TRUE)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add grid to region 1 *****************************
   nRetVal = RMC_AddGrid(ID_RMC1,1,ColorDarkBlue,FALSE,0,0,0,0,0)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add first X axis to region 1 *****************************
   nRetVal = RMC_AddXAxis(ID_RMC1,1,RMC_XAXISBOTTOM,0,100,11,8,ColorBlanchedAlmond,ColorWhite,RMC_LINESTYLENONE,0,"","X Axis","",0)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add first Y axis to region 1 *****************************
   nRetVal = RMC_AddYAxis(ID_RMC1,1,RMC_YAXISLEFT,0,100,11,8,ColorBlanchedAlmond,ColorBlack,RMC_LINESTYLENONE,0,"","Y Axis","",0)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Series 1 to region 1 *******************************
   '****** Read X-data values ******
   REDIM aData[9] AS DOUBLE
   aData[0] = 10 : aData[1] = 20 : aData[2] = 30 : aData[3] = 40 : aData[4] = 50
   aData[5] = 60 : aData[6] = 70 : aData[7] = 80 : aData[8] = 90 : aData[9] = 10
   '****** Read Y-data values ******
   REDIM aData2[9] AS DOUBLE
   aData2[0] = 10 : aData2[1] = 30 : aData2[2] = 50 : aData2[3] = 70 : aData2[4] = 90
   aData2[5] = 70 : aData2[6] = 50 : aData2[7] = 30 : aData2[8] = 10 : aData2[9] = 10
   nRetVal = RMC_AddXYSeries(ID_RMC1,1, aData, 10,aData2,10,ColorWhiteSmoke,RMC_XY_LINE,RMC_LSTYLE_LINE,RMC_SYMBOL_STAR,RMC_XAXISBOTTOM,RMC_YAXISLEFT, RMC_VLABEL_NONE)
   IF nRetVal < 0 THEN GOTO IsError

   nRetVal = RMC_SetWatermark(RMC_USERWM,RMC_USERWMCOLOR,RMC_USERWMLUCENT,RMC_USERWMALIGN,RMC_USERFONTSIZE)
   nRetVal = RMC_Draw(ID_RMC1)
   IF nRetVal < 0 THEN GOTO IsError
   EXIT SUB

   IsError:

END SUB

SUB XYTwoSeries(hParentDlg AS HWND)
   DIM i AS LONG
   DIM nC AS LONG
   DIM nRetVal AS LONG
   DIM sTemp AS STRING
   DIM DYNAMIC aData[0] AS DOUBLE
   DIM DYNAMIC aData2[0] AS DOUBLE
   DIM tChart AS tRMC_CHART
   DIM tRegion AS tRMC_REGION
   DIM tCaption AS tRMC_CAPTION
   DIM tLegend AS tRMC_LEGEND
   DIM tGrid AS tRMC_GRID
   DIM tXYAxis AS tRMC_XYAXIS
   DIM tXYSeries AS tRMC_XYSERIES


   '************** Create the chart **********************
   tChart.nLeft        = 10
   tChart.nTop         = 10
   tChart.nWidth       = 600
   tChart.nHeight      = 450
   tChart.nBackColor   = ColorAliceBlue
   tChart.nCtrlStyle   = RMC_CTRLSTYLEFLATSHADOW
   tChart.sBgImage     = ""
   nRetVal = RMC_CreateChartI(hParentDlg, ID_RMC1, &tChart)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Region 1 *****************************
   tRegion.nLeft       = 5
   tRegion.nTop        = 5
   tRegion.nWidth      = -5
   tRegion.nHeight     = -5
   tRegion.sFooter     = ""
   tRegion.nShowBorder = FALSE
   nRetVal = RMC_AddRegionI(ID_RMC1, &tRegion)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add caption to region 1 *******************
   tCaption.sText  =     "Two XY series aligned to 2 different XY-axes pairs"
   tCaption.nBackColor = ColorBlue
   tCaption.nTextColor = ColorAntiqueWhite
   tCaption.nFontSize  = 10
   tCaption.nIsBold    = TRUE
   nRetVal = RMC_AddCaptionI(ID_RMC1, 1, &tCaption)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add grid to region 1 *****************************
   tGrid.nGridBackColor = ColorBeige
   tGrid.nAsGradient    = FALSE
   tGrid.nLeft      = 0
   tGrid.nTop       = 0
   tGrid.nWidth     = 0
   tGrid.nHeight    = 0
   nRetVal = RMC_AddGridI(ID_RMC1, 1, &tGrid)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add first X axis to region 1 *****************************
   tXYAxis.nAlignment        = RMC_XAXISBOTTOM
   tXYAxis.nMinValue         = 0
   tXYAxis.nMaxValue         = 100
   tXYAxis.nTickCount        = 11
   tXYAxis.nFontsize         = 8
   tXYAxis.nTextColor        = ColorBlue
   tXYAxis.nLineColor        = ColorBlue
   tXYAxis.nLineStyle        = RMC_LINESTYLEDOT
   tXYAxis.nDecimalDigits    = 0
   tXYAxis.sUnit             = ""
   tXYAxis.sText             = "First X axis"
   nRetVal = RMC_AddXAxisI(ID_RMC1, 1, &tXYAxis)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add first Y axis to region 1 *****************************
   tXYAxis.nAlignment        = RMC_YAXISLEFT
   tXYAxis.nMinValue         = 0
   tXYAxis.nMaxValue         = 100
   tXYAxis.nTickCount        = 11
   tXYAxis.nFontsize         = 8
   tXYAxis.nTextColor        = ColorBlue
   tXYAxis.nLineColor        = ColorBlue
   tXYAxis.nLineStyle        = RMC_LINESTYLEDOT
   tXYAxis.nDecimalDigits    = 0
   tXYAxis.sUnit             = ""
   tXYAxis.sText             = "First Y axis"
   nRetVal = RMC_AddYAxisI(ID_RMC1, 1, &tXYAxis)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add second X axis to region 1 *****************************
   tXYAxis.nAlignment        = RMC_XAXISTOP
   tXYAxis.nMinValue         = 0
   tXYAxis.nMaxValue         = 10
   tXYAxis.nTickCount        = 5
   tXYAxis.nFontsize         = 8
   tXYAxis.nTextColor        = ColorCoral
   tXYAxis.nLineColor        = ColorCoral
   tXYAxis.nLineStyle        = RMC_LINESTYLEDASH
   tXYAxis.nDecimalDigits    = 2
   tXYAxis.sUnit             = ""
   tXYAxis.sText             = "Second X axis"
   nRetVal = RMC_AddXAxisI(ID_RMC1, 1, &tXYAxis)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add second Y axis to region 1 *****************************
   tXYAxis.nAlignment        = RMC_YAXISRIGHT
   tXYAxis.nMinValue         = 0
   tXYAxis.nMaxValue         = 10
   tXYAxis.nTickCount        = 5
   tXYAxis.nFontsize         = 8
   tXYAxis.nTextColor        = ColorCoral
   tXYAxis.nLineColor        = ColorCoral
   tXYAxis.nLineStyle        = RMC_LINESTYLEDASH
   tXYAxis.nDecimalDigits    = 2
   tXYAxis.sUnit             = ""
   tXYAxis.sText             = "Second Y axis"
   nRetVal = RMC_AddYAxisI(ID_RMC1, 1, &tXYAxis)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Series 1 to region 1 *******************************
   tXYSeries.nColor        = ColorDarkBlue
   tXYSeries.nStyle        = RMC_XY_SYMBOL
   tXYSeries.nLineStyle    = 0
   tXYSeries.nSeriesSymbol = RMC_SYMBOL_BULLET
   tXYSeries.nWhichXAxis   = RMC_XAXISBOTTOM
   tXYSeries.nWhichYAxis   = RMC_YAXISLEFT
   tXYSeries.nValueLabelOn = RMC_VLABEL_NONE
   '****** Read X-data values ******
   REDIM aData[4] AS DOUBLE
   aData[0] = 20 : aData[1] = 30 : aData[2] = 60 : aData[3] = 70 : aData[4] = 90
   '****** Read Y-data values ******
   REDIM aData2[4] AS DOUBLE
   aData2[0] = 40 : aData2[1] = 20 : aData2[2] = 70 : aData2[3] = 10 : aData2[4] = 60
   nRetVal = RMC_AddXYSeriesI(ID_RMC1, 1, aData, 5,aData2,5,&tXYSeries)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Series 2 to region 1 *******************************
   tXYSeries.nColor        = ColorCoral
   tXYSeries.nStyle        = RMC_XY_SYMBOL
   tXYSeries.nLineStyle    = 0
   tXYSeries.nSeriesSymbol = RMC_SYMBOL_DIAMOND
   tXYSeries.nWhichXAxis   = RMC_XAXISTOP
   tXYSeries.nWhichYAxis   = RMC_YAXISRIGHT
   tXYSeries.nValueLabelOn = RMC_VLABEL_DEFAULT
   '****** Read X-data values ******
   REDIM aData[4] AS DOUBLE
   aData[0] = 2.5 : aData[1] = 4.5 : aData[2] = 5.5 : aData[3] = 7.5 : aData[4] = 1
   '****** Read Y-data values ******
   REDIM aData2[4] AS DOUBLE
   aData2[0] = 7.5 : aData2[1] = 5.5 : aData2[2] = 5.5 : aData2[3] = 2.5 : aData2[4] = 5
   nRetVal = RMC_AddXYSeriesI(ID_RMC1, 1, aData, 5,aData2,5,&tXYSeries)
   IF nRetVal < 0 THEN GOTO IsError

   nRetVal = RMC_SetWatermark(RMC_USERWM,RMC_USERWMCOLOR,RMC_USERWMLUCENT,RMC_USERWMALIGN,RMC_USERFONTSIZE)
   nRetVal = RMC_Draw(ID_RMC1)
   IF nRetVal < 0 THEN GOTO IsError
   EXIT SUB

   IsError:
END SUB

SUB FromFile(hParentDlg AS HWND)
   DIM nRetVal AS LONG

   '************** Create the chart **********************
   nRetVal = RMC_CreateChartFromFile(hParentDlg,ID_RMC1,10,10,FALSE,"4 regions.rmc")
   IF nRetVal < 0 THEN GOTO IsError

   nRetVal = RMC_SetWatermark(RMC_USERWM,RMC_USERWMCOLOR,RMC_USERWMLUCENT,RMC_USERWMALIGN,RMC_USERFONTSIZE)
   nRetVal = RMC_Draw(ID_RMC1)
   IF nRetVal < 0 THEN GOTO IsError

   EXIT SUB

   IsError:
END SUB

SUB FromString(hParentDlg AS HWND)
   DIM sTemp AS STRING * 5000
   DIM nRetVal AS LONG
   sTemp = sTemp + "00003650|00004450|000051|000061|000071|00008-6697831|00009400|00011Tahoma|100011"
    sTemp = sTemp + "|1000310|1000410|10005-5|10006-5|1000910|100101|100111|100121|100131|100181|1002"
    sTemp = sTemp + "00|100217|1002215|100238|100272|100331|100341|100358|100378|100411|100482|100492"
    sTemp = sTemp + "|10051-6751336|10052-15132304|10053-983041|100541|100558|10056-16777077|10057-16"
    sTemp = sTemp + "777077|100586|10060-16777077|10061-1468806|100622|10180data source: www.federalr"
    sTemp = sTemp + "eserve.gov + www.ecb.int|10181Prime Rates in USA und Euroland|10183%|101871999*"
    sTemp = sTemp + "2000*2001*2002*2003*2004*2005*2006|110011|1100221|110035|1100434|110052|110063|1"
    sTemp = sTemp + "10073|1100970|1101312|110171|11019-16744448|1102115|110221|1102396|110262|110521"
    sTemp = sTemp + "2|110534.75*4.75*4.75*4.75*4.75*5*5*5.25*5.25*5.25*5.5*5.5*5.5*5.75*6*6*6.5*6.5*"
    sTemp = sTemp + "6.5*6.5*6.5*6.5*6.5*6.5*5.5*5.5*5*4.5*4*3.75*3.75*3.5*3*2.5*2*1.75*1.75*1.75*1.7"
    sTemp = sTemp + "5*1.75*1.75*1.75*1.75*1.75*1.75*1.75*1.25*1.25*1.25*1.25*1.25*1.25*1.25*1*1*1*1*"
    sTemp = sTemp + "1*1*1*1*1*1*1*1*1*1*1.25*1.5*1.75*2*2.25*2.25*2.5*2.75*2.75*3*3.25*3.25*3.5*3.75"
    sTemp = sTemp + "*3.75*4*4.25*4.5*4.5*4.75*4.75*5*5.25*5.25*5.25*5.25*5.25*5.25*5.25|120011|12002"
    sTemp = sTemp + "21|120035|1200434|120052|120063|120073|1200950|1201312|120171|12019-2448096|1202"
    sTemp = sTemp + "115|120221|1202396|120262|1205212|120533*3*3*2.5*2.5*2.5*2.5*2.5*2.5*2.5*3*3*3*3"
    sTemp = sTemp + ".25*3.5*3.75*3.75*4.25*4.25*4.5*4.5*4.75*4.75*4.75*4.75*4.75*4.75*4.75*4.5*4.5*4"
    sTemp = sTemp + ".5*4.25*3.75*3.75*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3."
    sTemp = sTemp + "25*2.75*2.75*2.75*2.5*2.5*2.5*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*"
    sTemp = sTemp + "2*2*2*2*2*2.25*2.25*2.25*2.5*2.5*2.5*2.75*2.75*3*3*3.25*3.25*3.5|010011|010054|0"
    sTemp = sTemp + "100721|01014-16744448|010222|01024216*287|01025109*109|010272|010283|010012|0100"
    sTemp = sTemp + "51|01010295|01011102|010191|01026USA (Federal Funds Rate)|010013|010054|0100721|"
    sTemp = sTemp + "01014-10496|010222|01024260*287|01025192*192|010272|010283|010014|010051|0101029"
    sTemp = sTemp + "5|01011185|010191|01026Euroland (Prime Rate)"


   nRetVal = RMC_CreateChartFromFile(hParentDlg,ID_RMC1,10,10,0,sTemp)
   IF nRetVal < 0 THEN GOTO IsError

   nRetVal = RMC_SetWatermark(RMC_USERWM,RMC_USERWMCOLOR,RMC_USERWMLUCENT,RMC_USERWMALIGN,RMC_USERFONTSIZE)
   nRetVal = RMC_Draw(ID_RMC1)
   IF nRetVal < 0 THEN GOTO IsError
   EXIT SUB

   IsError:

END SUB

SUB SaveChart(hParentDlg AS HWND)
   DIM nRetVal AS LONG
   DIM sTemp AS STRING
   DIM DYNAMIC aData[0] AS DOUBLE
   DIM tChart AS tRMC_CHART
   DIM tRegion AS tRMC_REGION
   DIM tLegend AS tRMC_LEGEND
   DIM tGridlessSeries AS tRMC_GRIDLESSSERIES

   ' This example uses the long notation style (with UDTs) and sets
   ' only those properties, which shall differ from the defaults values.


   '************** Create the chart **********************
   tChart.nLeft        = 10
   tChart.nTop         = 10
   tChart.nWidth       = 600
   tChart.nHeight      = 450
   nRetVal = RMC_CreateChartI(hParentDlg, ID_RMC1, &tChart)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Region 1 *****************************
   nRetVal = RMC_AddRegionI(ID_RMC1, &tRegion)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add legend to region 1 *******************************
   tLegend.nLegendAlign    = RMC_LEGEND_CUSTOM_UL
   sTemp = "Apples*Bananas*Pears*Cherries"
   nRetVal = RMC_AddLegendI(ID_RMC1, 1, sTemp, &tLegend)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Series 1 to region 1 *******************************
   tGridlessSeries.nStyle        = RMC_PYRAMIDE3
   tGridlessSeries.nValueLabelOn = RMC_VLABEL_DEFAULT
   '****** Read data values ******
   REDIM aData[3] AS DOUBLE
   aData[0] = 30.25 : aData[1] = 26.75 : aData[2] = 15.89 : aData[3] = 46.23
   nRetVal = RMC_AddGridlessSeriesI(ID_RMC1,1, aData, 4,0,0, &tGridlessSeries)
   IF nRetVal < 0 THEN GOTO IsError

   nRetVal = RMC_SetWatermark(RMC_USERWM,RMC_USERWMCOLOR,RMC_USERWMLUCENT,RMC_USERWMALIGN,RMC_USERFONTSIZE)
   nRetVal = RMC_Draw2File(ID_RMC1,"Demo.png",0,0,0)
   IF nRetVal < 0 THEN GOTO IsError
   MSGBOX("Chart was saved as 'demo.png'")
   EXIT SUB

   IsError:

END SUB

''''''' Miscellaneous ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
FUNCTION Build_ScrollChart(hParentDlg AS HWND) AS LONG
   LOCAL i AS LONG
   LOCAL nC AS LONG
   LOCAL nRetVal AS LONG
   DIM DYNAMIC aPPC[0] AS LONG
   LOCAL tChart AS tRMC_CHART
   LOCAL tRegion AS tRMC_REGION
   LOCAL tCaption AS tRMC_CAPTION
   LOCAL tLegend AS tRMC_LEGEND
   LOCAL tGrid AS tRMC_GRID
   LOCAL tDataAxis AS tRMC_DATAAXIS
   LOCAL tLabelAxis AS tRMC_LABELAXIS
   LOCAL tBarSeries AS tRMC_BARSERIES
   LOCAL tLineSeries AS tRMC_LINESERIES

   ' This example shows, how you can change the data of a chart 'on the fly' without
   ' the necessarity of a complete rebuild of the chart.
   ' This function is only called once, from BEGIN EVENTS, before setting
   ' the initial data for the chart.
   ' The call to RMC_Draw for showing the chart also happens in BEGIN EVENTS,
   ' behind 'CASE ID_MSC1', after setting the first data set for the chart.
   ' When you scroll the chart, the chart gets refreshed with new data also
   ' in the Callback, behind 'CASE WM_VSCROLL'


   '************** Create the chart **********************
   tChart.nLeft        = 10
   tChart.nTop         = 10
   tChart.nWidth       = 650
   tChart.nHeight      = 500
   tChart.nBackColor   = ColorDarkTurquoise
   tChart.nCtrlStyle   = RMC_CTRLSTYLEFLAT
   nRetVal = RMC_CreateChartI(hParentDlg, ID_RMC1, &tChart)

   '************** Add Region 1 *****************************
   tRegion.nLeft       = 5
   tRegion.nTop        = 5
   tRegion.nWidth      = -5
   tRegion.nHeight     = -5
   tRegion.sFooter     = "data source: www.yahoo.com"
   tRegion.nShowBorder = FALSE
   nRetVal = RMC_AddRegionI(ID_RMC1, &tRegion)
   '************** Add caption to region 1 *******************
   tCaption.sText  =     "Dow Jones 2000 - 2005"
   tCaption.nBackColor = ColorDefault
   tCaption.nTextColor = ColorDefault
   tCaption.nFontSize  = 13
   tCaption.nIsBold    = TRUE
   nRetVal = RMC_AddCaptionI(ID_RMC1, 1, &tCaption)
   '************** Add grid to region 1 *****************************
   tGrid.nGridBackColor = ColorLightSkyBlue
   tGrid.nAsGradient    = TRUE
   tGrid.nLeft      = 0
   tGrid.nTop       = 0
   tGrid.nWidth     = 0
   tGrid.nHeight    = 0
   nRetVal = RMC_AddGridI(ID_RMC1, 1, &tGrid)
   '************** Add data axis to region 1 *****************************
   tDataAxis.nAlignment      = RMC_DATAAXISBOTTOM
   tDataAxis.nMinValue       = 7000
   tDataAxis.nMaxValue       = 12000
   tDataAxis.nTickCount      = 11
   tDataAxis.nFontsize       = 8
   tDataAxis.nTextColor      = ColorDefault
   tDataAxis.nLineColor      = ColorDefault
   tDataAxis.nLineStyle      = RMC_LINESTYLESOLID
   tDataAxis.nDecimalDigits  = 0
   tDataAxis.sUnit           = ""
   tDataAxis.sText           = "Closing Index (Line series)\11"
   nRetVal = RMC_AddDataAxisI(ID_RMC1, 1, &tDataAxis)
   '************** Add second data axis to region 1 *****************************
   tDataAxis.nAlignment      = RMC_DATAAXISTOP
   tDataAxis.nMinValue       = 0
   tDataAxis.nMaxValue       = 30000000
   tDataAxis.nDecimalDigits  = 0
   tDataAxis.sUnit           = ""
   tDataAxis.sText           = "Share volumes (Bar series)\11"
   nRetVal = RMC_AddDataAxisI(ID_RMC1, 1, &tDataAxis)
   '************** Add label axis to region 1 *****************************
   tLabelAxis.nCount         = 1
   tLabelAxis.nTickCount     = 21
   tLabelAxis.nAlignment     = RMC_LABELAXISLEFT
   tLabelAxis.nFontsize      = 8
   tLabelAxis.nTextColor     = ColorDefault
   tLabelAxis.nTextAlignment = RMC_TEXTCENTER
   tLabelAxis.nLineColor     = ColorDefault
   tLabelAxis.nLineStyle     = RMC_LINESTYLESOLID
   nRetVal = RMC_AddLabelAxisI(ID_RMC1, 1, "", &tLabelAxis)
   '************** Add Series 1 to region 1 *******************************
   tBarSeries.nType             = RMC_BARSINGLE
   tBarSeries.nStyle            = RMC_BAR_HOVER
   tBarSeries.nIsLucent         = FALSE
   tBarSeries.nColor            = ColorLightGoldenrod
   tBarSeries.nIsHorizontal     = TRUE
   tBarSeries.nWhichDataAxis    = 2
   tBarSeries.nValueLabelOn     = FALSE
   tBarSeries.nPointsPerColumn  = 1
   tBarSeries.nHatchMode        = RMC_HATCHBRUSH_OFF
   nRetVal = RMC_AddBarSeriesI(ID_RMC1, 1, 0,0, &tBarSeries)
   ' Data will be added later in the Callback, so we pass zero for the data and datacount
   '************** Add Series 2 to region 1 *******************************
   tLineSeries.nType             = RMC_LINE
   tLineSeries.nStyle            = RMC_LINE_FLAT
   tLineSeries.nLineStyle        = RMC_LSTYLE_LINE
   tLineSeries.nIsLucent         = FALSE
   tLineSeries.nColor            = ColorRed
   tLineSeries.nSeriesSymbol     = RMC_SYMBOL_POINT
   tLineSeries.nWhichDataAxis    = 1
   tLineSeries.nValueLabelOn     = FALSE
   tLineSeries.nHatchMode        = RMC_HATCHBRUSH_OFF
   nRetVal = RMC_AddLineSeriesI(ID_RMC1, 1, 0,0,0,0, &tLineSeries)
   ' Data will be added later in the Callback, so we pass zero for data and datacount

   FUNCTION = nRetVal

END FUNCTION
