' Thanks to Michael Henning, who ported
' this bcxmini.inc from
' the original PowerBASIC MiniDesigner file


GLOBAL nChangeData  AS LONG  ' for RMC_SetData() demonstration in the first line chart
GLOBAL nShowClone   AS LONG  ' for show/hide the cloned chart in MiniDesigner()
GLOBAL sih   AS SCROLLINFO
GLOBAL lScrH AS HWND
GLOBAL CurColors[10]


CONST ID_RMC1         = WM_USER+1024
CONST ID_EXPORT       = ID_RMC1+1
CONST ID_PRINT        = ID_RMC1+2
CONST ID_CLOSE        = ID_RMC1+3
CONST ID_GB1          = ID_RMC1+4
CONST ID_GB2          = ID_RMC1+5
CONST ID_GB3          = ID_RMC1+6
CONST ID_GB4          = ID_RMC1+7
CONST ID_GB5          = ID_RMC1+8
CONST ID_GB6          = ID_RMC1+9
CONST ID_GB7          = ID_RMC1+10
CONST ID_GB8          = ID_RMC1+11
CONST ID_GB9          = ID_RMC1+12
CONST ID_NGB1         = ID_RMC1+13
CONST ID_NGB2         = ID_RMC1+14
CONST ID_XY1          = ID_RMC1+20
CONST ID_XY2          = ID_RMC1+21
CONST ID_MSC1         = ID_RMC1+37
CONST ID_MSC2         = ID_RMC1+38
CONST ID_MSC3         = ID_RMC1+39
CONST ID_MSC4         = ID_RMC1+40
CONST ID_MSC5         = ID_RMC1+41
CONST ID_MSC6         = ID_RMC1+42
CONST ID_SCROLL       = ID_RMC1+60
CONST IDC_GRAPHIC1    = ID_RMC1+61
CONST ID_RMC2         = ID_RMC1+62
CONST ID_CB_COLOR     = ID_RMC1+63
CONST ID_CB_COLOROBJ  = ID_RMC1+64
CONST ID_OPT_H        = ID_RMC1+65
CONST ID_OPT_V        = ID_RMC1+66
CONST ID_OPT_FH       = ID_RMC1+67
CONST ID_OPT_SH       = ID_RMC1+68
CONST ID_CB_S1STYLE   = ID_RMC1+69
CONST ID_CB_S2STYLE   = ID_RMC1+71
CONST ID_CHK_S1HIDE   = ID_RMC1+72
CONST ID_CHK_S2HIDE   = ID_RMC1+73
CONST ID_CHK_S1VLABEL = ID_RMC1+74
CONST ID_CHK_S2VLABEL = ID_RMC1+75
CONST ID_CHK_LUCENT   = ID_RMC1+76
CONST ID_CB_LSTYLE    = ID_RMC1+77
CONST ID_CB_SYMBOLS   = ID_RMC1+78
CONST ID_LBL_LSTYLE   = ID_RMC1+79
CONST ID_LBL_SYMBOLS  = ID_RMC1+80
CONST ID_CHK_CLONE    = ID_RMC1+81
CONST ID_OPT_JPG      = ID_RMC1+82
CONST ID_OPT_EMF      = ID_RMC1+83
CONST ID_CMD_PRINT    = ID_RMC1+84
CONST ID_CMD_SAVE     = ID_RMC1+85
CONST ID_CMD_COPY     = ID_RMC1+86
CONST ID_INFO         = ID_RMC1+87
CONST ID_RMC3         = ID_RMC1+100


SUB MiniDesign(hWnd AS HWND)
   GLOBAL nDlgH,nDlgW
   nDlgW = 580
   nDlgH = 390
   BCX_MDIALOG(MDCallback, "RMChart Demo - MiniDesigner", hWnd, 10, 10, nDlgW, nDlgH, _
   WS_VISIBLE|DS_CENTER |WS_SYSMENU|WS_MINIMIZEBOX|WS_MAXIMIZEBOX|WS_CAPTION|WS_THICKFRAME|DS_SETFONT , _
   WS_EX_CONTROLPARENT,"ms sans serif",8)
END SUB

' *********************************** MiniDesigner *********************************************


SUB ShowMDInfo()
   DIM RAW sInfo$

   sInfo = "The important message of the 'MiniDesigner' is not," + $CRLF _
   +"what can be done with it, but how is it done. Play with" + $CRLF _
   +"it and have a look into the source, how it works. You can" + $CRLF _
   +"see mouse support in action and how easy it is to change the"  + $CRLF _
   +"properties of an existing chart. Maybe this gives you some" + $CRLF _
   +"ideas for your own work with RMChart."+ $CRLF+ $CRLF _
   +" - Change the properties of the chart"+ $CRLF _
   +" - Check/uncheck 'Show the cloned chart'"+ $CRLF _
   +" - Resize/Maximize the dialog"+ $CRLF _
   +" - Press the middle mouse button/ mouse wheel and move the upper chart"+ $CRLF _
   +" - Click with ctrl+left mouse button onto different parts of the upper chart"+ $CRLF _
   +" - Click and hold with left mouse button onto a bar and move up and down"+ $CRLF _
   +" - Click with the right mouse button into the grid of the upper chart"+ $CRLF _
   +" - Click with ctrl+right mouse button into the grid of the upper chart"+ $CRLF _
   +" - Click with shift+right mouse button into the grid of the upper chart"

   MSGBOX sInfo, "RMChart Demo", MB_OK BOR MB_ICONINFORMATION
END SUB


' Draws the upper and (if visible) the lower chart
SUB DrawCharts()
   LOCAL szTemp$
   RMC_Draw (ID_RMC2)                                  ' Draw the upper chart
   IF nShowClone THEN                                  ' if the lower chart is visible
      RMC_WriteRMCFile   (ID_RMC2, szTemp)             ' get the data string from the upper chart
      RMC_SetRMCFile     (ID_RMC3, szTemp)             ' Set the data string in the existent lower chart
      RMC_SetCaptionText (ID_RMC3, 1, "I'm the clone") ' change the caption from "I'm the original"
      RMC_Draw (ID_RMC3)                ' Draw the lower chart
   END IF
END SUB

' Callback function for the MiniDesigner, everything important happens here!
BEGIN MODAL DIALOG AS MDCallback

   STATIC nLBDN, nMBDN         ' for status of the Left and Middle mousebutton
   STATIC aData  AS DOUBLE PTR ' This a cheat for creating the aData array
   DIM RAW TINFO AS tRMC_INFO PTR

   SELECT CASE CBMSG
      CASE WM_INITDIALOG

      DIM RAW nCCount,i,nValue,sColor$
      DIM RAW nX=10, nY=10

      BCX_GROUP   ("Change the color", hWnd, 10000         , nX   , nY   , 170, 50)
      BCX_LABEL   ("Object"          , hWnd, 10001         , nX+5 , nY+12, 30 , 10)
      BCX_LABEL   ("Color"           , hWnd, 10002         , nX+5 , nY+32, 30 , 10)
      BCX_COMBOBOX(""                , hWnd, ID_CB_COLOROBJ, nX+40, nY+10, 110, 120)
      BCX_COMBOBOX(""                , hWnd, ID_CB_COLOR   , nX+40, nY+30, 110, 120)

      nShowClone = 0

      nCCount = ReadColors(-1, 0, sColor$)
      FOR i = 0 TO nCCount-1
         nValue = ReadColors(0, i, sColor$)
         COMBOADDLINE (hWnd,ID_CB_COLOR, sColor$, nValue)
      NEXT
      COMBOSETINDEXDATA( hWnd,ID_CB_COLOR, ColorCornflowerBlue)
      COMBOADDLINE (hWnd,ID_CB_COLOROBJ,"Control BGColor",1)
      COMBOADDLINE (hWnd,ID_CB_COLOROBJ,"Caption BGColor",2)
      COMBOADDLINE (hWnd,ID_CB_COLOROBJ,"Caption TextColor",3)
      COMBOADDLINE (hWnd,ID_CB_COLOROBJ,"Grid BGColor",4)
      COMBOADDLINE (hWnd,ID_CB_COLOROBJ,"DataAxis TextColor",5)
      COMBOADDLINE (hWnd,ID_CB_COLOROBJ,"DataAxis LineColor",6)
      COMBOADDLINE (hWnd,ID_CB_COLOROBJ,"LabelAxis TextColor",7)
      COMBOADDLINE (hWnd,ID_CB_COLOROBJ,"LabelAxis LineColor",8)
      COMBOADDLINE (hWnd,ID_CB_COLOROBJ,"Color of series 1",9)
      COMBOADDLINE (hWnd,ID_CB_COLOROBJ,"Color of series 2",10)
      COMBOSETINDEXDATA( hWnd,ID_CB_COLOROBJ,1)

      nY = 65
      BCX_GROUP( "Change chart's orientation", hWnd, 10000, nX,nY,170,25)
      MODSTYLE( _
      BCX_RADIO("Horizontal", hWnd, ID_OPT_H, nX+5 , nY+8, 60, 14), WS_GROUP)
      BCX_RADIO("Vertical"  , hWnd, ID_OPT_V, nX+80, nY+8, 60, 14)
      CheckSet(hWnd,ID_OPT_V,1)

      nY = 95
      BCX_GROUP( "Choose the period", hWnd, 10000, nX,nY,170,25)
      MODSTYLE( _
      BCX_RADIO( "First half of year", hWnd, ID_OPT_FH,  nX+5,nY+8,70, 14),WS_GROUP)
      BCX_RADIO( "Second half of year", hWnd, ID_OPT_SH, nX+80, nY+8, 80, 14)
      CheckSet(hWnd,ID_OPT_FH,1)

      nY = 125
      BCX_GROUP( "Series 1 (Bars)", hWnd, 10000, nX,nY,170,70)
      BCX_LABEL( "Style", hWnd, 10001, nX+5,nY+12,30,10)
      BCX_COMBOBOX("", hWnd, ID_CB_S1STYLE,nX+40,nY+10,110,120)
      COMBOADDLINE (hWnd,ID_CB_S1STYLE,"Flat",RMC_BAR_FLAT)
      COMBOADDLINE (hWnd,ID_CB_S1STYLE,"Flat, gradient style 1",RMC_BAR_FLAT_GRADIENT1)
      COMBOADDLINE (hWnd,ID_CB_S1STYLE,"Flat, gradient style 2",RMC_BAR_FLAT_GRADIENT2)
      COMBOADDLINE (hWnd,ID_CB_S1STYLE,"Hover",RMC_BAR_HOVER)
      COMBOADDLINE (hWnd,ID_CB_S1STYLE,"3D",RMC_BAR_3D)
      COMBOADDLINE (hWnd,ID_CB_S1STYLE,"3D, gradient style",RMC_BAR_3D_GRADIENT)
      COMBOADDLINE (hWnd,ID_CB_S1STYLE,"Column flat",RMC_COLUMN_FLAT)
      COMBOADDLINE (hWnd,ID_CB_S1STYLE,"Column 3D",RMC_COLUMN_3D)
      COMBOADDLINE (hWnd,ID_CB_S1STYLE,"Column 3D, gradient style",RMC_COLUMN_3D_GRADIENT)
      COMBOSETINDEXDATA (hWnd,ID_CB_S1STYLE,RMC_BAR_FLAT_GRADIENT2)
      BCX_CHECKBOX("Transparency on" , hWnd, ID_CHK_LUCENT  , nX+5, nY+30, 70, 11)
      BCX_CHECKBOX("Show value label", hWnd, ID_CHK_S1VLABEL, nX+5, nY+43, 70, 11)
      BCX_CHECKBOX("Hide series"     , hWnd, ID_CHK_S1HIDE  , nX+5, nY+56, 70, 11)

      nY = 200
      BCX_GROUP   ("Series 2 (Line)", hWnd, 10000        , nX   , nY   , 170, 77)
      BCX_LABEL   ("Style"   , hWnd, 10001        , nX+5 , nY+12, 30 , 10)
      BCX_COMBOBOX(""        , hWnd, ID_CB_S2STYLE, nX+40, nY+10, 110, 120)
      COMBOADDLINE (hWnd,ID_CB_S2STYLE,"Flat Solid",RMC_LINE_FLAT)
      COMBOADDLINE (hWnd,ID_CB_S2STYLE,"Flat Dot",RMC_LINE_FLAT_DOT)
      COMBOADDLINE (hWnd,ID_CB_S2STYLE,"Flat Dash",RMC_LINE_FLAT_DASH)
      COMBOADDLINE (hWnd,ID_CB_S2STYLE,"Flat DashDot",RMC_LINE_FLAT_DASHDOT)
      COMBOADDLINE (hWnd,ID_CB_S2STYLE,"Flat DashDotDot",RMC_LINE_FLAT_DASHDOTDOT)
      COMBOADDLINE (hWnd,ID_CB_S2STYLE,"Cable",RMC_LINE_CABLE)
      COMBOADDLINE (hWnd,ID_CB_S2STYLE,"Cable with shadow",RMC_LINE_CABLE_SHADOW)
      'COMBOADDLINE (hWnd,ID_CB_S2STYLE,"No line, only symbols",RMC_LINE_SYMBOLONLY)
      COMBOADDLINE (hWnd,ID_CB_S2STYLE,"3D",RMC_LINE_3D)
      COMBOADDLINE (hWnd,ID_CB_S2STYLE,"3D, gradient style",RMC_LINE_3D_GRADIENT)
      COMBOSETINDEXDATA( hWnd,ID_CB_S2STYLE,RMC_LINE_CABLE)
      BCX_LABEL   ("Symbols", hWnd, ID_LBL_SYMBOLS, nX+5 , nY+30, 30 , 10)
      BCX_COMBOBOX(""       , hWnd, ID_CB_SYMBOLS , nX+40, nY+28, 110, 120)
      COMBOADDLINE (hWnd, ID_CB_SYMBOLS,"No symbol", RMC_SYMBOL_NONE)
      COMBOADDLINE (hWnd, ID_CB_SYMBOLS,"Bullet", RMC_SYMBOL_BULLET)
      COMBOADDLINE (hWnd, ID_CB_SYMBOLS,"Point", RMC_SYMBOL_POINT)
      COMBOADDLINE (hWnd, ID_CB_SYMBOLS,"Diamond", RMC_SYMBOL_DIAMOND)
      COMBOADDLINE (hWnd, ID_CB_SYMBOLS,"Square", RMC_SYMBOL_SQUARE)
      COMBOADDLINE (hWnd, ID_CB_SYMBOLS,"Star", RMC_SYMBOL_STAR)
      COMBOADDLINE (hWnd, ID_CB_SYMBOLS,"Arrow down", RMC_SYMBOL_ARROW_DOWN)
      COMBOADDLINE (hWnd, ID_CB_SYMBOLS,"Arrow up", RMC_SYMBOL_ARROW_UP)
      COMBOADDLINE (hWnd, ID_CB_SYMBOLS,"Circle", RMC_SYMBOL_CIRCLE)
      COMBOADDLINE (hWnd, ID_CB_SYMBOLS,"Rectangle", RMC_SYMBOL_RECTANGLE)
      COMBOADDLINE (hWnd, ID_CB_SYMBOLS,"Cross", RMC_SYMBOL_CROSS)
      COMBOADDLINE (hWnd, ID_CB_SYMBOLS,"Bullet small", RMC_SYMBOL_BULLET_SMALL)
      COMBOADDLINE (hWnd, ID_CB_SYMBOLS,"Point small", RMC_SYMBOL_POINT_SMALL)
      COMBOADDLINE (hWnd, ID_CB_SYMBOLS,"Diamond small", RMC_SYMBOL_DIAMOND_SMALL)
      COMBOADDLINE (hWnd, ID_CB_SYMBOLS,"Square small", RMC_SYMBOL_SQUARE_SMALL)
      COMBOADDLINE (hWnd, ID_CB_SYMBOLS,"Star small", RMC_SYMBOL_STAR_SMALL)
      COMBOADDLINE (hWnd, ID_CB_SYMBOLS,"Arrow down small", RMC_SYMBOL_ARROW_DOWN_SMALL)
      COMBOADDLINE (hWnd, ID_CB_SYMBOLS,"Arrow up small", RMC_SYMBOL_ARROW_UP_SMALL)
      COMBOADDLINE (hWnd, ID_CB_SYMBOLS,"Circle small", RMC_SYMBOL_CIRCLE_SMALL)
      COMBOADDLINE (hWnd, ID_CB_SYMBOLS,"Rectangle small", RMC_SYMBOL_RECTANGLE_SMALL)
      COMBOADDLINE (hWnd, ID_CB_SYMBOLS,"Cross small", RMC_SYMBOL_CROSS_SMALL)
      COMBOSETINDEXDATA( hWnd,ID_CB_SYMBOLS,RMC_SYMBOL_BULLET)

      BCX_CHECKBOX("Show value label", hWnd, ID_CHK_S2VLABEL, nX+5, nY+50, 70, 11)
      CheckSet(hWnd, ID_CHK_S2VLABEL, 1)
      BCX_CHECKBOX("Hide series"     , hWnd, ID_CHK_S2HIDE  , nX+5, nY+63, 70, 11)

      nY = 282
      BCX_GROUP( "Show/Hide second chart", hWnd, 10000, nX,nY,170,25)
      BCX_CHECKBOX("Show the cloned chart", hWnd,ID_CHK_CLONE,nX+5,nY+9,120,11)

      nY = 312
      BCX_GROUP( "Print/Save/Copy to Clipboard the upper chart",hWnd, 10000, nX,nY,170,50)
      MODSTYLE( _
      BCX_RADIO ("As Bitmap"  , hWnd      , ID_OPT_JPG  , nX+5  , nY+8 , 70, 14),WS_GROUP)
      BCX_RADIO ("As EMF"     , hWnd      , ID_OPT_EMF  , nX+80 , nY+8 , 80, 14)
      CheckSet(hWnd,ID_OPT_JPG,1)

      BCX_BUTTON("&Print"     , hWnd      , ID_CMD_PRINT, nX+5  , nY+25, 50, 15)
      BCX_BUTTON("&Save"      , hWnd      , ID_CMD_SAVE , nX+60 , nY+25, 50, 15)
      BCX_BUTTON("&Copy"      , hWnd      , ID_CMD_COPY , nX+115, nY+25, 50, 15)
      BCX_BUTTON("&Help"      , hWnd      , ID_INFO     , nX    , 367  , 50, 15)
      BCX_BUTTON("&End"       , hWnd      , ID_CLOSE    , nX+55 , 367  , 50, 15)

      DoTheChart (hWnd)

      CASE WM_CREATE
      nLBDN = 0
      
      CASE WM_SIZE
      DIM RAW x, y
      x = LOWORD(CBLPARAM) : y = HIWORD(CBLPARAM)
      ' set the size of the upper chart, dependend on status of flag 'nShowClone'
      RMC_SetCtrlSize (ID_RMC2,x-320,y-80 - IIF(nShowClone,y/2-40,0),0)
      IF nShowClone THEN ' if the lower chart is visible
         ' set the lower chart size ...
         RMC_SetCtrlSize (ID_RMC3,x-320,(y-40) - (y/2),0)
         ' ... and position
         RMC_SetCtrlPos (ID_RMC3,300,(y/2),0)
      END IF
      
      CASE WM_COMMAND
      DIM RAW x,y
      SELECT CASE CBCTL                   ' select which control sends a message
         CASE ID_CB_COLOROBJ
         IF CBCTLMSG = CBN_SELCHANGE THEN
            x = COMBOGETSELDATA(CBHNDL,ID_CB_COLOROBJ)  ' Index of the selected object
            COMBOSETINDEXDATA(CBHNDL,ID_CB_COLOR,CurColors[x-1])
         END IF
         CASE ID_CB_COLOR', ID_CB_COLOROBJ ' Color object and Color comboboxes
         IF CBCTLMSG = CBN_SELCHANGE THEN
            x = COMBOGETSELDATA(CBHNDL,ID_CB_COLOROBJ)  ' Index of the selected object
            y = COMBOGETSELDATA(CBHNDL,ID_CB_COLOR)     ' Index of selected color
            CurColors[x-1] = y                          ' Match color to object
            SELECT CASE x                               ' select the object and set the
               CASE 1  ' Control BGColor                ' color with the appropriate function
               RMC_SetCtrlBGColor (ID_RMC2,y)
               CASE 2  ' Caption BGColor
               RMC_SetCaptionBGColor (ID_RMC2,1,y)
               CASE 3  ' Caption TextColor
               RMC_SetCaptionTextColor (ID_RMC2,1,y)
               CASE 4  ' Grid Color
               RMC_SetGridBGColor (ID_RMC2,1,y)
               CASE 5  ' DataAxis TextColor
               RMC_SetDAXTextColor (ID_RMC2,1,y)
               CASE 6  ' DataAxis LineColor
               RMC_SetDAXLineColor (ID_RMC2,1,y)
               CASE 7  ' LabelAxis TextColor
               RMC_SetLAXTextColor (ID_RMC2,1,y)
               CASE 8  ' LabelAxis LineColor
               RMC_SetLAXLineColor (ID_RMC2,1,y)
               CASE 9  ' Color of series 1
               RMC_SetSeriesColor (ID_RMC2,1,1,y,0)
               CASE 10  ' Color of series 2
               RMC_SetSeriesColor (ID_RMC2,1,2,y,0)
            END SELECT
            CALL DrawCharts
         END IF
         
         CASE ID_OPT_H,ID_OPT_V            ' Horizontal or Vertical
         IF CBCTLMSG = BN_CLICKED THEN
            x = OptGet(CBHNDL,ID_OPT_H,ID_OPT_V)
            IF x = ID_OPT_H THEN                  ' Horizontal
               RMC_SetDAXAlignment (ID_RMC2,1,RMC_DATAAXISBOTTOM)  ' first dataaxis bottom
               ' alignment of second data axis and label axis gets adjusted automatically
               RMC_SetSeriesVertical (ID_RMC2,1,1,FALSE)            ' series 1 horizontal
               RMC_SetSeriesVertical (ID_RMC2,1,2,FALSE)            ' series 2 horizontal
            ELSE                                   ' Vertical
               RMC_SetDAXAlignment (ID_RMC2,1,RMC_DATAAXISLEFT)   ' first dataaxis left
               ' alignment of second data axis and label axis gets adjusted automatically
               RMC_SetSeriesVertical (ID_RMC2,1,1,TRUE)             ' series 1 vertical
               RMC_SetSeriesVertical (ID_RMC2,1,2,TRUE )            ' series 2 vertical
            END IF
            CALL DrawCharts
         END IF
         CASE ID_OPT_FH,ID_OPT_SH        ' First half or second half
         IF CBCTLMSG = BN_CLICKED THEN
            x = OptGet(CBHNDL,ID_OPT_FH,ID_OPT_SH)
            IF x = ID_OPT_FH THEN                   ' first half of the year
               REDIM aData[6]
               aData[0] = 150 : aData[1] = 300 : aData[2] = 200 : aData[3] = 400 : aData[4] = 600 : aData[5] = 800
               ' Set new data for the first series
               RMC_SetSeriesData (ID_RMC2,1,1,aData,6,0)
               aData[0] = 8.9 : aData[1] = 4.1 : aData[2] = 3.88 : aData[3] = 2.1 : aData[4] = 1.3 : aData[5] = 4.3
               ' Set new data for the second series
               RMC_SetSeriesData (ID_RMC2,1,2,aData,6,0)
               ' Set new labels
               RMC_SetLAXLabels (ID_RMC2,1,"January*February*March*April*May*June")
            ELSE
               REDIM aData[6]
               aData[0] = 700 : aData[1] = 450 : aData[2] = 380 : aData[3] = 520 : aData[4] = 610 : aData[5] = 420
               ' Set new data for the first series
               RMC_SetSeriesData (ID_RMC2,1,1,aData,6,0)
               aData[0] = 1.9 : aData[1] = 3.8 : aData[2] = 5.2 : aData[3] = 7.4 : aData[4] = 4.5 : aData[5] = 2.3
               ' Set new data for the second series
               RMC_SetSeriesData (ID_RMC2,1,2,aData,6,0)
               ' Set new labels
               RMC_SetLAXLabels (ID_RMC2,1,"July*August*September*October*November*December")
            END IF
            CALL DrawCharts
         END IF
         CASE ID_CB_S1STYLE,ID_CB_S2STYLE ' Style for series 1 and 2
         IF CBCTLMSG = CBN_SELCHANGE THEN
            x = COMBOGETSELDATA(CBHNDL,CBCTL)  ' Get the index of the selected object
            IF CBCTL = ID_CB_S1STYLE THEN
               RMC_SetSeriesStyle (ID_RMC2,1,1,x)  ' Set style for series 1
            ELSE
               RMC_SetSeriesStyle (ID_RMC2,1,2,x)  ' Set style for series 2
            END IF
            CALL DrawCharts
         END IF
         CASE ID_CHK_LUCENT ' Transparency on/off for series 1
         RMC_SetSeriesLucent (ID_RMC2,1,1,CheckGet(CBHNDL,ID_CHK_LUCENT))
         CALL DrawCharts
         CASE ID_CHK_S1VLABEL,ID_CHK_S2VLABEL ' Valuelabel on/off for series 1 or 2
         RMC_SetSeriesValuelabel (ID_RMC2,1,IIF(CBCTL=ID_CHK_S1VLABEL,1,2),CheckGet(CBHNDL,CBCTL))
         CALL DrawCharts
         CASE ID_CHK_S1HIDE, ID_CHK_S2HIDE  ' Hide/show series 1 or 2
         RMC_SetSeriesHide (ID_RMC2,1,IIF(CBCTL=ID_CHK_S1HIDE,1,2),CheckGet(CBHNDL,CBCTL))
         CALL DrawCharts
         CASE ID_CB_SYMBOLS ' Symbols for series 2
         IF CBCTLMSG = CBN_SELCHANGE THEN
            RMC_SetSeriesSymbol (ID_RMC2,1,2,COMBOGETSELDATA(CBHNDL,CBCTL))
            CALL DrawCharts
         END IF

         CASE ID_CHK_CLONE     ' Show or hide the lower chart
         DIM RAW tRect AS RECT
         nShowClone = CheckGet(CBHNDL,ID_CHK_CLONE)  ' Get the status
         GetClientRect (CBHNDL,&tRect)               ' Get client rect
         ' set the size of the upper chart, dependent on status of flag 'nShowClone'
         RMC_SetCtrlSize (ID_RMC2,tRect.right-320,(tRect.bottom-80) - IIF(nShowClone,(tRect.bottom/2)-40,0),0)
         IF nShowClone THEN    ' if the lower chart is visible
                               ' set the lower chart size ...
            CALL DrawCharts    ' Draw both charts
            RMC_SetCtrlSize (ID_RMC3,tRect.right-320,(tRect.bottom-40) - (tRect.bottom/2),0) ' set the size for the lower chart
                               ' Make the lower chart visible
            RMC_SetCtrlPos (ID_RMC3,300,tRect.bottom/2,0)
         ELSE                  ' if the lower chart is not visible
            RMC_SetCtrlPos (ID_RMC3,-2000,-2000,0)  ' make it invisible (shift it's position out of the Window)
         END IF

         CASE ID_CMD_PRINT
         x = OptGet(CBHNDL,ID_OPT_JPG,ID_OPT_EMF)
         RMC_Draw2Printer (ID_RMC2,0,25,25,150,110,IIF(x=ID_OPT_JPG,RMC_BMP,RMC_EMF))
         CASE ID_CMD_SAVE
         x = OptGet(CBHNDL,ID_OPT_JPG,ID_OPT_EMF)
         RMC_Draw2File (ID_RMC2,"MiniDesigner." + IIF$(x=ID_OPT_JPG,"jpg","emf"),0,0,0)
         CASE ID_CMD_COPY
         x = OptGet(CBHNDL,ID_OPT_JPG,ID_OPT_EMF)
         RMC_Draw2Clipboard (ID_RMC2,IIF(x=ID_OPT_JPG,RMC_BMP,RMC_EMF))
         CASE ID_CLOSE
         CLOSEDIALOG
         CASE ID_INFO
         CALL ShowMDInfo

         CASE ID_RMC2           ' the upper chart sends a message
         SELECT CASE CBCTLMSG   ' which message
            CASE RMC_CTRLLBUTTONDOWN     ' Ctrl-Left mousebutton clicked
            TINFO = (tRMC_INFO*)CBLPARAM ' lParam holds a pointer to a tRMC_INFO structure
            ShowInfo (TINFO)      ' Show the content of this structure
            CASE RMC_LBUTTONDOWN  ' left mousebutton pressed
            nLBDN = 1          ' set the flag for the first series (see RMC_MOUSEMOVE)
            CASE RMC_LBUTTONUP    ' left mousebutton unpressed
            nLBDN = 0          ' remove the flag
            CASE RMC_MBUTTONDOWN  ' Middle mousebutton pressed
            nMBDN = 1          ' set the flag for moving the chart (see RMC_MOUSEMOVE)
            CASE RMC_MBUTTONUP    ' Middle mousebutton unpressed
            nMBDN = 0          ' remove the flag
            CASE RMC_RBUTTONDOWN  ' right mousebutton pressed
            TINFO = (tRMC_INFO*)CBLPARAM ' lParam holds a pointer to a tRMC_INFO structure
            IF TINFO->nGCol > 0 THEN
               ' Set the "virtual" data for the second series (line); nDataIndex == TINFO->nGCol
               RMC_SetSeriesSingleData (ID_RMC2,1,2,TINFO->nVirtData2,TINFO->nGCol,0)
               CALL DrawCharts
            END IF
            CASE RMC_SHIFTRBUTTONDOWN
            TINFO = (tRMC_INFO*)CBLPARAM
            IF TINFO->nGCol > 0 THEN  ' if clicked into a grid column
               RMC_SetSeriesColor (ID_RMC2,1,1,ColorRed,TINFO->nGCol) ' change the color for this bar
               CALL DrawCharts
            END IF
            CASE RMC_CTRLRBUTTONDOWN
            TINFO = (tRMC_INFO*)CBLPARAM
            IF TINFO->nGCol > 0 THEN  ' if clicked into a grid column
               RMC_SetSeriesColor (ID_RMC2,1,1,ColorGold,TINFO->nGCol) ' change the color for this bar
               CALL DrawCharts
            END IF
            CASE RMC_MOUSEMOVE    ' moving the mouse over the chart
            TINFO = (tRMC_INFO*)CBLPARAM  ' lParam holds a pointer to a tRMC_INFO structure
            IF nLBDN THEN         ' if left mousebutton is pressed
               IF TINFO->nGCol > 0 THEN ' If the GridCol member of TINFO holds a valid value
                  ' Set the "virtual" data for the first series (bars); nDataIndex == GridColIndex
                  RMC_SetSeriesSingleData (ID_RMC2,1,1,TINFO->nVirtData1,TINFO->nGCol,0)
                  CALL DrawCharts ' Draw the upper and the lower chart
               END IF
            END IF
            IF nMBDN THEN  ' If Middle mousebutton is pressed
               RMC_SetCtrlPos (ID_RMC2,TINFO->nXMove,TINFO->nYMove,1) ' Move the chart
            END IF
         END SELECT
      END SELECT
   END SELECT
END FUNCTION

' Create the chart initially
SUB DoTheChart( hParent AS HWND)
   LOCAL i AS LONG
   LOCAL nC AS LONG
   LOCAL nDataCount AS LONG
   LOCAL nRetVal AS LONG
   LOCAL sTemp AS STRING
   LOCAL szTemp$
   DIM DYNAMIC aData[0]  AS DOUBLE
   DIM DYNAMIC aData2[0] AS DOUBLE
   DIM DYNAMIC aPPC[0]   AS LONG
   DIM DYNAMIC aColor[0] AS LONG
   LOCAL tRect AS RECT
   
   CurColors[0] = ColorCornflowerBlue    'Control BGColor
   CurColors[1] = ColorCoral             'Caption BGColor
   CurColors[2] = ColorFloralWhite       'Caption TextColor
   CurColors[3] = ColorAzure             'Grid BGColor
   CurColors[4] = ColorCornsilk          'DataAxis TextColor
   CurColors[5] = ColorBlack             'DataAxis LineColor
   CurColors[6] = ColorCornsilk          'LabelAxis TextColor
   CurColors[7] = ColorBlack             'LabelAxis LineColor
   CurColors[8] = ColorGold              'Color of series 1
   CurColors[9] = ColorGreen             'Color of series 2

   GetClientRect (hParent,&tRect)

   '************** Create the chart **********************
   nRetVal = RMC_CreateChart(hParent,ID_RMC2,300,10,tRect.right-320,tRect.bottom-80,ColorCornflowerBlue,RMC_CTRLSTYLEFLAT,FALSE,"","Tahoma",0,0)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Region 1 *****************************
   nRetVal = RMC_AddRegion(ID_RMC2,5,5,-5,-5,"this is the footer",FALSE)
   IF nRetVal < 0 THEN GOTO IsError

   '************** Add caption to region 1 *******************
   nRetVal = RMC_AddCaption(ID_RMC2,1,"I'm the original",ColorCoral,ColorFloralWhite,12,TRUE)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add grid to region 1 *****************************
   nRetVal = RMC_AddGrid(ID_RMC2,1,ColorAzure,TRUE,0,0,0,0,0)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add data axis to region 1 *****************************
   nRetVal = RMC_AddDataAxis(ID_RMC2,1,RMC_DATAAXISLEFT,0,1000,11,9,ColorCornsilk,ColorBlack,RMC_LINESTYLESOLID,0,"","","",0)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add second data axis to region 1 *****************************
   nRetVal = RMC_AddDataAxis(ID_RMC2,1,RMC_DATAAXISRIGHT,0,9.7,0,0,0,0,0,2,"%","","",0)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add label axis to region 1 *****************************
   szTemp =         "January*February*March*April*May*June"
   nRetVal = RMC_AddLabelAxis(ID_RMC2,1, szTemp,1,6,RMC_LABELAXISBOTTOM,8,ColorCornsilk,RMC_TEXTCENTER,ColorBlack,RMC_LINESTYLESOLID,"")
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Series 1 to region 1 *******************************
   '****** Read data values ******
   REDIM aData[6]
   aData[0] = 150 : aData[1] = 300 : aData[2] = 200 : aData[3] = 400 : aData[4] = 600 : aData[5] = 800
   nRetVal = RMC_AddBarSeries(ID_RMC2,1,aData, 6,RMC_BARSINGLE,RMC_BAR_FLAT_GRADIENT2,FALSE,ColorGold,FALSE,1,RMC_VLABEL_NONE,1,RMC_HATCHBRUSH_OFF)
   IF nRetVal < 0 THEN GOTO IsError
   '************** Add Series 2 to region 1 *******************************
   '****** Read data values ******
   REDIM aData[6]
   aData[0] = 8.9 : aData[1] = 4.1 : aData[2] = 3.88 : aData[3] = 2.1 : aData[4] = 1.3 : aData[5] = 4.3
   nRetVal = RMC_AddLineSeries(ID_RMC2,1, aData, 6,0,0,RMC_LINE,RMC_LINE_CABLE,RMC_LSTYLE_LINE,FALSE, _
   ColorGreen,RMC_SYMBOL_BULLET,2,RMC_VLABEL_DEFAULT,RMC_HATCHBRUSH_OFF)
   IF nRetVal < 0 THEN GOTO IsError
   ' Draw the upper chart initially
   nRetVal = RMC_Draw(ID_RMC2)
   IF nRetVal < 0 THEN GOTO IsError

   szTemp = ""
   RMC_WriteRMCFile (ID_RMC2,szTemp)  ' Get the data string from the upper chart for cloning
   RMC_CreateChartFromFile (hParent,ID_RMC3,300,315,0,szTemp) ' Create a new chart from the data string of the upper chart

   ' Don't Draw() the chart, because at this moment the appropriate checkbox in the dialog is not checked

   EXIT SUB
   IsError:
END SUB


FUNCTION ReadColors(BYVAL nMode AS LONG, BYVAL nIndex AS LONG, sName AS STRING) AS LONG
   DIM i AS LONG
   DATA ColorAliceBlue=0xFFF0F8FF,ColorAntiqueWhite=0xFFFAEBD7,ColorAquamarine=0xFF7FFFD4,ColorArmyGreen=0xFF669966
   DATA ColorAutumnOrange=0xFFFF6633,ColorAvocadoGreen=0xFF669933,ColorAzure=0xFFF0FFFF,ColorBabyBlue=0xFF6699FF
   DATA ColorBananaYellow=0xFFCCCC33,ColorBeige=0xFFF5F5DC,ColorBisque=0xFFFFE4C4,ColorBlack=0xFF000000
   DATA ColorBlanchedAlmond=0xFFFFEBCD,ColorBlue=0xFF0000FF,ColorBlueViolet=0xFF8A2BE2,ColorBrown=0xFFA52A2A
   DATA ColorBurlyWood=0xFFDEB887,ColorCadetBlue=0xFF5F9EA0,ColorChalk=0xFFFFFF99,ColorChartreuse=0xFF7FFF00
   DATA ColorChocolate=0xFFD2691E,ColorCoral=0xFFFF7F50,ColorCornflowerBlue=0xFF6495ED,ColorCornsilk=0xFFFFF8DC
   DATA ColorCrimson=0xFFDC143C,ColorCyan=0xFF00FFFF,ColorDarkBlue=0xFF00008B,ColorDarkBrown=0xFF663333
   DATA ColorDarkCrimson=0xFF993366,ColorDarkCyan=0xFF008B8B,ColorDarkGold=0xFFCC9933,ColorDarkGoldenrod=0xFFB8860B
   DATA ColorDarkGray=0xFFA9A9A9,ColorDarkGreen=0xFF006400,ColorDarkKhaki=0xFFBDB76B,ColorDarkMagenta=0xFF8B008B
   DATA ColorDarkOliveGreen=0xFF556B2F,ColorDarkOrange=0xFFFF8C00,ColorDarkOrchid=0xFF9932CC,ColorDarkRed=0xFF8B0000
   DATA ColorDarkSalmon=0xFFE9967A,ColorDarkSeaGreen=0xFF8FBC8B,ColorDarkSlateBlue=0xFF483D8B,ColorDarkSlateGray=0xFF2F4F4F
   DATA ColorDarkTurquoise=0xFF00CED1,ColorDarkViolet=0xFF9400D3,ColorDeepAzure=0xFF6633FF,ColorDeepPink=0xFFFF1493
   DATA ColorDeepPurple=0xFF330066,ColorDeepRiver=0xFF6600CC,ColorDeepRose=0xFFCC3399,ColorDeepSkyBlue=0xFF00BFFF
   DATA ColorDefault=0,ColorDeepYellow=0xFFFFCC00,ColorDesertBlue=0xFF336699,ColorDimGray=0xFF696969,ColorDodgerBlue=0xFF1E90FF
   DATA ColorDullGreen=0xFF99CC66,ColorEasterPurple=0xFFCC99FF,ColorFadeGreen=0xFF99CC99,ColorFirebrick=0xFFB22222
   DATA ColorFloralWhite=0xFFFFFAF0,ColorForestGreen=0xFF228B22,ColorGainsboro=0xFFDCDCDC,ColorGhostGreen=0xFFCCFFCC
   DATA ColorGhostWhite=0xFFF8F8FF,ColorGold=0xFFFFD700,ColorGoldenrod=0xFFDAA520,ColorGrape=0xFF663399
   DATA ColorGrassGreen=0xFF009933,ColorGray=0xFF808080,ColorGreen=0xFF008000,ColorGreenYellow=0xFFADFF2F
   DATA ColorHoneydew=0xFFF0FFF0,ColorHotPink=0xFFFF69B4,ColorIndianRed=0xFFCD5C5C,ColorIndigo=0xFF4B0082
   DATA ColorIvory=0xFFFFFFF0,ColorKentuckyGreen=0xFF339966,ColorKhaki=0xFFF0E68C,ColorLavender=0xFFE6E6FA
   DATA ColorLavenderBlush=0xFFFFF0F5,ColorLawnGreen=0xFF7CFC00,ColorLemonChiffon=0xFFFFFACD,ColorLightBlue=0xFFADD8E6
   DATA ColorLightCoral=0xFFF08080,ColorLightCyan=0xFFE0FFFF,ColorLightGoldenrod=0xFFEEDD82,ColorLightGoldenrodYellow=0xFFFAFAD2
   DATA ColorLightGray=0xFFD3D3D3,ColorLightGreen=0xFF90EE90,ColorLightOrange=0xFFFF9933,ColorLightPink=0xFFFFB6C1
   DATA ColorLightSalmon=0xFFFFA07A,ColorLightSeaGreen=0xFF20B2AA,ColorLightSkyBlue=0xFF87CEFA,ColorLightSlateGray=0xFF778899
   DATA ColorLightSteelBlue=0xFFB0C4DE,ColorLightViolet=0xFFFF99FF,ColorLightYellow=0xFFFFFFE0,ColorLime=0xFF00FF00
   DATA ColorLimeGreen=0xFF32CD32,ColorLinen=0xFFFAF0E6,ColorMagenta=0xFFFF00FF,ColorMaroon=0xFF800000
   DATA ColorMartianGreen=0xFF99CC33,ColorMediumAquamarine=0xFF66CDAA,ColorMediumBlue=0xFF0000CD,ColorMediumOrchid=0xFFBA55D3
   DATA ColorMediumPurple=0xFF9370DB,ColorMediumSeaGreen=0xFF3CB371,ColorMediumSlateBlue=0xFF7B68EE,ColorMediumSpringGreen=0xFF00FA9A
   DATA ColorMediumTurquoise=0xFF48D1CC,ColorMediumVioletRed=0xFFC71585,ColorMidnightBlue=0xFF191970
   DATA ColorMintCream=0xFFF5FFFA,ColorMistyRose=0xFFFFE4E1,ColorMoccasin=0xFFFFE4B5,ColorMoonGreen=0xFFCCFF66
   DATA ColorMossGreen=0xFF336666,ColorNavajoWhite=0xFFFFDEAD,ColorNavy=0xFF000080,ColorOceanGreen=0xFF669999
   DATA ColorOldLace=0xFFFDF5E6,ColorOlive=0xFF808000,ColorOliveDrab=0xFF6B8E23,ColorOrange=0xFFFFA500
   DATA ColorOrangeRed=0xFFFF4500,ColorOrchid=0xFFDA70D6,ColorPaleGoldenrod=0xFFEEE8AA,ColorPaleGreen=0xFF98FB98
   DATA ColorPaleTurquoise=0xFFAFEEEE,ColorPaleVioletRed=0xFFDB7093,ColorPaleYellow=0xFFFFFFCC,ColorPapayaWhip=0xFFFFEFD5
   DATA ColorPeachPuff=0xFFFFDAB9,ColorPeru=0xFFCD853F,ColorPink=0xFFFFC0CB,ColorPlum=0xFFDDA0DD,ColorPowderBlue=0xFFB0E0E6
   DATA ColorPurple=0xFF800080,ColorRed=0xFFFF0000,ColorRosyBrown=0xFFBC8F8F,ColorRoyalBlue=0xFF4169E1
   DATA ColorSaddleBrown=0xFF8B4513,ColorSalmon=0xFFFA8072,ColorSand=0xFFFFCC99,ColorSandyBrown=0xFFF4A460
   DATA ColorSeaGreen=0xFF2E8B57,ColorSeaShell=0xFFFFF5EE,ColorSienna=0xFFA0522D,ColorSilver=0xFFC0C0C0
   DATA ColorSkyBlue=0xFF87CEEB,ColorSlateBlue=0xFF6A5ACD,ColorSlateGray=0xFF708090,ColorSnow=0xFFFFFAFA
   DATA ColorSpringGreen=0xFF00FF7F,ColorSteelBlue=0xFF4682B4,ColorTan=0xFFD2B48C,ColorTeal=0xFF008080
   DATA ColorThistle=0xFFD8BFD8,ColorTomato=0xFFFF6347,ColorTransparent=0xFFFFFFFE,ColorTropicalPink=0xFFFF6666,ColorTurquoise=0xFF40E0D0
   DATA ColorViolet=0xFFEE82EE,ColorVioletRed=0xFFD02090,ColorWalnut=0xFF663300,ColorWheat=0xFFF5DEB3
   DATA ColorWhite=0xFFFFFFFF,ColorWhiteSmoke=0xFFF5F5F5,ColorYellow=0xFFFFFF00,ColorYellowGreen=0xFF9ACD32

   IF nMode = -1 THEN         ' Colorcount
      FUNCTION = UBOUND(DATA$) + 1
   ELSEIF nMode = 0 THEN      ' Name and Value
      sName$ = MID$(EXTRACT$(DATA$[nIndex],"="),6)
      FUNCTION = HEX2DEC(REMAIN$(DATA$[nIndex],"="))
   END IF
   FUNCTION = 0
END FUNCTION



FUNCTION COMBOADDLINE (nDialogHandle AS HWND, nCtrlID AS LONG, _
   sText AS STRING, nData AS LONG) AS LONG
   DIM RAW hCombo  AS HWND
   DIM RAW nIndex  AS LONG
   hCombo = GetDlgItem(nDialogHandle, nCtrlID)
   nIndex = SENDMESSAGE(hCombo, CB_ADDSTRING, 0, sText)
   SENDMESSAGE(hCombo, CB_SETITEMDATA, nIndex, nData)
   FUNCTION = nIndex
END FUNCTION

SUB COMBOSETINDEXDATA(BYVAL nDialogHandle AS HWND, BYVAL nCtrlID AS LONG, BYVAL nData AS LONG)
   DIM RAW i
   DIM RAW nCount, hCombo AS HWND
   hCombo = GetDlgItem(nDialogHandle,nCtrlID)
   nCount = SENDMESSAGE(hCombo, CB_GETCOUNT, 0, 0)
   FOR i = 0 TO nCount-1
      IF nData = SENDMESSAGE(hCombo, CB_GETITEMDATA, i, 0) THEN
         SENDMESSAGE (hCombo,CB_SETCURSEL,i,0)
         EXIT SUB
      END IF
   NEXT
   SENDMESSAGE (hCombo,CB_SETCURSEL,0,0)
END SUB

FUNCTION COMBOGETSELINDEX (BYVAL nDialogHandle AS HWND, BYVAL nCtrlID AS LONG) AS LONG
   DIM RAW hCombo AS HWND
   hCombo = GetDlgItem(nDialogHandle, nCtrlID)
   FUNCTION = SENDMESSAGE(hCombo, CB_GETCURSEL, 0, 0)
END FUNCTION

FUNCTION COMBOGETSELDATA (BYVAL nDialogHandle AS HWND, BYVAL nCtrlID AS LONG) AS LONG
   DIM RAW hCombo AS HWND
   hCombo = GetDlgItem(nDialogHandle, nCtrlID)
   FUNCTION = SENDMESSAGE(hCombo, CB_GETITEMDATA, COMBOGETSELINDEX(nDialogHandle, nCtrlID), 0)
END FUNCTION

FUNCTION CheckGet(BYVAL nDialogHandle AS HWND, BYVAL nCtrlID AS LONG) AS LONG
   FUNCTION = IsDlgButtonChecked(nDialogHandle, nCtrlID)
END FUNCTION

SUB CheckSet(BYVAL nDialogHandle AS HWND, BYVAL nCtrlID AS LONG,BYVAL nState AS LONG)
   CheckDlgButton(nDialogHandle, nCtrlID, nState)
END SUB

FUNCTION OptGet(BYVAL hDlg AS HWND, BYVAL nLower AS LONG, BYVAL nUpper AS LONG) AS LONG
   DIM RAW i      AS LONG
   DIM RAW nOpt   AS LONG
   FOR i=nLower TO nUpper
      nOpt = CheckGet(hDlg,i)
      IF nOpt=1 THEN
         nOpt = i
         EXIT FOR
      END IF
   NEXT
   FUNCTION = nOpt
END FUNCTION


FUNCTION FORMAT$ OPTIONAL(num AS DOUBLE, fmt$=0)
   IF NOT fmt THEN FUNCTION = LTRIM$(STR$(num))
   DIM RAW f$
   f$ = REPLACE$(fmt$,"0","#")
   FUNCTION = USING$(f$,num)
END FUNCTION


SUB ShowInfo(TINFO AS tRMC_INFO PTR)
   DIM AUTO sInfo AS STRING

   sInfo = sInfo + "Info about the mousepointer:"+CRLF$
   sInfo = sInfo + "------------------------------"+CRLF$
   sInfo = sInfo + "X position: "+TAB$+STR$(TINFO->nXPos)+CRLF$ _
   + "Y position: "+TAB$+STR$(TINFO->nYPos)
   IF TINFO->nRegionIndex > 0 THEN
      sInfo = sInfo + CRLF$ + CRLF$ + "Info about the region:"+CRLF$
      sInfo = sInfo + "------------------------------"+CRLF$
      sInfo = sInfo + "Regionindex:"+TAB$+STR$(TINFO->nRegionIndex)+CRLF$ _
      + "Left position:" +TAB$+STR$(TINFO->nRLeft)+CRLF$ _
      + "Top position:"+TAB$+STR$(TINFO->nRTop)+CRLF$ _
      + "Right position:"+TAB$+STR$(TINFO->nRRight)+CRLF$ _
      + "Bottom position:"+TAB$+STR$(TINFO->nRBottom)
   END IF
   IF TINFO->nGLeft + TINFO->nGRight > 0 THEN
      sInfo = sInfo + CRLF$ + CRLF$ + "Info about the grid:"+CRLF$
      sInfo = sInfo + "------------------------------"+CRLF$
      sInfo = sInfo + "Left position:" +TAB$+STR$(TINFO->nGLeft)+CRLF$ _
      + "Top position:"+TAB$+STR$(TINFO->nGTop)+CRLF$ _
      + "Right position:"+TAB$+STR$(TINFO->nGRight)+CRLF$ _
      + "Bottom position:"+TAB$+STR$(TINFO->nGBottom)+CRLF$
      IF TINFO->nGCol > 0 THEN
         SELECT CASE TINFO->nChartType
            CASE RMC_BARSINGLE TO RMC_HIGHLOW
            sInfo = sInfo + "Column:" +TAB$+TAB$+STR$(TINFO->nGCol)+CRLF$ _
            + "Row:" +TAB$+TAB$+STR$(TINFO->nGRow)
            CASE RMC_XYCHART
            sInfo = sInfo + "Sector-index of 1. axes pair:" +TAB$+STR$(TINFO->nGCol)
            IF TINFO->nGRow > 0 THEN
               sInfo = sInfo + CRLF$+"Sector-index of 2. axes pair:" +TAB$+STR$(TINFO->nGRow)
            END IF
         END SELECT
      END IF
   END IF
   IF TINFO->nSeriesIndex > 0 THEN
      sInfo = sInfo + CRLF$ + CRLF$ + "Info about the series:"+CRLF$
      sInfo = sInfo + "------------------------------"+CRLF$
      sInfo = sInfo + "Seriesindex:" +TAB$+STR$(TINFO->nSeriesIndex)+CRLF$
      sInfo = sInfo + "Dataindex:" +TAB$+STR$(TINFO->nDataIndex)+CRLF$
      IF TINFO->nChartType = RMC_GRIDLESS THEN
      ELSE
         sInfo = sInfo + "Left position:" +TAB$+STR$(TINFO->nSLeft)+CRLF$ _
         + "Top position:"+TAB$+STR$(TINFO->nSTop)+CRLF$ _
         + "Right position:"+TAB$+STR$(TINFO->nSRight)+CRLF$ _
         + "Bottom position:"+TAB$+STR$(TINFO->nSBottom)+CRLF$
         IF TINFO->nChartType = RMC_HIGHLOW THEN
            sInfo = sInfo + "Y-pos. Open point:" +TAB$+STR$(TINFO->nSTop2)+CRLF$ _
            + "Y-pos. Close point:"+TAB$+STR$(TINFO->nSBottom2)+CRLF$
         END IF
      END IF
      SELECT CASE TINFO->nChartType
         CASE RMC_BARSINGLE,RMC_BARGROUP,RMC_LINE,RMC_AREA,RMC_VOLUMEBAR
         sInfo = sInfo + "Data value:" +TAB$+FORMAT$(TINFO->nData1,"0.00")+CRLF$
         CASE RMC_BARSTACKED,RMC_BARSTACKED100,RMC_LINE_INDEXED,RMC_AREA_INDEXED,RMC_GRIDLESS
         sInfo = sInfo + "Absolut data value:" +TAB$+FORMAT$(TINFO->nData1,"0.00")+CRLF$
         sInfo = sInfo + "Percent data value:" +TAB$+FORMAT$(TINFO->nData2,"0.00")+CRLF$
         CASE RMC_XYCHART
         sInfo = sInfo + "X-data value:" +TAB$+FORMAT$(TINFO->nData1,"0.00")+CRLF$
         sInfo = sInfo + "Y-data value:" +TAB$+FORMAT$(TINFO->nData2,"0.00")+CRLF$
         CASE RMC_HIGHLOW
         sInfo = sInfo + "Open data:" +TAB$+FORMAT$(TINFO->nData1,"0.00")+CRLF$
         sInfo = sInfo + "High data:" +TAB$+FORMAT$(TINFO->nData2,"0.00")+CRLF$
         sInfo = sInfo + "Low data:" +TAB$+FORMAT$(TINFO->nData3,"0.00")+CRLF$
         sInfo = sInfo + "Close data:" +TAB$+FORMAT$(TINFO->nData4,"0.00")+CRLF$
      END SELECT
   END IF
   IF TINFO->nGLeft + TINFO->nGRight > 0 THEN
      sInfo = sInfo + CRLF$ + CRLF$ + "Data value, which is correspondent"+CRLF$ _
      +  "to this X/Y location:"+CRLF$
      sInfo = sInfo + "------------------------------"+CRLF$
      IF TINFO->nChartType = RMC_XYCHART THEN
         sInfo = sInfo + "X-data value of 1. axes pair: " +TAB$+FORMAT$(TINFO->nVirtData1,"0.00")+CRLF$
         sInfo = sInfo + "Y-data value of 1. axes pair: " +TAB$+FORMAT$(TINFO->nVirtData2,"0.00")+CRLF$
         IF TINFO->nVirtData3 <> 0 AND TINFO->nVirtData4 <> 0 THEN
            sInfo = sInfo + "X-data value of 2. axes pair: " +TAB$+FORMAT$(TINFO->nVirtData3,"0.00")+CRLF$
            sInfo = sInfo + "Y-data value of 2. axes pair: " +TAB$+FORMAT$(TINFO->nVirtData4,"0.00")+CRLF$
         END IF
      ELSE
         sInfo = sInfo + "Data value of the 1. data-axis:" +TAB$+FORMAT$(TINFO->nVirtData1,"0.00")+CRLF$
         IF TINFO->nVirtData2 <> 0 THEN
            sInfo = sInfo + "Data value of the 2. data-axis:" +TAB$+FORMAT$(TINFO->nVirtData2,"0.00")+CRLF$
         END IF
      END IF
   END IF

   MSGBOX sInfo,"RMChart Demo" ,MB_OK BOR MB_ICONINFORMATION
END SUB

