'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' A demo of using rmchart.dll charting library.
'
PROGRAM	"rmchartdemo"
VERSION	"0.0001"
'
	IMPORT	"xst"   		' standard library	: required by most programs
	IMPORT  "xsx"
	IMPORT	"xio"				' console io library
	IMPORT	"gdi32"     ' gdi32.dll
	IMPORT  "user32"    ' user32.dll
	IMPORT  "kernel32"  ' kernel32.dll
	IMPORT  "comctl32"	' comctl32.dll			: common controls library
	IMPORT  "rmchart"
  IMPORT  "comdlg32"	' comdlg32.dll			: common dialog library

'	IMPORT	"xma"   		' math library			: Sin/Asin/Sinh/Asinh/Log/Exp/Sqrt...
'	IMPORT	"xcm"				' complex math library
'	IMPORT  "xsx"				' extended std library
'	IMPORT  "msvcrt"		' msvcrt.dll				: C function library
'	IMPORT  "shell32"   ' shell32.dll
'
DECLARE FUNCTION  Entry ()
DECLARE FUNCTION  WndProc (hwnd, msg, wParam, lParam)
DECLARE FUNCTION  InitGui ()
DECLARE FUNCTION  RegisterWinClass (className$, addrWndProc, icon$, menu$)
DECLARE FUNCTION  CreateWindows ()
DECLARE FUNCTION  NewWindow (className$, titleBar$, style, x, y, w, h, exStyle)
DECLARE FUNCTION  NewChild (className$, text$, style, x, y, w, h, parent, id, exStyle)
DECLARE FUNCTION  MessageLoop ()
DECLARE FUNCTION  CleanUp ()
DECLARE FUNCTION ShowDonut (hWnd)
DECLARE FUNCTION SingleBars (hWnd)
DECLARE FUNCTION ShowXYSeries (hWnd)
DECLARE FUNCTION ExplPie (hWnd)
DECLARE FUNCTION DataFromFile (hWnd)
DECLARE FUNCTION ShowBars2 (hWnd)
DECLARE FUNCTION SimpleLine (hWnd)
DECLARE FUNCTION FromString (hWnd)
DECLARE FUNCTION SaveChart (hWnd)
DECLARE FUNCTION FromFile (hWnd)
DECLARE FUNCTION XYTwoSeries (hWnd)
DECLARE FUNCTION GroupedBars (hWnd)
DECLARE FUNCTION StackedBars (hWnd)
DECLARE FUNCTION BarsLine (hWnd)
DECLARE FUNCTION FloatingBars (hWnd)
DECLARE FUNCTION ColorBars (hWnd)
DECLARE FUNCTION ShowSaveFileDialog (hWndOwner, @fileName$, filter$, initDir$, title$)
DECLARE FUNCTION ExportTheChart (hWnd, nCtrlID)
DECLARE FUNCTION PrintTheChart (hWnd, nCtrlID)
DECLARE FUNCTION Build_ScrollChart (hWnd)
DECLARE FUNCTION ScrollChart (hWnd)
DECLARE FUNCTION PrinterDialog (hWnd, @hDC)

$$ID_RMC1 = 1025

$$ID_OPEN = 100
$$ID_CLOSE = 101
$$ID_EXPORT = 102
$$ID_PRINT = 103
$$ID_EXIT = 104
$$ID_BARS = 120
$$ID_GROUPED_BARS = 121
$$ID_STACKED_BARS = 122
$$ID_BARS_IMAGE = 123
$$ID_LINES = 124
$$ID_THREE_LINES = 125
$$ID_BARS_LINE = 126
$$ID_FLOATING_BARS = 127
$$ID_PIE = 130
$$ID_DONUT_IMAGE = 131
$$ID_XY_SERIES = 140
$$ID_XY_2_SERIES = 141
$$ID_SCROLL_CHART = 150
$$ID_READ_FILE = 151
$$ID_DATA_STRING = 152
$$ID_SAVE_IMAGE = 153
'
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION  Entry ()

	STATIC	entry

	IF entry THEN RETURN							' enter once
	entry =  $$TRUE										' enter occured

'	XioCreateConsole (title$, 500)			' create console, if console is not wanted, comment out this line
	InitGui ()												' initialize program and libraries
	IF CreateWindows () THEN QUIT (0)	' create windows and other child controls
	MessageLoop ()										' the main message loop
	CleanUp ()												' unregister all window classes
'	XioFreeConsole ()									' free console

END FUNCTION
'
'
' ########################
' #####  WndProc ()  #####
' ########################
'
FUNCTION  WndProc (hWnd, msg, wParam, lParam)

	PAINTSTRUCT ps
	RECT rect
	SCROLLINFO sih
	
	SELECT CASE msg

		CASE $$WM_CREATE :
			ShowScrollBar (hWnd, $$SB_VERT, 0)

		CASE $$WM_COMMAND :
			id         = LOWORD(wParam)
'			hwndCtl    = lParam
'			notifyCode = HIWORD(wParam)
			SELECT CASE id
				CASE $$ID_OPEN 					:
				CASE $$ID_CLOSE 				: DestroyWindow (hWnd)
				CASE $$ID_EXPORT 				: ExportTheChart (hWnd, $$ID_RMC1)
				CASE $$ID_PRINT 				: PrintTheChart (hWnd, $$ID_RMC1)
				CASE $$ID_EXIT 					: DestroyWindow (hWnd)
				CASE $$ID_BARS 					: ShowScrollBar (hWnd, $$SB_VERT, 0): err = SingleBars (hWnd)
				CASE $$ID_GROUPED_BARS 	: ShowScrollBar (hWnd, $$SB_VERT, 0): err = GroupedBars (hWnd)
				CASE $$ID_STACKED_BARS 	: ShowScrollBar (hWnd, $$SB_VERT, 0): err = StackedBars (hWnd)
				CASE $$ID_BARS_IMAGE 		: ShowScrollBar (hWnd, $$SB_VERT, 0): err = ColorBars (hWnd)
				CASE $$ID_LINES 				: ShowScrollBar (hWnd, $$SB_VERT, 0): err = SimpleLine (hWnd)
				CASE $$ID_THREE_LINES 	: ShowScrollBar (hWnd, $$SB_VERT, 0): err = DataFromFile (hWnd)
				CASE $$ID_BARS_LINE 		: ShowScrollBar (hWnd, $$SB_VERT, 0): err = BarsLine (hWnd)
				CASE $$ID_FLOATING_BARS : ShowScrollBar (hWnd, $$SB_VERT, 0): err = FloatingBars (hWnd)
				CASE $$ID_PIE 					: ShowScrollBar (hWnd, $$SB_VERT, 0): err = ExplPie (hWnd)
				CASE $$ID_DONUT_IMAGE 	: ShowScrollBar (hWnd, $$SB_VERT, 0): err = ShowDonut (hWnd)
				CASE $$ID_XY_SERIES 		: ShowScrollBar (hWnd, $$SB_VERT, 0): err = ShowXYSeries (hWnd)
				CASE $$ID_XY_2_SERIES 	: ShowScrollBar (hWnd, $$SB_VERT, 0): err = XYTwoSeries (hWnd)
				CASE $$ID_SCROLL_CHART 	: ShowScrollBar (hWnd, $$SB_VERT, 1): err = ScrollChart (hWnd)
				CASE $$ID_READ_FILE 		: err = FromFile (hWnd)
				CASE $$ID_DATA_STRING 	: err = FromString (hWnd)
				CASE $$ID_SAVE_IMAGE 		: err = SaveChart (hWnd)
			END SELECT

		CASE $$WM_DESTROY :
			PostQuitMessage(0)
			
		' the vertical scrollbar from "Scroll chart" (see Functions ScrollChart and Build_ScrollChart)			
    CASE $$WM_VSCROLL : 
			sih.cbSize = SIZE(sih)
      sih.fMask = $$SIF_ALL
			GetScrollInfo (hWnd, $$SB_VERT, &sih)
      SELECT CASE LOWORD(wParam)

         CASE $$SB_LINEDOWN
					sih.nPos = MIN(sih.nPos + 1,(sih.nMax-sih.nPage)+1)
         CASE $$SB_LINEUP
					sih.nPos = MAX(1,sih.nPos - 1)
         CASE $$SB_PAGEUP
					sih.nPos = MAX(1,sih.nPos - (sih.nPage-1))
         CASE $$SB_PAGEDOWN
					sih.nPos = MIN(sih.nPos + (sih.nPage-1),(sih.nMax-sih.nPage)+1)
         CASE $$SB_THUMBTRACK
					sih.nPos = HIWORD(wParam)
         CASE $$SB_TOP
					sih.nPos = 1
         CASE $$SB_BOTTOM
					sih.nPos = (sih.nMax-sih.nPage)+1
         CASE ELSE
					RETURN ($$TRUE)
      END SELECT
      SetScrollInfo (hWnd, $$SB_VERT, &sih, $$TRUE)
			
      sLines$ =  STRING$((1237-sih.nPos)+20) + "," + STRING$((1237-sih.nPos))
      ' Set the new data for the first series (Bars):
      RMC_SETSERIESDATAFILE ($$ID_RMC1,1,1, &"dowdaily.csv",&sLines$,&"3",&",",0)
      ' Set the new data for the second series (Line):
      RMC_SETSERIESDATAFILE ($$ID_RMC1,1,2, &"dowdaily.csv",&sLines$,&"2",&",",0)
      nError = RMC_DRAW($$ID_RMC1) ' Show the chart with the new data


'		CASE $$WM_NOTIFY :
'			idCtrl = wParam
'			SELECT CASE idCtrl
'				CASE $$ListView1 :
'					GetNotifyMsg (lParam, @hwndFrom, @idFrom, @code)
'					SELECT CASE code :
'					END SELECT
'			END SELECT

'		CASE $$WM_PAINT :
'			hdc = BeginPaint (hWnd, &ps)
'			EndPaint (hWnd, &ps)

'		CASE $$WM_SIZE :
'			w = LOWORD (lParam)
'			h = HIWORD (lParam)
'			sizeType = wParam

		CASE ELSE :
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)

	END SELECT

END FUNCTION
'
'
' ########################
' #####  InitGui ()  #####
' ########################
'
FUNCTION  InitGui ()

	SHARED hInst
	hInst = GetModuleHandleA (0) 	' get current instance handle
	IFZ hInst THEN QUIT (0)
	InitCommonControls ()					' initialize comctl32.dll library

END FUNCTION
'
'
' #################################
' #####  RegisterWinClass ()  #####
' #################################
'
FUNCTION  RegisterWinClass (className$, addrWndProc, icon$, menu$)

	SHARED hInst
	WNDCLASS wc

	wc.style           = $$CS_HREDRAW | $$CS_VREDRAW | $$CS_OWNDC
	wc.lpfnWndProc     = addrWndProc
	wc.cbClsExtra      = 0
	wc.cbWndExtra      = 0
	wc.hInstance       = hInst
	wc.hIcon           = LoadIconA (hInst, &icon$)
	wc.hCursor         = LoadCursorA (0, $$IDC_ARROW)
	wc.hbrBackground   = $$COLOR_BTNFACE + 1
	wc.lpszMenuName    = &menu$
	wc.lpszClassName   = &className$

	IFZ RegisterClassA (&wc) THEN RETURN ($$TRUE)

END FUNCTION
'
'
' ##############################
' #####  CreateWindows ()  #####
' ##############################
'
FUNCTION  CreateWindows ()

' register window class
	className$  = "rmchart"
	addrWndProc = &WndProc()
	icon$ 			= "scrabble"
	menu$ 			= "menu"
	IF RegisterWinClass (@className$, addrWndProc, @icon$, @menu$) THEN RETURN ($$TRUE)

' create main window
	titleBar$ = "RMChart Demo"
	style 		= $$WS_OVERLAPPEDWINDOW | $$WS_VSCROLL
	w 				= 700
	h 				= 590
	exStyle		= 0
	#winMain = NewWindow (@className$, @titleBar$, style, x, y, w, h, exStyle)
	IFZ #winMain THEN RETURN ($$TRUE)

	XstCenterWindow (#winMain)							' center window position
	ShowWindow (#winMain, $$SW_SHOWNORMAL)	' show window

END FUNCTION
'
'
' ##########################
' #####  NewWindow ()  #####
' ##########################
'
FUNCTION  NewWindow (className$, titleBar$, style, x, y, w, h, exStyle)

	SHARED hInst

	RETURN CreateWindowExA (exStyle, &className$, &titleBar$, style, x, y, w, h, 0, 0, hInst, 0)

END FUNCTION
'
'
' #########################
' #####  NewChild ()  #####
' #########################
'
FUNCTION  NewChild (className$, text$, style, x, y, w, h, parent, id, exStyle)

	SHARED hInst

	style = style | $$WS_CHILD | $$WS_VISIBLE
	RETURN CreateWindowExA (exStyle, &className$, &text$, style, x, y, w, h, parent, id, hInst, 0)

END FUNCTION
'
'
' ############################
' #####  MessageLoop ()  #####
' ############################
'
FUNCTION  MessageLoop ()

	USER32_MSG msg

' main message loop

	IF LIBRARY(0) THEN RETURN								' main program executes message loop

	DO																			' the message loop
		ret = GetMessageA (&msg, NULL, 0, 0)	' retrieve next message from queue

		SELECT CASE ret
			CASE  0 : RETURN msg.wParam					' WM_QUIT message
			CASE -1 : RETURN $$TRUE							' error
			CASE ELSE:
				hwnd = GetActiveWindow ()
				IF (!IsWindow (hwnd)) || (!IsDialogMessageA (hwnd, &msg)) THEN		' send only non-dialog messages
  				TranslateMessage (&msg)					' translate virtual-key messages into character messages
  				DispatchMessageA (&msg)					' send message to window callback function WndProc()
				END IF
		END SELECT
	LOOP

END FUNCTION
'
'
' ########################
' #####  CleanUp ()  #####
' ########################
'
FUNCTION  CleanUp ()

	SHARED hInst, className$

	UnregisterClassA (&className$, hInst)

END FUNCTION
'
' #######################
' #####  ShowDonut  #####
' #######################
'
FUNCTION ShowDonut (hWnd)

DOUBLE data[]

	' No individual color values are defined, so the
	' internal colors are used in this one:

	' ***** Create the chart *****
	bg$ = "seasky.jpg"																	' background image
	ret = RMC_CREATECHART (hWnd, $$ID_RMC1, 10, 10, 600, 450, $$ColorTransparent, $$RMC_CTRLSTYLEIMAGE, 0, &bg$, 0, 0, 0)

	' ***** Add Region 1 *****
	ret = RMC_ADDREGION ($$ID_RMC1, 5, 5, -5, -5, 0, 1)

	' ***** Add legend to region 1 *****
	legend$ = "Apples*Citrons*Bananas*Cherries"
	ret = RMC_ADDLEGEND ($$ID_RMC1, 1, &legend$, $$RMC_LEGEND_CUSTOM_CENTER, $$ColorGainsboro, $$RMC_LEGENDNORECT, $$ColorBlue, 8, $$TRUE)

	' ***** Add Series 1 to region 1 *****
	DIM data[3]
	data[0] = 40
	data[1] = 30
	data[2] = 60
	data[3] = 20

	ret = RMC_ADDGRIDLESSSERIES ($$ID_RMC1, 1, &data[0], 4, 0, 0, $$RMC_DONUT_GRADIENT, $$RMC_FULL, 0, $$FALSE, $$RMC_VLABEL_TWIN, $$RMC_HATCHBRUSH_OFF, 0)

	RMC_DRAW ($$ID_RMC1)		' Draw the chart

END FUNCTION
'
' ######################
' #####  ShowBars  #####
' ######################
'
FUNCTION SingleBars (hWnd)

	DOUBLE aData[]
	DOUBLE nAverage

	nRetVal = RMC_CREATECHART (hWnd, $$ID_RMC1, 10, 10, 600, 450, $$ColorAliceBlue,$$RMC_CTRLSTYLEFLAT,$$FALSE,NULL,NULL,0,0)			' create the chart control
	nRetVal = RMC_ADDREGION ($$ID_RMC1, 5,5,-5,-5,NULL,$$FALSE)													' add a Region to the chart

	caption$ = "This is the chart's caption"
	nRetVal = RMC_ADDCAPTION ($$ID_RMC1, 1, &caption$, $$ColorBlue, $$ColorYellow, 11, $$TRUE)		' add a Caption to region 1
	nRetVal = RMC_ADDGRID ($$ID_RMC1, 1, $$ColorPaleGoldenrod, $$FALSE,0,0,0,0,$$RMC_BICOLOR_LABELAXIS)			' add a Grid to region 1
	nRetVal = RMC_ADDDATAAXIS ($$ID_RMC1, 1, $$RMC_DATAAXISLEFT, 0, 100, 11, 8, 0,0,0,0,0,0,0,0)		' add a Data axis to region 1

	sTemp$ = "Label 1*Label 2*Label 3*Label 4*Label 5"
	nRetVal = RMC_ADDLABELAXIS ($$ID_RMC1, 1, &sTemp$, 1, 5,$$RMC_LABELAXISBOTTOM,8,$$ColorBlack,$$RMC_TEXTCENTER,$$ColorBlack,$$RMC_LINESTYLENONE,NULL)	' add a Label axis to region 1

	DIM aData[4]
	aData[0] = 20
	aData[1] = 70
	aData[2] = 40
	aData[3] = 60
	aData[4] = 30
	nRetVal = RMC_ADDBARSERIES ($$ID_RMC1, 1, &aData[0], 5, $$RMC_BARSINGLE, $$RMC_BAR_FLAT_GRADIENT2, $$FALSE,$$ColorDefault,$$FALSE,1,$$RMC_VLABEL_NONE,1,$$RMC_HATCHBRUSH_OFF)		' add a Bar series to region 1

  ' Now add an average line:

   DIM aXPoints[2]
   DIM aYPoints[2]

    ' Calc the average and get the needed X/Y positions (nL,nT,nR,nB) for the line
   nRetVal = RMC_CALCAVERAGE($$ID_RMC1,1,1,&nAverage,&nL,&nT,&nR,&nB,NULL)

    ' Add a CustomLine to show the average:
   nRetVal = RMC_CODASH($$ID_RMC1,1,nL,nT,nR,nB,$$RMC_LINE_FLAT,$$ColorGreen,0,2,0,0)

    ' Draw the "legend" for the average line:
   aXPoints[0] = 480 : aXPoints[1] = 565 : aXPoints[2] = 565
   aYPoints[0] = 175 : aYPoints[1] = 175 : aYPoints[2] = 215
   nRetVal = RMC_COLINE($$ID_RMC1,2,&aXPoints[],&aYPoints[],3,$$RMC_LINE_FLAT,$$ColorGreen,0,2,0,$$RMC_ANCHOR_ARROW_OPEN)
	 txt$ = " Average (" + FORMAT$("#.##", nAverage) + ")"
   nRetVal = RMC_COTEXT($$ID_RMC1,3,&txt$,480,159,0,0,0,0,0,0,0,0,NULL)

	RMC_DRAW ($$ID_RMC1)		' Draw the chart

END FUNCTION
'
' ##########################
' #####  ShowXYSeries  #####
' ##########################
'
FUNCTION ShowXYSeries (hWnd)

DOUBLE dataX[]
DOUBLE dataY[]
tRMC_XYAXIS tXYAxis

	' ************** Create the chart **********************
	nRetVal = RMC_CREATECHART (hWnd, $$ID_RMC1, 10, 10, 600, 450, $$ColorAliceBlue, $$RMC_CTRLSTYLEFLATSHADOW, 0, 0, 0, 0, 0)

	' ************** Add Region 1 *****************************
	nRetVal = RMC_ADDREGION ($$ID_RMC1, 5, 5, -5, -5, NULL, $$FALSE)

	' ************** Add caption to region 1 *******************
	caption$ = "Two XY series aligned to 2 different XY-axes pairs"
	nRetVal = RMC_ADDCAPTION ($$ID_RMC1, 1, &caption$, $$ColorBlue, $$ColorAntiqueWhite, 10, $$TRUE)

	' ************** Add grid to region 1 *****************************
	nRetVal = RMC_ADDGRID ($$ID_RMC1, 1, $$ColorLightBlue, $$FALSE, 0, 0, 0, 0, 0)

	' ************** Add first X axis to region 1 *****************************
	text$ = "First X axis"
	nRetVal = RMC_ADDXAXIS ($$ID_RMC1, 1, $$RMC_XAXISBOTTOM, 0, 100, 11, 8, $$ColorBlue, $$ColorBlue, $$RMC_LINESTYLEDOT, 0, NULL, &text$, NULL, 0)

	' ************** Add first Y axis to region 1 *****************************
	text1$ = "First Y axis"
	nRetVal = RMC_ADDYAXIS ($$ID_RMC1, 1, $$RMC_YAXISLEFT, 0, 100, 11, 8, $$ColorBlue, $$ColorBlue, $$RMC_LINESTYLEDOT, 0, NULL, &text1$, NULL, 0)

	' ************** Add second X axis to region 1 *****************************
	text2$ = "Second X axis"
	nRetVal = RMC_ADDXAXIS ($$ID_RMC1, 1, $$RMC_XAXISTOP, 0, 10, 5, 8, $$ColorCoral, $$ColorCoral, $$RMC_LINESTYLEDASH, 1, NULL, &text2$, NULL, 0)

	' ************** Add second Y axis to region 1 *****************************
	text3$ = "Second Y axis"
	nRetVal = RMC_ADDYAXIS ($$ID_RMC1, 1, $$RMC_YAXISRIGHT, 0, 10, 5, 8, $$ColorCoral, $$ColorCoral, $$RMC_LINESTYLEDASH, 1, NULL, &text3$, NULL, 0)

	' ************** Add Series 1 to region 1 *******************************
	' ****** Read X-data values ******
	DIM dataX[4]
	dataX[0] = 20 : dataX[1] = 30 : dataX[2] = 60 : dataX[3] = 70 : dataX[4] = 90

	' ****** Read Y-data values ******
	DIM dataY[4]
	dataY[0] = 40 : dataY[1] = 20 : dataY[2] = 70 : dataY[3] = 10 : dataY[4] = 60
	nRetVal = RMC_ADDXYSERIES ($$ID_RMC1, 1, &dataX[0], 5, &dataY[0], 5, $$ColorDefault, $$RMC_XY_SYMBOL, 0, $$RMC_SYMBOL_BULLET, $$RMC_XAXISBOTTOM, $$RMC_YAXISLEFT, 0)

	' ************** Add Series 2 to region 1 *******************************
	' ****** Read X-data values ******
	dataX[0] = 2.5 : dataX[1] = 4.5 : dataX[2] = 5.5 : dataX[3] = 7.5 : dataX[4] = 9.5

	' ****** Read Y-data values ******
	dataY[0] = 7.5 : dataY[1] = 5.5 : dataY[2] = 5.5 : dataY[3] = 2.5 : dataY[4] = 7.5

	nRetVal = RMC_ADDXYSERIES ($$ID_RMC1, 1, &dataX[], 5, &dataY[], 5, $$ColorCoral, $$RMC_XY_SYMBOL, 0, $$RMC_SYMBOL_DIAMOND, $$RMC_XAXISTOP, $$RMC_YAXISRIGHT, 0)

	IF nRetVal < 0 THEN RETURN ($$TRUE)	' Error?

	RMC_DRAW ($$ID_RMC1)		' Draw the chart

END FUNCTION
'
' #######################
' #####  ShowBars2  #####
' #######################
'
FUNCTION ShowBars2 (hWnd)

  tRMC_CHART tChart
  tRMC_REGION tRegion
  tRMC_CAPTION tCaption
  tRMC_GRID tGrid
  tRMC_DATAAXIS tDataAxis
  tRMC_LABELAXIS tLabelAxis
  tRMC_BARSERIES tBarSeries
	UBYTE asTemp[]
	DOUBLE data[]

  '************** Create the chart **********************
    tChart.nLeft        = 15
    tChart.nTop         = 15
    tChart.nWidth       = 600
    tChart.nHeight      = 450
    tChart.nBackColor   = $$ColorAliceBlue
    tChart.nCtrlStyle   = $$RMC_CTRLSTYLEFLAT
    tChart.sBgImage     = ""
    nRetVal = RMC_CREATECHARTI (hWnd, $$ID_RMC1, &tChart)
    IF nRetVal < 0 THEN GOTO isError

    '************** Add Region 1 *****************************
    tRegion.nLeft       = 5
    tRegion.nTop        = 5
    tRegion.nWidth      = -5
    tRegion.nHeight     = -5
    tRegion.sFooter     = "Test Footer"
    tRegion.nShowBorder = $$FALSE
    nRetVal = RMC_ADDREGIONI ($$ID_RMC1, &tRegion)
    IF nRetVal < 0 THEN GOTO isError

    '************** Add caption to region 1 *******************
    tCaption.sText  = "Don't try this at home."
    tCaption.nBackColor = $$ColorBlue
    tCaption.nTextColor = $$ColorYellow
    tCaption.nFontSize  = 11
    tCaption.nIsBold    = 1
    nRetVal = RMC_ADDCAPTIONI ($$ID_RMC1, 1, &tCaption)
    IF nRetVal < 0 THEN GOTO isError

    '************** Add grid to region 1 *****************************
    tGrid.nGridBackColor = $$ColorPaleGoldenrod
    tGrid.nAsGradient    = $$FALSE
    tGrid.nLeft      = 0
    tGrid.nTop       = 0
    tGrid.nWidth     = 0
    tGrid.nHeight    = 0
    nRetVal = RMC_ADDGRIDI ($$ID_RMC1, 1, &tGrid)
    IF nRetVal < 0 THEN GOTO isError

    '************** Add data axis to region 1 *****************************
    tDataAxis.nAlignment      = $$RMC_DATAAXISLEFT
    tDataAxis.nMinValue       = 0
    tDataAxis.nMaxValue       = 0 '100
    tDataAxis.nTickCount      = 11
    tDataAxis.nFontsize       = 8
    tDataAxis.nTextColor      = $$ColorBlack
    tDataAxis.nLineColor      = $$ColorBlack
    tDataAxis.nLineStyle      = $$RMC_LINESTYLESOLID
    tDataAxis.nDecimalDigits  = 1
    tDataAxis.sUnit           = ""
    tDataAxis.sText           = ""
    nRetVal = RMC_ADDDATAAXISI ($$ID_RMC1, 1, &tDataAxis)
    IF nRetVal < 0 THEN GOTO isError

    '************** Add label axis to region 1 *****************************
    tLabelAxis.nCount         = 1
    tLabelAxis.nTickCount     = 5
    tLabelAxis.nAlignment     = $$RMC_LABELAXISBOTTOM
    tLabelAxis.nFontsize      = 8
    tLabelAxis.nTextColor     = $$ColorBlack
    tLabelAxis.nTextAlignment = $$RMC_TEXTCENTER
    tLabelAxis.nLineColor     = $$ColorBlack
    tLabelAxis.nLineStyle     = $$RMC_LINESTYLESOLID
    tLabelAxis.sText          = "Label Axis text "
    nRetVal = RMC_ADDLABELAXISI ($$ID_RMC1, 1, &"Label 1*Label 2*Label 3*Label 4*Label 5", &tLabelAxis)
    IF nRetVal < 0 THEN GOTO isError

    '************** Add Series 1 to region 1 *******************************
    tBarSeries.nType             = $$RMC_BARSINGLE
    tBarSeries.nStyle            = $$RMC_BAR_FLAT_GRADIENT2
    tBarSeries.nIsLucent         = $$FALSE
    tBarSeries.nColor            = $$ColorDefault
    tBarSeries.nIsHorizontal     = $$FALSE
    tBarSeries.nWhichDataAxis    = 1
    tBarSeries.nValueLabelOn     = $$RMC_VLABEL_NONE
    tBarSeries.nPointsPerColumn  = 1
    tBarSeries.nHatchMode        = $$RMC_HATCHBRUSH_OFF
    '****** Read data values ******
		DIM data[4]
		data[0] = 50 : data[1] = 70 : data[2] = 40 : data[3] = 60 : data[4] = 30
    nRetVal = RMC_ADDBARSERIESI ($$ID_RMC1, 1, &data[], 5, &tBarSeries)

    IF nRetVal < 0 THEN GOTO isError

		RMC_SETWATERMARK (&$$RMC_USERWM,$$RMC_USERWMCOLOR, $$RMC_USERWMLUCENT, $$RMC_USERWMALIGN, $$RMC_USERFONTSIZE)

  RMC_DRAW ($$ID_RMC1)
  RETURN

isError:
  PRINT "Error "; nRetVal
	RETURN nRetVal

END FUNCTION

FUNCTION ExplPie (hWnd)

DOUBLE aData[]

	'************** Create the chart **********************
	nRetVal = RMC_CREATECHART (hWnd,$$ID_RMC1,10,10,600,450,$$ColorAliceBlue,$$RMC_CTRLSTYLE3D,$$FALSE,NULL,NULL,0,0)
	IF nRetVal < 0 THEN GOTO IsError

	'************** Add Region 1 *****************************
	nRetVal = RMC_ADDREGION($$ID_RMC1,5,5,-5,-5,NULL,$$FALSE)
	IF nRetVal < 0 THEN GOTO IsError

	'************** Add legend to region 1 *******************************
	sTemp$ = "Cherries*Bananas*Apples*Strawberries"
	nRetVal = RMC_ADDLEGEND($$ID_RMC1,1,&sTemp$,$$RMC_LEGEND_CUSTOM_UL,$$ColorLightYellow,$$RMC_LEGENDRECT,$$ColorBlue,8,$$FALSE)
	IF nRetVal < 0 THEN GOTO IsError

	'************** Add Series 1 to region 1 *******************************
	'****** Read color values ******
	DIM aColor[3]
	aColor[0] = $$ColorFirebrick
	aColor[1] = $$ColorLightSteelBlue
	aColor[2] = $$ColorDarkGreen
	aColor[3] = $$ColorLightCoral
	'****** Read data values ******
	DIM aData[3]
	aData[0] = 10 : aData[1] = 20 : aData[2] = 30 : aData[3] = 40
	nRetVal = RMC_ADDGRIDLESSSERIES($$ID_RMC1,1, &aData[], 4,&aColor[],4,$$RMC_PIE_3D,$$RMC_FULL,2,1,$$RMC_VLABEL_NONE,$$RMC_HATCHBRUSH_OFF,0)
	IF nRetVal < 0 THEN GOTO IsError

'	nRetVal = RMC_SETWATERMARK (&$$RMC_USERWM,$$RMC_USERWMCOLOR,$$RMC_USERWMLUCENT,$$RMC_USERWMALIGN,$$RMC_USERFONTSIZE)
	nRetVal = RMC_DRAW($$ID_RMC1)
	IF nRetVal < 0 THEN GOTO IsError
	RETURN

IsError:
	PRINT "Error "; nRetVal
	RETURN nRetVal

END FUNCTION

FUNCTION DataFromFile (hWnd)

	tRMC_LABELAXIS labelaxis
	tRMC_LINESERIES lineseries, lineseries2
	tRMC_DATAAXIS tDataAxis

	'************** Create the chart **********************
	fn$ = "Tahoma"
	nRetVal = RMC_CREATECHART(hWnd,$$ID_RMC1,10,10,600,450,$$ColorPaleGreen,$$RMC_CTRLSTYLEFLATSHADOW,$$FALSE,NULL,&fn$,0,0)
	IF nRetVal < 0 THEN GOTO IsError

	'************** Add Region 1 *****************************
	cap$ = "data on a weekly basis. source: www.yahoo.com"
	nRetVal = RMC_ADDREGION($$ID_RMC1,5,10,-5,-5,&cap$,$$FALSE)
	IF nRetVal < 0 THEN GOTO IsError

	'************** Add caption to region 1 *******************
	txt$ = "Performance of DOW JONES, DAX and NASDAQ from January 2000 to end of June 2004"
	nRetVal = RMC_ADDCAPTION($$ID_RMC1,1,&txt$,$$ColorPaleGreen,$$ColorDarkBlue,9,1)
	IF nRetVal < 0 THEN GOTO IsError

	'************** Add legend to region 1 *******************************
	legend$ = "DOW JONES*DAX*NASDAQ"
	nRetVal = RMC_ADDLEGEND($$ID_RMC1,1,&legend$,$$RMC_LEGEND_CUSTOM_UR,$$ColorPaleTurquoise,$$RMC_LEGENDRECT,$$ColorDarkBlue,8,$$FALSE)
	IF nRetVal < 0 THEN GOTO IsError

	'************** Add grid to region 1 *****************************
	nRetVal = RMC_ADDGRID($$ID_RMC1,1,$$ColorLightBlue,1,0,0,0,0,$$RMC_BICOLOR_NONE)
	IF nRetVal < 0 THEN GOTO IsError

	'************** Add data axis to region 1 *****************************
	tDataAxis.nAlignment      = $$RMC_DATAAXISLEFT
	tDataAxis.nMinValue       = 0
	tDataAxis.nMaxValue       = 0
	tDataAxis.nTickCount      = 11
	tDataAxis.nFontsize       = 8
	tDataAxis.nTextColor      = $$ColorDarkBlue
	tDataAxis.nLineColor      = $$ColorDarkSlateGray
	tDataAxis.nLineStyle      = $$RMC_LINESTYLEDOT
	tDataAxis.nDecimalDigits  = 0
	tDataAxis.sUnit           = "%"
	tDataAxis.sText           = "2nd January 2000 = 100%"
	nRetVal = RMC_ADDDATAAXISI ($$ID_RMC1, 1, &tDataAxis)
	IF nRetVal < 0 THEN GOTO IsError

		'************** Add label axis to region 1 *****************************
	label$ 										= "2000*2001*2002*2003*2004"
	labelaxis.nCount 					= 1
	labelaxis.nTickCount 			= 5
	labelaxis.nAlignment 			= $$RMC_LABELAXISBOTTOM
	labelaxis.nFontsize 			= 8
	labelaxis.nTextColor 			= $$ColorDarkBlue
	labelaxis.nTextAlignment 	= $$RMC_TEXTCENTER
	labelaxis.nLineColor 			= $$ColorDarkSlateGray
	labelaxis.nLineStyle 			= $$RMC_LINESTYLEDOT
	labelaxis.sText 					= ""

	nRetVal = RMC_ADDLABELAXISI ($$ID_RMC1, 1, &label$, &labelaxis)
	IF nRetVal < 0 THEN GOTO IsError


	'************** Add Series 1 to region 1 *******************************
	'****** Read points per column ******
	DIM aPPC[0]
	aPPC[0] = 52

	lineseries.nType = $$RMC_LINE_INDEXED
	lineseries.nStyle = $$RMC_LINE_FLAT
	lineseries.nLineStyle = $$RMC_LSTYLE_LINE
	lineseries.nIsLucent = $$FALSE
	lineseries.nColor = $$ColorBlue
	lineseries.nSeriesSymbol = $$RMC_SYMBOL_NONE
	lineseries.nWhichDataAxis = 1
	lineseries.nValueLabelOn = $$RMC_VLABEL_NONE
	lineseries.nHatchMode = $$RMC_HATCHBRUSH_OFF

	nRetVal = RMC_ADDLINESERIESI ($$ID_RMC1, 1, 0, 0, &aPPC[0], 1, &lineseries)
	IF nRetVal < 0 THEN GOTO IsError

	'****** Set name and parameters for the datafile for series 1 ******
	nRetVal = RMC_SETSERIESDATAFILE ($$ID_RMC1, 1, 1, &"dow00-04.csv", &"-1,1", &"5", &",", 0)
	IF nRetVal < 0 THEN GOTO IsError

	'************** Add Series 2 to region 1 *******************************
	'****** Read points per column ******
	DIM aPPC[0]
	aPPC[0] = 52

	lineseries2.nType = $$RMC_LINE_INDEXED
	lineseries2.nStyle = $$RMC_LINE_FLAT
	lineseries2.nLineStyle = $$RMC_LSTYLE_LINE
	lineseries2.nIsLucent = $$FALSE
	lineseries2.nColor = $$ColorCrimson
	lineseries2.nSeriesSymbol = $$RMC_SYMBOL_NONE
	lineseries2.nWhichDataAxis = 1
	lineseries2.nValueLabelOn = $$RMC_VLABEL_NONE
	lineseries2.nHatchMode = $$RMC_HATCHBRUSH_OFF

	nRetVal = RMC_ADDLINESERIESI ($$ID_RMC1, 1, 0, 0, &aPPC[0], 1, &lineseries2)
	IF nRetVal < 0 THEN GOTO IsError

	'****** Set name and parameters for the datafile for series 2 ******
	nRetVal = RMC_SETSERIESDATAFILE($$ID_RMC1,1,2, &"dax00-04.csv", &"-1,1", &"5", &",", 0)
	IF nRetVal < 0 THEN GOTO IsError

	'************** Add Series 3 to region 1 *******************************
	'****** Read points per column ******
	REDIM aPPC[0]
	aPPC[0] = 52
	nRetVal = RMC_ADDLINESERIES ($$ID_RMC1,1, 0, 0,&aPPC[],1,$$RMC_LINE_INDEXED,$$RMC_LINE_FLAT,$$RMC_LSTYLE_LINE,$$FALSE, _
																	$$ColorBlack,$$RMC_SYMBOL_NONE,1,$$RMC_VLABEL_NONE,$$RMC_HATCHBRUSH_OFF)
	IF nRetVal < 0 THEN GOTO IsError

	'****** Set name and parameters for the datafile for series 3 ******
	nRetVal = RMC_SETSERIESDATAFILE($$ID_RMC1,1,3,&"nasdaq00-04.csv",&"-1,1",&"5",&",",0)
	IF nRetVal < 0 THEN GOTO IsError

	nRetVal = RMC_SETSERIESVALUELABEL ($$ID_RMC1, 1, 1, $$RMC_VLABEL_NONE)
	IF nRetVal < 0 THEN GOTO IsError

	' Add some CustomObjects
	nRetVal = RMC_COTEXT($$ID_RMC1,1,&"09/11/2001",287,117,80,22,0,$$ColorLightGreen,0,150,0,0,&"CB")
	nRetVal = RMC_CODASH($$ID_RMC1,2,327,141,250,223,0,$$ColorLightGreen,0,2,0,$$RMC_ANCHOR_ARROW_OPEN)
	nRetVal = RMC_CODASH($$ID_RMC1,3,327,141,250,274,0,$$ColorLightGreen,0,2,0,$$RMC_ANCHOR_ARROW_OPEN)
	nRetVal = RMC_CODASH($$ID_RMC1,4,327,141,252,336,0,$$ColorLightGreen,0,2,0,$$RMC_ANCHOR_ARROW_OPEN)

	nRetVal = RMC_DRAW($$ID_RMC1)
	IF nRetVal < 0 THEN GOTO IsError
	RETURN

IsError:
	PRINT "Error "; nRetVal
	RETURN nRetVal
END FUNCTION

FUNCTION SimpleLine (hWnd)

DOUBLE aData[]
DOUBLE nFirst, nLast
tRMC_LABELAXIS labelaxis
tRMC_DATAAXIS tDataAxis
tRMC_LINESERIES tLineSeries

	'************** Create the chart **********************
	nRetVal = RMC_CREATECHART(hWnd,$$ID_RMC1,10,10,600,450,$$ColorChalk,$$RMC_CTRLSTYLEFLAT,$$FALSE,NULL,NULL,0,0)
	IF nRetVal < 0 THEN GOTO IsError

	'************** Add Region 1 *****************************
	nRetVal = RMC_ADDREGION($$ID_RMC1,5,5,-5,-5,&"Click with the right mousebutton into the grid!\\11c",$$FALSE)
	IF nRetVal < 0 THEN GOTO IsError

	'************** Add caption to region 1 *******************
	nRetVal = RMC_ADDCAPTION($$ID_RMC1,1,&"Simple line",$$ColorNavy,$$ColorWhite,10,1)
	IF nRetVal < 0 THEN GOTO IsError

	'************** Add grid to region 1 *****************************
	nRetVal = RMC_ADDGRID($$ID_RMC1,1,$$ColorBeige,1,0,0,0,0,0)
	IF nRetVal < 0 THEN GOTO IsError

	'************** Add data axis to region 1 *****************************
	nRetVal = RMC_ADDDATAAXIS($$ID_RMC1,1,$$RMC_DATAAXISLEFT,0,100,11,8,$$ColorBlack,$$ColorBlack,$$RMC_LINESTYLESOLID,0,NULL,NULL,NULL,0)
	IF nRetVal < 0 THEN GOTO IsError

	'************** Add label axis to region 1 *****************************
	labelaxis.nCount = 1
	labelaxis.nTickCount = 20
	labelaxis.nAlignment = $$RMC_LABELAXISBOTTOM
	labelaxis.nFontsize = 8
	labelaxis.nTextColor = $$ColorBlack
	labelaxis.nTextAlignment = $$RMC_TEXTCENTER
	labelaxis.nLineColor = $$ColorBlack
	labelaxis.nLineStyle = $$RMC_LINESTYLESOLID
	labelaxis.sText = ""

	nRetVal = RMC_ADDLABELAXISI ($$ID_RMC1, 1, NULL, &labelaxis)
	IF nRetVal < 0 THEN GOTO IsError

	'************** Add Series 1 to region 1 *******************************
	'****** Read data values ******
	DIM aData[19]
	aData[0] = 15 : aData[1] = 25 : aData[2] = 30 : aData[3] = 22 : aData[4] = 75
	aData[5] = 45 : aData[6] = 65 : aData[7] = 75 : aData[8] = 40 : aData[9] = 35
	aData[10] = 20 : aData[11] = 45 : aData[12] = 80 : aData[13] = 90 : aData[14] = 70
	aData[15] = 65 : aData[16] = 25 : aData[17] = 10 : aData[18] = 30 : aData[19] = 25

	tLineSeries.nType = $$RMC_LINE
	tLineSeries.nStyle = $$RMC_LINE_FLAT
	tLineSeries.nLineStyle = $$RMC_LSTYLE_LINE
	tLineSeries.nIsLucent = $$FALSE
	tLineSeries.nColor = $$ColorBlue
	tLineSeries.nSeriesSymbol = $$RMC_SYMBOL_BULLET
	tLineSeries.nWhichDataAxis = 1
	tLineSeries.nValueLabelOn = $$RMC_VLABEL_DEFAULT
	tLineSeries.nHatchMode = $$RMC_HATCHBRUSH_OFF

	nRetVal = RMC_ADDLINESERIESI ($$ID_RMC1, 1, &aData[], 20, 0, 0, &tLineSeries)
	IF nRetVal < 0 THEN GOTO IsError

	' Now add a trend line:

	' Calc the trend and get the needed X/Y positions (nL,nT,nR,nB) for the line
	nL = 0 : nT = 0 : nR = 0 : nB = 0
	nFirst = 0 : nLast = 0
	nRetVal = RMC_CALCTREND ($$ID_RMC1, 1, 1, &nFirst, &nLast, &nL, &nT, &nR, &nB, NULL)
	IF nRetVal < 0 THEN GOTO IsError

	IF nFirst > nLast THEN
		nColor = $$ColorRed
	ELSE
		nColor = $$ColorGreen
	END IF

	' Add a CustomLine to show the trend:
	nRetVal = RMC_CODASH ($$ID_RMC1,1,nL,nT,nR,nB,$$RMC_LINE_FLAT_DASH,nColor,0,2,0,$$RMC_ANCHOR_ARROW_CLOSED)

	' Draw the "legend" for the trend line:
	nRetVal = RMC_CODASH($$ID_RMC1,2,470,11,500,11,$$RMC_LINE_FLAT_DASH,nColor,0,2,0,0)
	IF nRetVal < 0 THEN GOTO IsError
	nRetVal = RMC_COTEXT($$ID_RMC1,3,&"Trend",505,5,0,0,0,0,0,0,0,0,NULL)
	IF nRetVal < 0 THEN GOTO IsError

	nRetVal = RMC_DRAW($$ID_RMC1)
	IF nRetVal < 0 THEN GOTO IsError
	RETURN

IsError:
	PRINT "Error "; nRetVal
	RETURN nRetVal

END FUNCTION

FUNCTION FromString (hWnd)

STRING sTemp

	sTemp = sTemp + "00003650|00004450|000051|000061|000071|00008-6697831|00009400|00011Tahoma|100011"
	sTemp = sTemp + "|1000310|1000410|10005-5|10006-5|1000910|100101|100111|100121|100131|100181|1002"
	sTemp = sTemp + "00|100217|1002215|100238|100272|100331|100341|100358|100378|100411|100482|100492"
	sTemp = sTemp + "|10051-6751336|10052-15132304|10053-983041|100541|100558|10056-16777077|10057-16"
	sTemp = sTemp + "777077|100586|10060-16777077|10061-1468806|100622|10180data source: www.federalr"
	sTemp = sTemp + "eserve.gov + www.ecb.int|10181Prime Rates in USA und Euroland|10183%|101871999*"
	sTemp = sTemp + "2000*2001*2002*2003*2004*2005*2006|110011|1100221|110035|1100434|110052|110063|1"
	sTemp = sTemp + "10073|1100970|1101312|110171|11019-16744448|1102115|110221|1102396|110262|110521"
	sTemp = sTemp + "2|110534.75*4.75*4.75*4.75*4.75*5*5*5.25*5.25*5.25*5.5*5.5*5.5*5.75*6*6*6.5*6.5*"
	sTemp = sTemp + "6.5*6.5*6.5*6.5*6.5*6.5*5.5*5.5*5*4.5*4*3.75*3.75*3.5*3*2.5*2*1.75*1.75*1.75*1.7"
	sTemp = sTemp + "5*1.75*1.75*1.75*1.75*1.75*1.75*1.75*1.25*1.25*1.25*1.25*1.25*1.25*1.25*1*1*1*1*"
	sTemp = sTemp + "1*1*1*1*1*1*1*1*1*1*1.25*1.5*1.75*2*2.25*2.25*2.5*2.75*2.75*3*3.25*3.25*3.5*3.75"
	sTemp = sTemp + "*3.75*4*4.25*4.5*4.5*4.75*4.75*5*5.25*5.25*5.25*5.25*5.25*5.25*5.25|120011|12002"
	sTemp = sTemp + "21|120035|1200434|120052|120063|120073|1200950|1201312|120171|12019-2448096|1202"
	sTemp = sTemp + "115|120221|1202396|120262|1205212|120533*3*3*2.5*2.5*2.5*2.5*2.5*2.5*2.5*3*3*3*3"
	sTemp = sTemp + ".25*3.5*3.75*3.75*4.25*4.25*4.5*4.5*4.75*4.75*4.75*4.75*4.75*4.75*4.75*4.5*4.5*4"
	sTemp = sTemp + ".5*4.25*3.75*3.75*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3."
	sTemp = sTemp + "25*2.75*2.75*2.75*2.5*2.5*2.5*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*"
	sTemp = sTemp + "2*2*2*2*2*2.25*2.25*2.25*2.5*2.5*2.5*2.75*2.75*3*3*3.25*3.25*3.5|010011|010054|0"
	sTemp = sTemp + "100721|01014-16744448|010222|01024216*287|01025109*109|010272|010283|010012|0100"
	sTemp = sTemp + "51|01010295|01011102|010191|01026USA (Federal Funds Rate)|010013|010054|0100721|"
	sTemp = sTemp + "01014-10496|010222|01024260*287|01025192*192|010272|010283|010014|010051|0101029"
	sTemp = sTemp + "5|01011185|010191|01026Euroland (Prime Rate)"


	nRetVal = RMC_CREATECHARTFROMFILE (hWnd,$$ID_RMC1,10,10,0,&sTemp)
	IF nRetVal < 0 THEN GOTO IsError

'	nRetVal = RMC_SETWATERMARK(&"XBLITE",$$RMC_USERWMCOLOR,$$RMC_USERWMLUCENT,$$RMC_USERWMALIGN,$$RMC_USERFONTSIZE)
	nRetVal = RMC_DRAW($$ID_RMC1)
	IF nRetVal < 0 THEN GOTO IsError
	RETURN

IsError:
	PRINT "Error "; nRetVal
	RETURN nRetVal

END FUNCTION

FUNCTION SaveChart (hWnd)

	DOUBLE aData[]
	tRMC_CHART tChart
	tRMC_REGION tRegion
	tRMC_LEGEND tLegend
	tRMC_GRIDLESSSERIES tGridlessSeries

	' This example uses the long notation style (with UDTs) and sets
	' only those properties, which shall differ from the defaults values.

	'************** Create the chart **********************
	tChart.nLeft        = 10
	tChart.nTop         = 10
	tChart.nWidth       = 600
	tChart.nHeight      = 450
	nRetVal = RMC_CREATECHARTI	(hWnd, $$ID_RMC1, &tChart)
	IF nRetVal < 0 THEN GOTO IsError

	'************** Add Region 1 *****************************
	nRetVal = RMC_ADDREGIONI($$ID_RMC1, &tRegion)
	IF nRetVal < 0 THEN GOTO IsError

	'************** Add legend to region 1 *******************************
	tLegend.nLegendAlign    = $$RMC_LEGEND_CUSTOM_UL
	sTemp$ = "Apples*Bananas*Pears*Cherries"
	nRetVal = RMC_ADDLEGENDI($$ID_RMC1, 1, &sTemp$, &tLegend)
	IF nRetVal < 0 THEN GOTO IsError

	'************** Add Series 1 to region 1 *******************************
	tGridlessSeries.nStyle        = $$RMC_PYRAMIDE3
	tGridlessSeries.nValueLabelOn = $$RMC_VLABEL_DEFAULT

	'****** Read data values ******
	DIM aData[3]
	aData[0] = 30.25 : aData[1] = 26.75 : aData[2] = 15.89 : aData[3] = 46.23
	nRetVal = RMC_ADDGRIDLESSSERIESI($$ID_RMC1,1, &aData[], 4,0,0, &tGridlessSeries)
	IF nRetVal < 0 THEN GOTO IsError

	nRetVal = RMC_SETWATERMARK(&"XBLITE",$$RMC_USERWMCOLOR,$$RMC_USERWMLUCENT,$$RMC_USERWMALIGN,$$RMC_USERFONTSIZE)
	nRetVal = RMC_DRAW2FILE($$ID_RMC1,&"Demo.png",0,0,0)
	IF nRetVal < 0 THEN GOTO IsError
	XstAlert("Chart was saved as 'demo.png'")
	RETURN

IsError:
	PRINT "Error "; nRetVal
	RETURN nRetVal

END FUNCTION

FUNCTION FromFile (hWnd)

	'************** Create the chart **********************
	nRetVal = RMC_CREATECHARTFROMFILE(hWnd,$$ID_RMC1,10,10,$$FALSE,&"4 regions.rmc")
	IF nRetVal < 0 THEN GOTO IsError

	nRetVal = RMC_SETWATERMARK(&"XBLITE",$$RMC_USERWMCOLOR,$$RMC_USERWMLUCENT,$$RMC_USERWMALIGN,$$RMC_USERFONTSIZE)
	nRetVal = RMC_DRAW($$ID_RMC1)
	IF nRetVal < 0 THEN GOTO IsError
	RETURN

IsError:
	PRINT "Error "; nRetVal
	RETURN nRetVal
END FUNCTION

FUNCTION XYTwoSeries(hWnd)

DOUBLE aData[]
DOUBLE aData2[]
tRMC_CHART tChart
tRMC_REGION tRegion
tRMC_CAPTION tCaption
tRMC_LEGEND tLegend
tRMC_GRID tGrid
tRMC_XYAXIS tXYAxis
tRMC_XYSERIES tXYSeries


   '************** Create the chart **********************
   tChart.nLeft        = 10
   tChart.nTop         = 10
   tChart.nWidth       = 600
   tChart.nHeight      = 450
   tChart.nBackColor   = $$ColorAliceBlue
   tChart.nCtrlStyle   = $$RMC_CTRLSTYLEFLATSHADOW
   tChart.sBgImage     = ""
   nRetVal = RMC_CREATECHARTI(hWnd, $$ID_RMC1, &tChart)
   IF nRetVal < 0 THEN GOTO IsError

   '************** Add Region 1 *****************************
   tRegion.nLeft       = 5
   tRegion.nTop        = 5
   tRegion.nWidth      = -5
   tRegion.nHeight     = -5
   tRegion.sFooter     = ""
   tRegion.nShowBorder = $$FALSE
   nRetVal = RMC_ADDREGIONI($$ID_RMC1, &tRegion)
   IF nRetVal < 0 THEN GOTO IsError

   '************** Add caption to region 1 *******************
   tCaption.sText  =     "Two XY series aligned to 2 different XY-axes pairs"
   tCaption.nBackColor = $$ColorBlue
   tCaption.nTextColor = $$ColorAntiqueWhite
   tCaption.nFontSize  = 10
   tCaption.nIsBold    = 1
   nRetVal = RMC_ADDCAPTIONI($$ID_RMC1, 1, &tCaption)
   IF nRetVal < 0 THEN GOTO IsError

   '************** Add grid to region 1 *****************************
   tGrid.nGridBackColor = $$ColorBeige
   tGrid.nAsGradient    = $$FALSE
   tGrid.nLeft      = 0
   tGrid.nTop       = 0
   tGrid.nWidth     = 0
   tGrid.nHeight    = 0
   nRetVal = RMC_ADDGRIDI($$ID_RMC1, 1, &tGrid)
   IF nRetVal < 0 THEN GOTO IsError

   '************** Add first X axis to region 1 *****************************
   tXYAxis.nAlignment        = $$RMC_XAXISBOTTOM
   tXYAxis.nMinValue         = 0
   tXYAxis.nMaxValue         = 100
   tXYAxis.nTickCount        = 11
   tXYAxis.nFontsize         = 8
   tXYAxis.nTextColor        = $$ColorBlue
   tXYAxis.nLineColor        = $$ColorBlue
   tXYAxis.nLineStyle        = $$RMC_LINESTYLEDOT
   tXYAxis.nDecimalDigits    = 0
   tXYAxis.sUnit             = ""
   tXYAxis.sText             = "First X axis"
   nRetVal = RMC_ADDXAXISI($$ID_RMC1, 1, &tXYAxis)
   IF nRetVal < 0 THEN GOTO IsError

   '************** Add first Y axis to region 1 *****************************
   tXYAxis.nAlignment        = $$RMC_YAXISLEFT
   tXYAxis.nMinValue         = 0
   tXYAxis.nMaxValue         = 100
   tXYAxis.nTickCount        = 11
   tXYAxis.nFontsize         = 8
   tXYAxis.nTextColor        = $$ColorBlue
   tXYAxis.nLineColor        = $$ColorBlue
   tXYAxis.nLineStyle        = $$RMC_LINESTYLEDOT
   tXYAxis.nDecimalDigits    = 0
   tXYAxis.sUnit             = ""
   tXYAxis.sText             = "First Y axis"
   nRetVal = RMC_ADDYAXISI($$ID_RMC1, 1, &tXYAxis)
   IF nRetVal < 0 THEN GOTO IsError

   '************** Add second X axis to region 1 *****************************
   tXYAxis.nAlignment        = $$RMC_XAXISTOP
   tXYAxis.nMinValue         = 0
   tXYAxis.nMaxValue         = 10
   tXYAxis.nTickCount        = 5
   tXYAxis.nFontsize         = 8
   tXYAxis.nTextColor        = $$ColorCoral
   tXYAxis.nLineColor        = $$ColorCoral
   tXYAxis.nLineStyle        = $$RMC_LINESTYLEDASH
   tXYAxis.nDecimalDigits    = 2
   tXYAxis.sUnit             = ""
   tXYAxis.sText             = "Second X axis"
   nRetVal = RMC_ADDXAXISI($$ID_RMC1, 1, &tXYAxis)
   IF nRetVal < 0 THEN GOTO IsError

   '************** Add second Y axis to region 1 *****************************
   tXYAxis.nAlignment        = $$RMC_YAXISRIGHT
   tXYAxis.nMinValue         = 0
   tXYAxis.nMaxValue         = 10
   tXYAxis.nTickCount        = 5
   tXYAxis.nFontsize         = 8
   tXYAxis.nTextColor        = $$ColorCoral
   tXYAxis.nLineColor        = $$ColorCoral
   tXYAxis.nLineStyle        = $$RMC_LINESTYLEDASH
   tXYAxis.nDecimalDigits    = 2
   tXYAxis.sUnit             = ""
   tXYAxis.sText             = "Second Y axis"
   nRetVal = RMC_ADDYAXISI($$ID_RMC1, 1, &tXYAxis)
   IF nRetVal < 0 THEN GOTO IsError

   '************** Add Series 1 to region 1 *******************************
   tXYSeries.nColor        = $$ColorDarkBlue
   tXYSeries.nStyle        = $$RMC_XY_SYMBOL
   tXYSeries.nLineStyle    = 0
   tXYSeries.nSeriesSymbol = $$RMC_SYMBOL_BULLET
   tXYSeries.nWhichXAxis   = $$RMC_XAXISBOTTOM
   tXYSeries.nWhichYAxis   = $$RMC_YAXISLEFT
   tXYSeries.nValueLabelOn = $$RMC_VLABEL_NONE

   '****** Read X-data values ******
   DIM aData[4]
   aData[0] = 20 : aData[1] = 30 : aData[2] = 60 : aData[3] = 70 : aData[4] = 90
   '****** Read Y-data values ******
   DIM aData2[4]
   aData2[0] = 40 : aData2[1] = 20 : aData2[2] = 70 : aData2[3] = 10 : aData2[4] = 60
   nRetVal = RMC_ADDXYSERIESI($$ID_RMC1, 1, &aData[], 5,&aData2[],5,&tXYSeries)
   IF nRetVal < 0 THEN GOTO IsError

   '************** Add Series 2 to region 1 *******************************
   tXYSeries.nColor        = $$ColorCoral
   tXYSeries.nStyle        = $$RMC_XY_SYMBOL
   tXYSeries.nLineStyle    = 0
   tXYSeries.nSeriesSymbol = $$RMC_SYMBOL_DIAMOND
   tXYSeries.nWhichXAxis   = $$RMC_XAXISTOP
   tXYSeries.nWhichYAxis   = $$RMC_YAXISRIGHT
   tXYSeries.nValueLabelOn = $$RMC_VLABEL_DEFAULT
   '****** Read X-data values ******
   DIM aData[4]
   aData[0] = 2.5 : aData[1] = 4.5 : aData[2] = 5.5 : aData[3] = 7.5 : aData[4] = 1
   '****** Read Y-data values ******
   DIM aData2[4]
   aData2[0] = 7.5 : aData2[1] = 5.5 : aData2[2] = 5.5 : aData2[3] = 2.5 : aData2[4] = 5
   nRetVal = RMC_ADDXYSERIESI($$ID_RMC1, 1, &aData[], 5,&aData2[],5,&tXYSeries)
   IF nRetVal < 0 THEN GOTO IsError

   nRetVal = RMC_DRAW($$ID_RMC1)
   IF nRetVal < 0 THEN GOTO IsError
   RETURN

IsError:
	PRINT "Error "; nRetVal
	RETURN nRetVal
END FUNCTION

' #########################
' #####  GroupedBars  #####
' #########################
'
'
'
FUNCTION GroupedBars (hWnd)

STRING sTemp
DOUBLE aData[]
tRMC_CHART tChart
tRMC_REGION tRegion
tRMC_CAPTION tCaption
tRMC_LEGEND tLegend
tRMC_GRID tGrid
tRMC_DATAAXIS tDataAxis
tRMC_LABELAXIS tLabelAxis
tRMC_BARSERIES tBarSeries


	' This example uses the alternative long notation style (with UDTs) and omits
	' no property: the code is bigger, but it's easier to change
	' the properties for testing purposes

	'************** Create the chart **********************
	tChart.nLeft        = 10
	tChart.nTop         = 10
	tChart.nWidth       = 600
	tChart.nHeight      = 450
	tChart.nBackColor   = $$ColorDefault
	tChart.nCtrlStyle   = $$RMC_CTRLSTYLEFLAT
	tChart.sFontName    = ""
	nRetVal = RMC_CREATECHARTI (hWnd, $$ID_RMC1, &tChart)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add Region 1 *****************************
	tRegion.nLeft       = 5
	tRegion.nTop        = 5
	tRegion.nWidth      = -5
	tRegion.nHeight     = -5
	tRegion.sFooter     = ""
	tRegion.nShowBorder = $$FALSE
	nRetVal = RMC_ADDREGIONI ($$ID_RMC1, &tRegion)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add grid to region 1 *****************************
	tGrid.nGridBackColor = $$ColorDefault
	tGrid.nAsGradient    = $$FALSE
	tGrid.nLeft      = 0
	tGrid.nTop       = 0
	tGrid.nWidth     = 0
	tGrid.nHeight    = 0
	nRetVal = RMC_ADDGRIDI ($$ID_RMC1, 1, &tGrid)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add data axis to region 1 *****************************
	tDataAxis.nAlignment      = $$RMC_DATAAXISLEFT
	tDataAxis.nMinValue       = 0
	tDataAxis.nMaxValue       = 100
	tDataAxis.nTickCount      = 11
	tDataAxis.nFontsize       = 8
	tDataAxis.nTextColor      = $$ColorDefault
	tDataAxis.nLineColor      = $$ColorDefault
	tDataAxis.nLineStyle      = $$RMC_LINESTYLESOLID
	tDataAxis.nDecimalDigits  = 0
	tDataAxis.sUnit           = ""
	tDataAxis.sText           = ""
	nRetVal = RMC_ADDDATAAXISI ($$ID_RMC1, 1, &tDataAxis)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add label axis to region 1 *****************************
	tLabelAxis.nCount         = 1
	tLabelAxis.nTickCount     = 5
	tLabelAxis.nAlignment     = $$RMC_LABELAXISBOTTOM
	tLabelAxis.nFontsize      = 8
	tLabelAxis.nTextColor     = $$ColorDefault
	tLabelAxis.nTextAlignment = $$RMC_TEXTCENTER
	tLabelAxis.nLineColor     = $$ColorDefault
	tLabelAxis.nLineStyle     = $$RMC_LINESTYLESOLID
	sTemp = "2008*2009*2010*2011*2012"
	nRetVal = RMC_ADDLABELAXISI ($$ID_RMC1, 1, &sTemp, &tLabelAxis)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add legend to region 1 *******************************
	tLegend.nLegendAlign    = $$RMC_LEGEND_TOP
	tLegend.nLegendBackColor= $$ColorDefault
	tLegend.nLegendStyle    = $$RMC_LEGENDRECT
	tLegend.nLegendTextColor= $$ColorDefault
	tLegend.nLegendFontSize = 8
	tLegend.nLegendIsBold   = $$FALSE
	sTemp = "First quarter*Second quarter*Third quarter*Fourth quarter"
	nRetVal = RMC_ADDLEGENDI ($$ID_RMC1, 1, &sTemp, &tLegend)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add Series 1 to region 1 *******************************
	tBarSeries.nType             = $$RMC_BARGROUP
	tBarSeries.nStyle            = $$RMC_BAR_HOVER
	tBarSeries.nIsLucent         = $$FALSE
	tBarSeries.nColor            = $$ColorDefault
	tBarSeries.nIsHorizontal     = $$FALSE
	tBarSeries.nWhichDataAxis    = 1
	tBarSeries.nValueLabelOn     = $$FALSE
	tBarSeries.nPointsPerColumn  = 1
	tBarSeries.nHatchMode        = $$RMC_HATCHBRUSH_OFF
	'****** Read data values ******
	DIM aData[4]
	aData[0] = 30 : aData[1] = 20 : aData[2] = 40 : aData[3] = 60 : aData[4] = 10
	nRetVal = RMC_ADDBARSERIESI ($$ID_RMC1, 1, &aData[], 5, &tBarSeries)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add Series 2 to region 1 *******************************
	tBarSeries.nType             = $$RMC_BARGROUP
	tBarSeries.nStyle            = $$RMC_BAR_HOVER
	tBarSeries.nIsLucent         = $$FALSE
	tBarSeries.nColor            = $$ColorDefault
	tBarSeries.nIsHorizontal     = $$FALSE
	tBarSeries.nWhichDataAxis    = 1
	tBarSeries.nValueLabelOn     = $$FALSE
	tBarSeries.nPointsPerColumn  = 1
	tBarSeries.nHatchMode        = $$RMC_HATCHBRUSH_OFF
	'****** Read data values ******
	DIM aData[4]
	aData[0] = 30 : aData[1] = 20 : aData[2] = 50 : aData[3] = 70 : aData[4] = 60
	nRetVal = RMC_ADDBARSERIESI ($$ID_RMC1, 1, &aData[], 5, &tBarSeries)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add Series 3 to region 1 *******************************
	tBarSeries.nType             = $$RMC_BARGROUP
	tBarSeries.nStyle            = $$RMC_BAR_HOVER
	tBarSeries.nIsLucent         = $$FALSE
	tBarSeries.nColor            = $$ColorDefault
	tBarSeries.nIsHorizontal     = $$FALSE
	tBarSeries.nWhichDataAxis    = 1
	tBarSeries.nValueLabelOn     = $$FALSE
	tBarSeries.nPointsPerColumn  = 1
	tBarSeries.nHatchMode        = $$RMC_HATCHBRUSH_OFF
	'****** Read data values ******
	DIM aData[4]
	aData[0] = 40 : aData[1] = 10 : aData[2] = 30 : aData[3] = 20 : aData[4] = 80
	nRetVal = RMC_ADDBARSERIESI ($$ID_RMC1, 1, &aData[], 5, &tBarSeries)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add Series 4 to region 1 *******************************
	tBarSeries.nType             = $$RMC_BARGROUP
	tBarSeries.nStyle            = $$RMC_BAR_HOVER
	tBarSeries.nIsLucent         = $$FALSE
	tBarSeries.nColor            = $$ColorDefault
	tBarSeries.nIsHorizontal     = $$FALSE
	tBarSeries.nWhichDataAxis    = 1
	tBarSeries.nValueLabelOn     = $$FALSE
	tBarSeries.nPointsPerColumn  = 1
	tBarSeries.nHatchMode        = $$RMC_HATCHBRUSH_OFF
	'****** Read data values ******
	DIM aData[4]
	aData[0] = 70 : aData[1] = 50 : aData[2] = 80 : aData[3] = 40 : aData[4] = 30
	nRetVal = RMC_ADDBARSERIESI ($$ID_RMC1, 1, &aData[], 5, &tBarSeries)
	IF nRetVal < 0 THEN GOTO IsError

	nRetVal = RMC_DRAW ($$ID_RMC1)      ' Draw the chart

	IF nRetVal < 0 THEN GOTO IsError
	RETURN

IsError:
	PRINT "Error "; nRetVal
	RETURN nRetVal

END FUNCTION
'
' #########################
' #####  StackedBars  #####
' #########################
'
'
'
FUNCTION StackedBars (hWnd)

STRING sTemp
DOUBLE aData[]
DOUBLE aData2[]

	nToolTipWidth = 100 ' We want to have ToolTips, so we must set the width. To avoid them, set it to zero

	'************** Create the chart **********************
	nRetVal = RMC_CREATECHART (hWnd,$$ID_RMC1,10,10,600,450,$$ColorBisque,$$RMC_CTRLSTYLE3DLIGHT,$$FALSE,0,0,nToolTipWidth,0)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add Region 1 *****************************
	nRetVal = RMC_ADDREGION ($$ID_RMC1,5,10,-5,-5,&"this is the footer",$$FALSE)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add caption to region 1 *******************
	nRetVal = RMC_ADDCAPTION ($$ID_RMC1,1,&"Example of stacked bars",$$ColorBisque,$$ColorBlack,11,$$TRUE)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add grid to region 1 *****************************
	nRetVal = RMC_ADDGRID ($$ID_RMC1,1,$$ColorCornsilk,$$FALSE,0,0,0,0,0)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add data axis to region 1 *****************************
	nRetVal = RMC_ADDDATAAXIS($$ID_RMC1,1,$$RMC_DATAAXISBOTTOM,0,50000,11,8,$$ColorBlack,$$ColorBlack,$$RMC_LINESTYLESOLID,0,&"$",&"This is an optional axis text",0,0)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add label axis to region 1 *****************************
	sTemp = "Label Nr. 1*Label Nr. 2*Label Nr. 3*Label Nr. 4*Label Nr. 5*Label Nr. 6"
	nRetVal = RMC_ADDLABELAXIS ($$ID_RMC1,1, &sTemp,1,6,$$RMC_LABELAXISLEFT,8,$$ColorBlack,$$RMC_TEXTCENTER,$$ColorBlack,$$RMC_LINESTYLESOLID,0)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add legend to region 1 *******************************
	sTemp = "Apples*Pears*Cherries*Strawberries"
	nRetVal = RMC_ADDLEGEND ($$ID_RMC1,1,&sTemp,$$RMC_LEGEND_CUSTOM_UR,$$ColorLightYellow,$$RMC_LEGENDRECT,$$ColorBlue,8,$$FALSE)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add Series 1 to region 1 *******************************
	'****** Read data values ******
	DIM aData[5]
	aData[0] = 10000 : aData[1] = 10000 : aData[2] = 16000 : aData[3] = 12000
	aData[4] = 20000 : aData[5] = 10000
	nRetVal = RMC_ADDBARSERIES ($$ID_RMC1,1,&aData[], 6,$$RMC_BARSTACKED,$$RMC_COLUMN_FLAT,$$FALSE,$$ColorDarkBlue,$$TRUE,1,$$RMC_VLABEL_NONE,1,$$RMC_HATCHBRUSH_OFF)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add Series 2 to region 1 *******************************
	'****** Read data values ******
	DIM aData[5]
	aData[0] = 5000 : aData[1] = 7000 : aData[2] = 4000 : aData[3] = 15000 : aData[4] = 10000
	aData[5] = 10000
	nRetVal = RMC_ADDBARSERIES($$ID_RMC1,1,&aData[], 6,$$RMC_BARSTACKED,$$RMC_COLUMN_FLAT,$$FALSE,$$ColorDarkGreen,$$TRUE,1,$$RMC_VLABEL_NONE,1,$$RMC_HATCHBRUSH_OFF)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add Series 3 to region 1 *******************************
	'****** Read data values ******
	DIM aData[5]
	aData[0] = 10000 : aData[1] = 3000 : aData[2] = 12000 : aData[3] = 10000
	aData[4] = 5000 : aData[5] = 20000
	nRetVal = RMC_ADDBARSERIES ($$ID_RMC1,1,&aData[], 6,$$RMC_BARSTACKED,$$RMC_COLUMN_FLAT,$$FALSE,$$ColorMaroon,$$TRUE,1,$$RMC_VLABEL_NONE,1,$$RMC_HATCHBRUSH_OFF)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add Series 4 to region 1 *******************************
	'****** Read data values ******
	DIM aData[5]
	aData[0] = 5000 : aData[1] = 9000 : aData[2] = 12000 : aData[3] = 6000 : aData[4] = 10000
	aData[5] = 5000
	nRetVal = RMC_ADDBARSERIES ($$ID_RMC1,1,&aData[], 6,$$RMC_BARSTACKED,$$RMC_COLUMN_FLAT,$$FALSE,$$ColorDarkGoldenrod,$$TRUE,1,$$RMC_VLABEL_NONE,1,$$RMC_HATCHBRUSH_OFF)
	IF nRetVal < 0 THEN GOTO IsError

	'   nRetVal = RMC_SetWatermark(RMC_USERWM,RMC_USERWMCOLOR,RMC_USERWMLUCENT,RMC_USERWMALIGN,RMC_USERFONTSIZE)
	nRetVal = RMC_DRAW ($$ID_RMC1)

	IF nRetVal < 0 THEN GOTO IsError
	RETURN

IsError:
	PRINT "Error "; nRetVal
	RETURN nRetVal

END FUNCTION
'
' ######################
' #####  BarsLine  #####
' ######################
'
'
'
FUNCTION BarsLine (hWnd)

STRING sTemp
DOUBLE aData[]
tRMC_CHART tChart
tRMC_REGION tRegion
tRMC_CAPTION tCaption
tRMC_LEGEND tLegend
tRMC_GRID tGrid
tRMC_DATAAXIS tDataAxis
tRMC_LABELAXIS tLabelAxis
tRMC_BARSERIES tBarSeries
tRMC_LINESERIES tLineSeries

	'************** Create the chart **********************
	tChart.nLeft        = 10
	tChart.nTop         = 10
	tChart.nWidth       = 670
	tChart.nHeight      = 450
	tChart.nBackColor   = $$ColorCornflowerBlue
	tChart.nCtrlStyle   = $$RMC_CTRLSTYLEFLATSHADOW
	tChart.sBgImage     = ""
	tChart.sFontName    = ""
	nRetVal = RMC_CREATECHARTI (hWnd, $$ID_RMC1, &tChart)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add Region 1 *****************************
	tRegion.nLeft       = 5
	tRegion.nTop        = 10
	tRegion.nWidth      = -5
	tRegion.nHeight     = -5
	tRegion.sFooter     = "data source: F.A.Z"
	tRegion.nShowBorder = $$FALSE
	nRetVal = RMC_ADDREGIONI ($$ID_RMC1, &tRegion)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add caption to region 1 *******************
	tCaption.sText  =     "The world's 10 biggest industrial companies 2003"
	tCaption.nBackColor = $$ColorCoral
	tCaption.nTextColor = $$ColorFloralWhite
	tCaption.nFontSize  = 12
	tCaption.nIsBold    = $$TRUE
	nRetVal = RMC_ADDCAPTIONI ($$ID_RMC1, 1, &tCaption)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add grid to region 1 *****************************
	tGrid.nGridBackColor = $$ColorAzure
	tGrid.nAsGradient    = $$TRUE
	tGrid.nLeft      = 0
	tGrid.nTop       = 0
	tGrid.nWidth     = 0
	tGrid.nHeight    = 0
	nRetVal = RMC_ADDGRIDI ($$ID_RMC1, 1, &tGrid)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add data axis to region 1 *****************************
	tDataAxis.nAlignment      = $$RMC_DATAAXISLEFT
	tDataAxis.nMinValue       = 100000
	tDataAxis.nMaxValue       = 250000
	tDataAxis.nTickCount      = 11
	tDataAxis.nFontsize       = 9
	tDataAxis.nTextColor      = $$ColorCornsilk
	tDataAxis.nLineColor      = $$ColorBlack
	tDataAxis.nLineStyle      = $$RMC_LINESTYLESOLID
	tDataAxis.nDecimalDigits  = 0
	tDataAxis.sUnit           = "$"
	tDataAxis.sText           = "Total turnover in Mill. Dollar"
	nRetVal = RMC_ADDDATAAXISI ($$ID_RMC1, 1, &tDataAxis)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add second data axis to region 1 *****************************
	tDataAxis.nAlignment      = $$RMC_DATAAXISRIGHT
	tDataAxis.nMinValue       = 0
	tDataAxis.nMaxValue       = 0
	tDataAxis.nDecimalDigits  = 2
	tDataAxis.sUnit           = "%"
	tDataAxis.sText           = "Net operating margin"
	nRetVal = RMC_ADDDATAAXISI ($$ID_RMC1, 1, &tDataAxis)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add label axis to region 1 *****************************
	tLabelAxis.nCount         = 1
	tLabelAxis.nTickCount     = 10
	tLabelAxis.nAlignment     = $$RMC_LABELAXISBOTTOM
	tLabelAxis.nFontsize      = 8
	tLabelAxis.nTextColor     = $$ColorCornsilk
	tLabelAxis.nTextAlignment = $$RMC_TEXTCENTER
	tLabelAxis.nLineColor     = $$ColorBlack
	tLabelAxis.nLineStyle     = $$RMC_LINESTYLESOLID
	tLabelAxis.sText          = ""
	sTemp = "Exxon Mobil*Royal Dutch / Shell*BP*General Motors*Daimler Chrysler*Ford Motor*Toyota Motor*General E"
	sTemp = sTemp + "lectric*TOTAL*Chevron Texaco"
	nRetVal = RMC_ADDLABELAXISI ($$ID_RMC1, 1, &sTemp, &tLabelAxis)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add Series 1 to region 1 *******************************
	tBarSeries.nType             = $$RMC_BARSINGLE
	tBarSeries.nStyle            = $$RMC_BAR_FLAT_GRADIENT2
	tBarSeries.nIsLucent         = $$FALSE
	tBarSeries.nColor            = $$ColorGold
	tBarSeries.nIsHorizontal     = $$FALSE
	tBarSeries.nWhichDataAxis    = 1
	tBarSeries.nValueLabelOn     = $$RMC_VLABEL_NONE
	tBarSeries.nPointsPerColumn  = 1
	tBarSeries.nHatchMode        = $$RMC_HATCHBRUSH_OFF
	'****** Read data values ******
	DIM aData[9]
	aData[0] = 242365 : aData[1] = 235598 : aData[2] = 232571 : aData[3] = 185524
	aData[4] = 170457 : aData[5] = 164196 : aData[6] = 149321 : aData[7] = 132797
	aData[8] = 130067 : aData[9] = 119703
	nRetVal = RMC_ADDBARSERIESI ($$ID_RMC1, 1, &aData[], 10, &tBarSeries)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add Series 2 to region 1 *******************************
	tLineSeries.nType             = $$RMC_LINE
	tLineSeries.nStyle            = $$RMC_LINE_CABLE
	tLineSeries.nLineStyle        = $$RMC_LSTYLE_LINE
	tLineSeries.nIsLucent         = $$FALSE
	tLineSeries.nColor            = $$ColorGreen
	tLineSeries.nSeriesSymbol     = $$RMC_SYMBOL_BULLET
	tLineSeries.nWhichDataAxis    = 2
	tLineSeries.nValueLabelOn     = $$RMC_VLABEL_DEFAULT
	tLineSeries.nHatchMode        = $$RMC_HATCHBRUSH_OFF
	'****** Read data values ******
	DIM aData[9]
	aData[0] = 8.9 : aData[1] = 4.1 : aData[2] = 4.4 : aData[3] = 2.1 : aData[4] = .3
	aData[5] = .3 : aData[6] = 5.9 : aData[7] = 11.3 : aData[8] = 6.7 : aData[9] = 6
	nRetVal = RMC_ADDLINESERIESI ($$ID_RMC1, 1, &aData[], 10,0,0, &tLineSeries)
	IF nRetVal < 0 THEN GOTO IsError

'	nRetVal = RMC_SetWatermark(&$$RMC_USERWM,$$RMC_USERWMCOLOR,$$RMC_USERWMLUCENT,$$RMC_USERWMALIGN,$$RMC_USERFONTSIZE)
	nRetVal = RMC_DRAW ($$ID_RMC1)

	IF nRetVal < 0 THEN GOTO IsError
	RETURN

IsError:
	PRINT "Error "; nRetVal
	RETURN nRetVal

END FUNCTION
'
' ##########################
' #####  FloatingBars  #####
' ##########################
'
'
'
FUNCTION FloatingBars (hWnd)

STRING sTemp
DOUBLE aData[]

	'************** Create the chart **********************
	nRetVal = RMC_CREATECHART (hWnd,$$ID_RMC1,10,10,550,300,$$ColorLightGray,$$RMC_CTRLSTYLE3DLIGHT,$$FALSE,0,&"Tahoma",0,0)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add Region 1 *****************************
	nRetVal = RMC_ADDREGION ($$ID_RMC1,5,5,-5,-5,NULL,$$FALSE)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add caption to region 1 *******************
	nRetVal = RMC_ADDCAPTION ($$ID_RMC1,1,&"Birth of a Killer App",$$ColorDefault,$$ColorBlack,11,$$TRUE)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add grid to region 1 *****************************
	nRetVal = RMC_ADDGRID ($$ID_RMC1,1,$$ColorPaleGoldenrod,$$TRUE,0,0,0,0,$$RMC_BICOLOR_NONE)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add data axis to region 1 *****************************
	sTemp = "04/01*04/02*04/03*04/04*04/05*04/06*04/07*04/08*04/09*04/10*04/11*04/12*05/01"
	nRetVal = RMC_ADDDATAAXIS ($$ID_RMC1,1,$$RMC_DATAAXISBOTTOM,1,13,13,8,$$ColorBlack,$$ColorBlack,$$RMC_LINESTYLESOLID,0,NULL,NULL,&sTemp,$$RMC_TEXTCENTER)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add label axis to region 1 *****************************
	sTemp = "Design*Development*Testing*Bug Fixing*Documentation*Marketing"
	nRetVal = RMC_ADDLABELAXIS ($$ID_RMC1,1, &sTemp,1,6,$$RMC_LABELAXISLEFT,8,$$ColorBlack,$$RMC_TEXTCENTER,$$ColorBlack,$$RMC_LINESTYLESOLID,NULL)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add legend to region 1 *******************************
	sTemp = "Schedule*Reality"
	nRetVal = RMC_ADDLEGEND ($$ID_RMC1,1,&sTemp,$$RMC_LEGEND_CUSTOM_UR,$$ColorLightBlue,$$RMC_LEGENDRECT,$$ColorMediumBlue,8,$$FALSE)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add Series 1 to region 1 *******************************
	'****** Read data values ******
	DIM aData[11]
	aData[0] = 1 : aData[1] = 3 : aData[2] = 4 : aData[3] = 6 : aData[4] = 6
	aData[5] = 4 : aData[6] = 7 : aData[7] = 4 : aData[8] = 9 : aData[9] = 3
	aData[10] = 10 : aData[11] = 3
	nRetVal = RMC_ADDBARSERIES ($$ID_RMC1,1,&aData[], 12,$$RMC_FLOATINGBARGROUP,$$RMC_BAR_HOVER,$$FALSE,$$ColorPaleGreen,$$TRUE,1,$$RMC_VLABEL_NONE,1,$$RMC_HATCHBRUSH_OFF)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add Series 2 to region 1 *******************************
	'****** Read data values ******
	DIM aData[11]
	aData[0] = 1 : aData[1] = .5 : aData[2] = 1.5 : aData[3] = 10.5 : aData[4] = 12
	aData[5] = 1 : aData[6] = 12 : aData[7] = 1 : aData[8] = 12.5 : aData[9] = .5
	aData[10] = 2 : aData[11] = 11
	nRetVal = RMC_ADDBARSERIES ($$ID_RMC1,1,&aData[], 12,$$RMC_FLOATINGBARGROUP,$$RMC_BAR_HOVER,$$FALSE,$$ColorOrangeRed,$$TRUE,1,$$RMC_VLABEL_NONE,2,$$RMC_HATCHBRUSH_OFF)
	IF nRetVal < 0 THEN GOTO IsError

'	nRetVal = RMC_SETWATERMARK (&$$RMC_USERWM,$$RMC_USERWMCOLOR,$$RMC_USERWMLUCENT,$$RMC_USERWMALIGN,$$RMC_USERFONTSIZE)
	nRetVal = RMC_DRAW ($$ID_RMC1)

	IF nRetVal < 0 THEN GOTO IsError
	RETURN

IsError:
	PRINT "Error "; nRetVal
	RETURN nRetVal
END FUNCTION
'
' #######################
' #####  ColorBars  #####
' #######################
'
'
'
FUNCTION ColorBars (hWnd)

STRING sTemp
DOUBLE aData[]
tRMC_CHART tChart
tRMC_REGION tRegion
tRMC_CAPTION tCaption
tRMC_GRID tGrid
tRMC_DATAAXIS tDataAxis
tRMC_LABELAXIS tLabelAxis
tRMC_BARSERIES tBarSeries

	'************** Create the chart **********************
	tChart.nLeft        = 10
	tChart.nTop         = 10
	tChart.nWidth       = 600
	tChart.nHeight      = 450
	tChart.nBackColor   = $$ColorTransparent
	tChart.nCtrlStyle   = $$RMC_CTRLSTYLEIMAGE
	tChart.sBgImage     = "seasky.jpg"
	tChart.sFontName    = ""
	tChart.nToolTipWidth = 100  ' We want to have ToolTips, so we must set the width
	nRetVal = RMC_CREATECHARTI (hWnd, $$ID_RMC1, &tChart)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add Region 1 *****************************
	tRegion.nLeft       = 5
	tRegion.nTop        = 5
	tRegion.nWidth      = -5
	tRegion.nHeight     = -5
	tRegion.sFooter     = ""
	tRegion.nShowBorder = $$FALSE
	nRetVal = RMC_ADDREGIONI ($$ID_RMC1, &tRegion)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add grid to region 1 *****************************
	tGrid.nGridBackColor = $$ColorTransparent
	tGrid.nAsGradient    = $$FALSE
	tGrid.nLeft      = 0
	tGrid.nTop       = 0
	tGrid.nWidth     = 0
	tGrid.nHeight    = 0
	nRetVal = RMC_ADDGRIDI ($$ID_RMC1, 1, &tGrid)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add data axis to region 1 *****************************
	tDataAxis.nAlignment      = $$RMC_DATAAXISLEFT
	tDataAxis.nMinValue       = 0
	tDataAxis.nMaxValue       = 100
	tDataAxis.nTickCount      = 11
	tDataAxis.nFontsize       = 8
	tDataAxis.nTextColor      = $$ColorChalk
	tDataAxis.nLineColor      = $$ColorChalk
	tDataAxis.nLineStyle      = $$RMC_LINESTYLEDOT
	tDataAxis.nDecimalDigits  = 0
	tDataAxis.sUnit           = ""
	tDataAxis.sText           = ""
	nRetVal = RMC_ADDDATAAXISI($$ID_RMC1, 1, &tDataAxis)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add label axis to region 1 *****************************
	tLabelAxis.nCount         = 1
	tLabelAxis.nTickCount     = 5
	tLabelAxis.nAlignment     = $$RMC_LABELAXISBOTTOM
	tLabelAxis.nFontsize      = 8
	tLabelAxis.nTextColor     = $$ColorYellow
	tLabelAxis.nTextAlignment = $$RMC_TEXTCENTER
	tLabelAxis.nLineColor     = $$ColorChalk
	tLabelAxis.nLineStyle     = $$RMC_LINESTYLENONE
	tLabelAxis.sText          = ""
	sTemp = "Label 1*Label 2*Label 3*Label 4*Label 5"
	nRetVal = RMC_ADDLABELAXISI ($$ID_RMC1, 1, &sTemp, &tLabelAxis)
	IF nRetVal < 0 THEN GOTO IsError
	'************** Add Series 1 to region 1 *******************************
	tBarSeries.nType             = $$RMC_BARSINGLE
	tBarSeries.nStyle            = $$RMC_BAR_FLAT_GRADIENT2
	tBarSeries.nIsLucent         = $$TRUE
	tBarSeries.nColor            = $$ColorTransparent
	tBarSeries.nIsHorizontal     = $$FALSE
	tBarSeries.nWhichDataAxis    = 1
	tBarSeries.nValueLabelOn     = $$RMC_VLABEL_NONE
	tBarSeries.nPointsPerColumn  = 1
	tBarSeries.nHatchMode        = $$RMC_HATCHBRUSH_OFF
	'****** Read data values ******
	DIM aData[4]
	aData[0] = 50 : aData[1] = 70 : aData[2] = 40 : aData[3] = 60 : aData[4] = 30
	nRetVal = RMC_ADDBARSERIESI ($$ID_RMC1, 1, &aData[], 5, &tBarSeries)
	IF nRetVal < 0 THEN GOTO IsError

	' Let's set some CustomToolTipTexts:
	tt$ = "First Bar"+CHR$(13)+CHR$(10)+"Value: 50"+CHR$(13)+CHR$(10)+"Color: Blue"
	nRetVal = RMC_SETCUSTOMTOOLTIPTEXT($$ID_RMC1,1,1,1,&tt$)
	tt$ = "Second Bar"+CHR$(13)+CHR$(10)+"Value: 70"+CHR$(13)+CHR$(10)+"Color: Green"
	nRetVal = RMC_SETCUSTOMTOOLTIPTEXT($$ID_RMC1,1,1,2,&tt$)
	tt$ = "Third Bar"+CHR$(13)+CHR$(10)+"Value: 40"+CHR$(13)+CHR$(10)+"Color: Red"
	nRetVal = RMC_SETCUSTOMTOOLTIPTEXT($$ID_RMC1,1,1,3,&tt$)
	tt$ = "Fourth Bar"+CHR$(13)+CHR$(10)+"Value: 60"+CHR$(13)+CHR$(10)+"Color: Yellow"
	nRetVal = RMC_SETCUSTOMTOOLTIPTEXT($$ID_RMC1,1,1,4,&tt$)
	' Last bar gets no CustomText, so the default ToolTipText (=Value) is used

	nRetVal = RMC_SETWATERMARK (&$$RMC_USERWM, $$RMC_USERWMCOLOR, $$RMC_USERWMLUCENT, $$RMC_USERWMALIGN, $$RMC_USERFONTSIZE)
	nRetVal = RMC_DRAW ($$ID_RMC1)

	IF nRetVal < 0 THEN GOTO IsError
	RETURN

IsError:
	PRINT "Error "; nRetVal
	RETURN nRetVal

END FUNCTION

FUNCTION ScrollChart (hWnd)
	SCROLLINFO sih

'	ShowScrollBar (hWnd, $$SB_VERT, $$TRUE)

	sih.cbSize = SIZE(sih)
	sih.fMask = $$SIF_RANGE || $$SIF_PAGE
	sih.nMin = 1
	sih.nMax = 1256           ' 1256 days total
	sih.nPage = 21            ' 21 days shall be painted
	SetScrollInfo (hWnd, $$SB_VERT, &sih, $$TRUE)
	' Call the Sub which builds the chart, but does not add data and does not show it

	nError = Build_ScrollChart(hWnd)
	IF nError < 0 THEN GOTO IsError

	' IF nError THEN MSGBOX "RMChart Demo","Error " + STR$(nError), MB_OK BOR MB_ICONERROR
	' Set the initial data for the first series (Bars):
	RMC_SETSERIESDATAFILE ($$ID_RMC1,1,1, &"dowdaily.csv",&"1256,1236",&"3",&",",0)
	' Set the initial data for the second series (Line):
	RMC_SETSERIESDATAFILE ($$ID_RMC1,1,2, &"dowdaily.csv",&"1256,1236",&"2",&",",0)
	RMC_DRAW ($$ID_RMC1)   ' Draw the chart for the first time


IsError:
	PRINT "Error ScrollChart: "; nRetVal
	RETURN nRetVal
END FUNCTION 
	
FUNCTION Build_ScrollChart (hWnd)

SHARED aPPC[] 
tRMC_CHART tChart
tRMC_REGION tRegion
tRMC_CAPTION tCaption
tRMC_LEGEND tLegend
tRMC_GRID tGrid
tRMC_DATAAXIS tDataAxis
tRMC_LABELAXIS tLabelAxis
tRMC_BARSERIES tBarSeries
tRMC_LINESERIES tLineSeries

DIM aPPC[0]

   ' This example shows, how you can change the data of a chart 'on the fly' without
   ' the necessarity of a complete rebuild of the chart.
   ' This function is only called once, from BEGIN EVENTS, before setting
   ' the initial data for the chart.
   ' The call to RMC_Draw for showing the chart also happens in BEGIN EVENTS,
   ' behind 'CASE ID_MSC1', after setting the first data set for the chart.
   ' When you scroll the chart, the chart gets refreshed with new data also
   ' in the Callback, behind 'CASE WM_VSCROLL'


   '************** Create the chart **********************
   tChart.nLeft        = 10
   tChart.nTop         = 10
   tChart.nWidth       = 650
   tChart.nHeight      = 500
   tChart.nBackColor   = $$ColorDarkTurquoise
   tChart.nCtrlStyle   = $$RMC_CTRLSTYLEFLAT
   nRetVal = RMC_CREATECHARTI (hWnd, $$ID_RMC1, &tChart)

   '************** Add Region 1 *****************************
   tRegion.nLeft       = 5
   tRegion.nTop        = 5
   tRegion.nWidth      = -5
   tRegion.nHeight     = -5
   tRegion.sFooter     = "data source: www.yahoo.com"
   tRegion.nShowBorder = $$FALSE
   nRetVal = RMC_ADDREGIONI($$ID_RMC1, &tRegion)
   '************** Add caption to region 1 *******************
   tCaption.sText  =     "Dow Jones 2000 - 2005"
   tCaption.nBackColor = $$ColorDefault
   tCaption.nTextColor = $$ColorDefault
   tCaption.nFontSize  = 13
   tCaption.nIsBold    = $$TRUE
   nRetVal = RMC_ADDCAPTIONI($$ID_RMC1, 1, &tCaption)
   '************** Add grid to region 1 *****************************
   tGrid.nGridBackColor = $$ColorLightSkyBlue
   tGrid.nAsGradient    = $$TRUE
   tGrid.nLeft      = 0
   tGrid.nTop       = 0
   tGrid.nWidth     = 0
   tGrid.nHeight    = 0
   nRetVal = RMC_ADDGRIDI($$ID_RMC1, 1, &tGrid)
   '************** Add data axis to region 1 *****************************
   tDataAxis.nAlignment      = $$RMC_DATAAXISBOTTOM
   tDataAxis.nMinValue       = 7000
   tDataAxis.nMaxValue       = 12000
   tDataAxis.nTickCount      = 11
   tDataAxis.nFontsize       = 8
   tDataAxis.nTextColor      = $$ColorDefault
   tDataAxis.nLineColor      = $$ColorDefault
   tDataAxis.nLineStyle      = $$RMC_LINESTYLESOLID
   tDataAxis.nDecimalDigits  = 0
   tDataAxis.sUnit           = ""
   tDataAxis.sText           = "Closing Index (Line series)\11"
   nRetVal = RMC_ADDDATAAXISI($$ID_RMC1, 1, &tDataAxis)
   '************** Add second data axis to region 1 *****************************
   tDataAxis.nAlignment      = $$RMC_DATAAXISTOP
   tDataAxis.nMinValue       = 0
   tDataAxis.nMaxValue       = 30000000
   tDataAxis.nDecimalDigits  = 0
   tDataAxis.sUnit           = ""
   tDataAxis.sText           = "Share volumes (Bar series)\11"
   nRetVal = RMC_ADDDATAAXISI($$ID_RMC1, 1, &tDataAxis)
   '************** Add label axis to region 1 *****************************
   tLabelAxis.nCount         = 1
   tLabelAxis.nTickCount     = 21
   tLabelAxis.nAlignment     = $$RMC_LABELAXISLEFT
   tLabelAxis.nFontsize      = 8
   tLabelAxis.nTextColor     = $$ColorDefault
   tLabelAxis.nTextAlignment = $$RMC_TEXTCENTER
   tLabelAxis.nLineColor     = $$ColorDefault
   tLabelAxis.nLineStyle     = $$RMC_LINESTYLESOLID
   nRetVal = RMC_ADDLABELAXISI($$ID_RMC1, 1, &"", &tLabelAxis)
   '************** Add Series 1 to region 1 *******************************
   tBarSeries.nType             = $$RMC_BARSINGLE
   tBarSeries.nStyle            = $$RMC_BAR_HOVER
   tBarSeries.nIsLucent         = $$FALSE
   tBarSeries.nColor            = $$ColorLightGoldenrod
   tBarSeries.nIsHorizontal     = $$TRUE
   tBarSeries.nWhichDataAxis    = 2
   tBarSeries.nValueLabelOn     = $$FALSE
   tBarSeries.nPointsPerColumn  = 1
   tBarSeries.nHatchMode        = $$RMC_HATCHBRUSH_OFF
   nRetVal = RMC_ADDBARSERIESI($$ID_RMC1, 1, 0,0, &tBarSeries)
   ' Data will be added later in the Callback, so we pass zero for the data and datacount
   '************** Add Series 2 to region 1 *******************************
   tLineSeries.nType             = $$RMC_LINE
   tLineSeries.nStyle            = $$RMC_LINE_FLAT
   tLineSeries.nLineStyle        = $$RMC_LSTYLE_LINE
   tLineSeries.nIsLucent         = $$FALSE
   tLineSeries.nColor            = $$ColorRed
   tLineSeries.nSeriesSymbol     = $$RMC_SYMBOL_POINT
   tLineSeries.nWhichDataAxis    = 1
   tLineSeries.nValueLabelOn     = $$FALSE
   tLineSeries.nHatchMode        = $$RMC_HATCHBRUSH_OFF
   nRetVal = RMC_ADDLINESERIESI($$ID_RMC1, 1, 0,0,0,0, &tLineSeries)
   ' Data will be added later in the Callback, so we pass zero for data and datacount
	RETURN nRetVal
END FUNCTION

END FUNCTION


'
'
' ###################################
' #####  ShowSaveFileDialog ()  #####
' ###################################
'
FUNCTION  ShowSaveFileDialog (hWndOwner, @fileName$, filter$, initDir$, title$)

	OPENFILENAME ofn
	SHARED hInst

	ofn.lStructSize = LEN(ofn)			'set length of struct
	ofn.hwndOwner 	= hWndOwner			'set parent window handle
	ofn.hInstance 	= hInst					'set the application's instance

'select a filter
'pstrFilter points to a buffer containing pairs of null-terminated
'filter strings. The first string in each pair describes a filter
'(for example, "Text Files"), and the second specifies the
'filter pattern (for example, "*.TXT"). Multiple filters can be
'specified for a single item by separating the filter pattern strings
'with a semicolon (for example, "*.TXT;*.DOC;*.BAK"). The last string
'in the buffer must be terminated by two NULL characters. If this member
'is NULL, the dialog box will not display any filters.
'The filter strings are assumed to be in the proper order - the
'operating system does not change the order.

'	filter$ = "XB Files (*.x, *.dec)" + CHR$(0) + "*.x;*.dec" + CHR$(0) + "Text Files (*.txt)" + CHR$(0) + "*.txt" + CHR$(0) + "All Files (*.*)" + CHR$(0) + "*.*" + CHR$(0) + CHR$(0)
	ofn.lpstrFilter = &filter$

'create a buffer for the returned file
	IF fileName$ = "" THEN
		fileName$ = SPACE$(254)
	ELSE
		fileName$ = fileName$ + SPACE$(254 - LEN(fileName$))
	END IF
	ofn.lpstrFile 			= &fileName$

	ofn.nMaxFile 				= 255					'set the maximum length of a returned file
	buffer2$ = SPACE$(254)
	ofn.lpstrFileTitle 	= &buffer2$		'Create a buffer for the file title
	ofn.nMaxFileTitle 	= 255					'Set the maximum length of a returned file title
	ofn.lpstrInitialDir = &initDir$		'Set the initial directory
  ofn.lpstrTitle 			= &title$			'Set the title
  ofn.flags = $$OFN_PATHMUSTEXIST OR $$OFN_EXPLORER	'flags

'call dialog
	IFZ GetSaveFileNameA (&ofn) THEN
		fileName$ = ""
		RETURN 0
	ELSE
		fileName$ = CSTRING$(ofn.lpstrFile)
		RETURN $$TRUE
	END IF

END FUNCTION
'
' ############################
' #####  ExportTheChart  #####
' ############################
'
'
'
FUNCTION ExportTheChart (hWnd, nCtrlID)

	filter$ = "Graphic Files (*.jpg *.png)\0*.png;*.jpg;\0ALL Files (*.*)\0*.*\0\0"

	ShowSaveFileDialog (hWnd, @fileName$, filter$, "", "Save Chart as Graphic File")

	IF fileName$ THEN
		IFZ INCHR (fileName$, ".") THEN fileName$ = fileName$ + ".png"
		RMC_DRAW2FILE (nCtrlID, &fileName$ ,0,0,0)
	END IF

END FUNCTION
'
' ###########################
' #####  PrintTheChart  #####
' ###########################
'
'
'
FUNCTION PrintTheChart (hWnd, nCtrlID)

	PrinterDialog (hWnd, @hDC)
	IF hDC THEN
		RMC_DRAW2PRINTER(nCtrlID, hDC,0,0,0,0,0)
	END IF

END FUNCTION

FUNCTION PrinterDialog (hWnd, @hDC)
	PRINTDLG pd

	pd.lStructSize = SIZE(pd)
	pd.hDevMode    = hDevMode
	pd.hDevNames   = hDevNames
	pd.hwndOwner   = hWnd
	pd.flags       = $$PD_SHOWHELP | $$PD_RETURNDC
	pd.nCopies     = 1
	pd.nFromPage   = 1
	pd.nToPage     = 1
	pd.nMinPage    = 1
	pd.nMaxPage    = 1
	ret = PrintDlgA (&pd)
	IF ret THEN hDC = pd.hdc

END FUNCTION

END PROGRAM
